Tue Dec 24 17:29:58 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* stable version 1.6.8 released.

Mon Dec 23 23:49:36 2002  Akinori MUSHA  <knu@iDaemons.org>

	* lib/tempfile.rb: Embed Rdoc style comments.

	* lib/tempfile.rb: Add length as an alias for size.

	* lib/tempfile.rb: Add Tempfile#close!() as a shorthand for
	  Tempfile#close(true).

	* lib/tempfile.rb: Add Tempfile#{unlink,delete}().

Sun Dec 22 00:36:43 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* lib/mkmf.rb (create_makefile): accept pure ruby libraries.

Fri Dec 20 19:35:37 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/extmk.rb.in: get rid of --no-undefined option in $DLDFLAGS.

Wed Dec 18 17:53:05 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* class.c (rb_include_module): argument should be T_MODULE, not
	  T_class, nor T_ICLASS.

Mon Dec 16 15:53:20 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* parse.y (nextc): get rid of overrun.  (pointed out by akr
	  [ruby-list:36773])

	* eval.c (rb_eval): untangled ruby_dyna_vars.  [ruby-talk:59035]

Mon Dec 16 08:03:47 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* dir.c (dir_set_pos): Dir#pos= should return the new position.

Sat Dec 14 02:03:51 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/dbm/extconf.rb (db_check): support for GNU dbm 1.8.3.
	  backported from 1.7.

Fri Dec 13 23:39:09 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/dbm/extconf.rb: backported from 1.7.

	* ext/dbm/dbm.c: ditto.

Fri Dec 13 17:15:49 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* variable.c (generic_ivar_get): should always warn for
	  uninitialized instance variables.

Thu Dec 12 16:26:31 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* marshal.c (r_object0): singleton class instance can't be loaded.
	  (ruby-bugs-ja:PR#366)

Thu Dec 12 03:05:16 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* sprintf.c (rb_f_sprintf): 1.7 sprintf() backported.

Wed Dec 11 23:35:43 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/extmk.rb.in (create_makefile): -no-undefined -> --no-undefined.

Wed Dec 11 20:48:03 2002  Akinori MUSHA  <knu@iDaemons.org>

	* lib/getoptlong.rb (GetoptLong::Error): provide a common ancestor
	  for GetoptLong error classes (RCR#129).

Fri Dec  6 14:13:59 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* numeric.c (num_cmp): define Numeric#<=>, remove Numeric#==.

Tue Dec  3 01:48:06 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (backtrace): should ignore line 0 frame.

Sun Dec  1 22:43:29 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* win32/win32.c (win32_stat): empty path is invalid, and return
	  ENOENT rather than EBADF in such case.  [ruby-talk:57177]

Wed Nov 27 17:42:56 2002  Akinori MUSHA  <knu@iDaemons.org>

	* ext/syslog/syslog.c: Cut redundancy.

	* ext/syslog/syslog.c: Do not leak ident.

	* ext/syslog/syslog.c, ext/syslog/test.rb: Syslog.close should
	  raise RuntimeError when not opened.

	* ext/syslog/syslog.c, ext/syslog/test.rb:
	  Syslog.{ident,options,facility,mask} should all return nil when
	  not opened.

	* ext/syslog/syslog.c, ext/syslog/test.rb: Change back the output
	  format of inspect().

Wed Nov 27 16:27:59 2002  Akinori MUSHA  <knu@iDaemons.org>

	* ext/digest/test.rb: Switch from RUnit to Test::Unit.

Wed Nov 27 16:22:09 2002  Akinori MUSHA  <knu@iDaemons.org>

	* ext/syslog/syslog.c: Fix a problem where Syslog#ident was not
	  marked and could thus be GC'd.

	* ext/syslog/test.rb: Switch from RUnit to Test::Unit.

	* ext/syslog/test.rb: The output format of inspect() is slightly
	  altered.

Fri Nov 22 19:30:17 2002  Akinori MUSHA  <knu@iDaemons.org>

	* instruby.rb: Install batch files on Windows. [Submitted by usa]

Fri Nov 22 22:55:01 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* sprintf.c (rb_f_sprintf): preceding ".." for negative
	  hexadecimal numbers should not appear if prec (e.g. %.4) is
	  specified.

Thu Nov 21 20:56:35 2002  Minero Aoki  <aamine@loveruby.net>

	* lib/net/http.rb: should not overwrite Host: header.

Wed Nov 20 02:07:12 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* compar.c (cmp_eq,cmp_gt,cmp_ge,cmp_lt,cmp_le): "<=>" might
	  return nil.  check using rb_cmpint().

	* error.c (init_syserr): remove sys_nerr dependency.

Tue Nov 19 22:37:23 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* regex.c (re_match): avoid dereferencing if size == 0.

Tue Nov 19 05:16:23 2002  Akinori MUSHA  <knu@iDaemons.org>

	* instruby.rb: Do not install various working files under bin/.

Tue Nov 19 02:34:18 2002  Akinori MUSHA  <knu@iDaemons.org>

	* bin/irb: Moved from sample/irb.rb.

	* instruby.rb: Install script files under bin/ with ruby's program
	  prefix and suffix.

	* instruby.rb: Rewrite installed scripts' shebang lines.

Mon Nov 18 02:59:31 2002  Akinori MUSHA  <knu@iDaemons.org>

	* lib/tempfile.rb: Make this libary thread safe.

	* lib/tempfile.rb: Do not pick a name which was once used and is
	  still scheduled for removal.

	* lib/tempfile.rb: A lock file need not and must not be scheduled
	  for removal.

	* lib/tempfile.rb: Compare Max_try with the number of mkdir
	  failures instead of the suffix counter.

	* lib/tempfile.rb: Overall cleanup and add some important notices.

Fri Nov 15 07:51:24 2002  NAKAMURA Hiroshi  <nakahiro@sarion.co.jp>

	* ostruct.rb: fix a bug in inspect which called String#+ with Symbol.
	  [ruby-dev:18788]

	* profile.rb: illegal use of Array#sort!.  replaced it with non-bang
	  method.  [ruby-dev:18792]

Sat Nov  9 16:06:57 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/tcltklib/stubs.c: should include "util.h" for ruby_strdup.

Fri Nov  8 22:10:51 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_eval): removed unnecessary toplevel check.

Thu Nov  7 09:51:37 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* eval.c (blk_orphan): a block created in a different thread is
	  orphan.  [ruby-dev:17471]

Mon Nov  4 04:04:32 2002  Akinori MUSHA  <knu@iDaemons.org>

	* lib/getopts.rb: Do not choke on characters that cannot be used
	  in a variable name.  Replace them with `_'.  Define a hash named
	  $OPT for convenience.

Thu Oct 31 09:31:51 2002  K.Kosako  <kosako@sofnec.co.jp>

	* eval.c (rb_export_method): undef'ed method visibility should not
	  be changed.

Sun Oct 27 00:55:21 2002  Akinori MUSHA  <knu@iDaemons.org>

	* array.c, class.c, eval.c, file.c, gc.c, node.h, numeric.c,
	  object.c, parse.y, range.c, re.c, string.c, struct.c, util.c,
	  ext/socket/socket.c: merge from 1.7: treat long values as long
	  instead of int.

Sat Oct 26 04:39:48 2002  Akinori MUSHA  <knu@iDaemons.org>

	* parse.y (str_extend): pushback() takes one argument, so properly
	  pass c to it.

Sat Oct 26 04:38:25 2002  Akinori MUSHA  <knu@iDaemons.org>

	* ext/dbm/dbm.c (fdbm_indexes, fdbm_select): add a missing
	  argument and prevent coredump when a nonexistent key is
	  specified.

	* ext/sdbm/init.c (fsdbm_indexes, fsdbm_select): ditto.
  
Sat Oct 26 04:36:01 2002  Akinori MUSHA  <knu@iDaemons.org>

	* eval.c, gc.c: use a common set of alloca() #ifdef's.  This fixes
	  the build with Intel C Compiler for Linux.

Tue Oct 22 18:15:49 2002  Guy Decoux  <ts@moulon.inra.fr>

	* eval.c (rb_eval): local_vars[-1] should protect body, not a
	  local_tbl.

Tue Oct 22 02:31:16 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* marshal.c (w_object): check if klass is really a class.

Fri Oct 18 23:39:00 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* parse.y (value_expr0): allow return/break/next/redo/retry in rhs
	  of logical operator.  [ruby-dev:18534]

	* parse.y (remove_begin): eliminate useless NODE_BEGIN.
	  [ruby-dev:18535]

Fri Oct 18 01:25:51 2002  Akinori MUSHA  <knu@iDaemons.org>

	* hash.c, eval.c: Use (*_NSGetEnviron()) instead of environ on
	  Darwin for namespace cleanness.  [ruby-core:00537]

	* dln.c (dln_load): Fix Darwin support that has been disabled and
	  switch to using it on Darwin instead of the system dlopen().
	  [ruby-core:00541]

Thu Oct 17 15:20:11 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_eval): need to push empty varmap node only when
	  ruby_dyna_var is NULL.

Fri Oct 11 06:05:30 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* win32/win32.c (win32_fclose, win32_close): use closesocket()
	  for socket.  [ruby-win32:382]

	* win32/win32.c (StartSockets): set NtSocketsInitialized.

	* win32/win32.h: prototypes; win32_fclose, win32_close

Thu Oct 10 17:26:12 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/tcltklib/stubs.c (ruby_tcltk_stubs): fix memory leak.
	  [ruby-dev:18478]

Thu Oct 10 15:20:18 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* eval.c (ruby_init): Init_stack() with local location.
	  (ruby-bugs-ja:PR#277)

	* gc.c (Init_stack): prefer address of argument rather than local
	  variable to initialize rb_gc_stack_start.

	* lib/weakref.rb (WeakRef::@@final): use Hash#delete.

	* lib/weakref.rb (WeakRef::__getobj__): examin if alive or not by
	  ID_REV_MAP to deal with recycled object.  [ruby-dev:18472]

	* lib/weakref.rb (WeakRef::weakref_alive?): ditto.

Mon Oct  7 16:43:07 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (bigdivrem): bignum zero's len should not be 0.

Mon Oct  7 15:36:42 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (bigdivmod): wrong condition check for Bignum zero.

	* bignum.c (Init_Bignum): need to add Bignum#div.

Sun Oct  6 06:11:19 2002  Minero Aoki  <aamine@loveruby.net>

	* eval.c (rb_load): should not pass block to the loaded file.

Fri Oct  4 14:23:08 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in (RUBY_PROG_GNU_LD): check whether the linker is GNU ld.

	* ext/extmk.rb.in (create_makefile): add -Wl,-no-undefined to $DLDFLAGS
	  on Linux if GNU ld is used and --enable-shared is specified.

	* configure.in (RUBY_MINGW32): backport from 1.7.

Fri Oct  4 02:21:16 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (rb_big_rshift): num should be initialized by carry
	  bits if x is negative. (ruby-bugs-ja:PR#347)

	* bignum.c (bigdivmod): len for bignum zero is 1, not 0.

Thu Oct  3 20:09:52 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* ext/tcltklib/tcltklib.c (invoke_queue_handler): make singleton
	  method object to run handler in separated safe level.

	* ext/tcltklib/tcltklib.c (ip_invoke): requires command name
	  argument.

Wed Oct  2 13:03:58 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in: set ac_cv_func_setitimer to "no" on Cygwin.

Tue Oct  1 23:48:32 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* ext/socket/socket.c (sock_new): duplicate underlying socket
	  handle not only descriptor.  [ruby-talk:40015]

	* ext/socket/socket.c (bsock_close_read, bsock_close_write): not
	  use myfdclose().

	* win32/win32.c, win32/win32.h (myfddup, myfdclose): delete.

Wed Sep 25 16:14:51 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* regex.c (re_match): p1 may exceed pend limit.

Mon Sep 23 02:46:29 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (ruby_run): should set toplevel visibility again here. 

	* eval.c (rb_eval): should not rely on ruby_class == rb_cObject
	  check.   Besides allow implicit publicity for attribute set
	  methods.

	* parse.y (primary): need not to check class_nest, just set
	  whether method is an attrset or not.

Sun Sep 22 17:08:11 2002  Tanaka Akira  <akr@m17n.org>
	
	* string.c (rb_str_each_line): p might be at the top of the
	  string.

Sun Sep 22 15:31:33 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* lib/mkmf.rb: some backports.

Sun Sep 15 21:42:07 2002  KONISHI Hiromasa <konishih@fd6.so-net.ne.jp>

	* win32/win32.c (opendir): Corresponds to the unjust path containing ".
	                (win32_stat) : ditto.

Thu Sep 12 00:52:15 2002  NAKAMURA Usaku <usa@ruby-lang.org>

	* lib/mkmf.rb (create_makefile): Merge from 1.7: link with
	  CONFIG["LIBS"].

Thu Sep 12 00:09:32 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* eval.c (rb_trap_eval): preserve thread status and so on.
	  [ruby-talk:40337], [ruby-core:00019]

Wed Sep 11 16:49:26 2002  Akinori MUSHA  <knu@iDaemons.org>

	* lib/open3.rb: Merge from 1.7: Turn sync on for the writer
	  handle.

	* lib/ping.rb: Merge from 1.7: Fix a typo.

Wed Sep 11 16:24:22 2002  Akinori MUSHA  <knu@iDaemons.org>

	* lib/thread.rb: Merge from 1.7: Get rid of race condition in
	  Queue#pop().

	* lib/thread.rb: Merge from 1.7: SizedQueue: new(max) should not
	  accept a value <= 0.

	* lib/thread.rb: Merge from 1.7: SizedQueue: Properly override
	  enq(), shift() and deq().

Wed Sep 11 16:15:06 2002  Akinori MUSHA  <knu@iDaemons.org>

	* lib/tempfile.rb: Merge from 1.7: Add Tempfile#size.

Mon Sep  9 23:43:33 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* win32/win32.h (S_I?USR): define only if not mingw32.

Mon Sep  9 20:41:03 2002  NAKAMURA Usaku <usa@ruby-lang.org>

	* win32/win32.c (do_spawn): fix the bug which the environment variables
	  had not spread.

Sun Sep  8 19:21:48 2002  NAKAMURA Usaku <usa@ruby-lang.org>

	* dir.c (rb_glob): add prototype of 2nd argument to avoid VC++ warning.

	* dir.c (push_pattern): add const directive to 1st argument.

	* dir.c: prototype; push_pattern() to avoid VC++ warning.

	* ext/tcltklib/tcltklib.c: prototype; _timer_for_tcl() and ip_ruby()
	  to avoid VC++ warning.

	* win32/win32.c (win32_stat): remove S_IWGRP and S_IWOTH bits from
	  st_mode.

	* win32/win32.h (S_I*): define if not defined.

Sat Sep  7 23:32:56 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* misc/inf-ruby.el (inferior-ruby-error-regexp-alist): regexp
	  alist for error message from ruby.

	* misc/inf-ruby.el (inferior-ruby-mode): fixed for Emacs.

	* misc/inf-ruby.el (ruby-send-region): compilation-parse-errors
	  doesn't parse first line, so insert separators before each
	  evaluations.

Sat Sep  7 08:44:27 2002  Minero Aoki  <aamine@loveruby.net>

	* parse.y (rb_gc_mark_parser): ruby_eval_tree is marked in eval.c.

Fri Sep  6 12:01:18 2002  Minero Aoki  <aamine@loveruby.net>

	* parse.y (rb_gc_mark_parser): should mark all global variables
	  in parse.y.

Fri Sep  6 05:48:26 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* file.c (rb_path_check): nothing to check under DOSISH.
	  [ruby-list:35772]

Fri Sep  6 05:11:48 2002  Minero Aoki  <aamine@loveruby.net>

	* gc.c (rb_gc): should mark parser.

	* parse.y (rb_gc_mark_parser): new function.

	* intern.h (rb_gc_mark_parser): added.

Thu Sep  5 18:32:32 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* variable.c (rb_path2class): should not use rb_eval_string().

Thu Sep  5 15:33:16 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (str_extend): expression substitution can contain string
	  terminator again.

Thu Sep  5 13:09:22 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* eval.c (rb_eval): overriding false constant with class/module
	  definition should be error.  (PR#327)

	* eval.c (rb_call0): preset source file/line to pass correct ones
	  to trace_func at end of empty method.  [ruby-dev:18035]

	* ruby.c (require_libraries): not clear source file.
	  [ruby-dev:18074]

Wed Sep  4 05:10:16 2002  Koji Arai  <jca02266@nifty.ne.jp>

	* parse.y (yylex): the warning message "invalid
          character syntax" was never issued.

Tue Sep  3 00:22:43 2002  Minero Aoki  <aamine@loveruby.net>

	* gc.c (gc_sweep): does reclaim nodes in also compile time, if we
	  can.

	* ruby.c (load_file): omit GC if we can.

	* parse.y (ruby_parser_stack_on_heap): new function.

	* intern.h (ruby_parser_stack_on_heap): added.

Tue Aug 27 15:03:35 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* file.c (rb_find_file): $LOAD_PATH must not be empty.

	* file.c (rb_find_file_ext): ditto.

Tue Aug 27 02:35:21 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* range.c (range_eq): class check should be based on range.class,
	  instead of Range to work with Range.dup.

	* range.c (range_eql): ditto.

Sun Aug 25 20:10:32 2002  Wakou Aoyama  <wakou@ruby-lang.org>

	* lib/cgi.rb (CGI#form): fix ruby-bugs-ja:PR#280, add default action.

Sat Aug 24 13:57:28 2002  Tanaka Akira  <akr@m17n.org>

	* lib/time.rb (Time.rfc2822, Time#rfc2822): preserve localtimeness.

Wed Aug 21 16:43:19 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_thread_cleanup): should not modify the global
	  variable curr_thread.

Tue Aug 20 19:39:03 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* file.c (rb_file_s_expand_path): accept drive letter on Cygwin.

	* file.c (is_absolute_path): ditto.

Mon Aug 19 19:01:55 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* misc/inf-ruby.el (inf-ruby-keys): ruby-send-definition
	  conflicted with ruby-insert-end.

	* misc/inf-ruby.el (inferior-ruby-mode): compilation-minor-mode.

	* misc/inf-ruby.el (ruby-send-region): send as here document to
	  adjust source file/line.  [ruby-talk:47113], [ruby-dev:17965]

	* misc/inf-ruby.el (ruby-send-terminator): added to make unique
	  terminator.

Mon Aug 19 17:08:19 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* re.c (rb_reg_initialize_m): frozen check should be moved here
	  from rb_reg_initialize().

Mon Aug 19 15:38:44 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* array.c (sort_2): comparison should be done as signed long.

	* array.c (sort_2): should return int, not VALUE.

Mon Aug 19 12:38:33 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* eval.c (rb_thread_save_context, rb_thread_restore_context):
	  save/restore SEH chain on MS-Windows at thread switch.
	  [ruby-win32:273]

	* eval.c (win32_get_exception_list, win32_set_exception_list):
	  added.

Sat Aug 17 23:01:25 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* array.c (sort_2): *a - *b may overflow.

Sat Aug 17 00:25:08 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* array.c (rb_ary_new2): len*sizeof(VALUE) may be a positive value.

	* array.c (rb_ary_initialize): ditto.

Thu Aug 15 00:48:46 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* re.c (rb_reg_initialize): should not modify frozen Regexp.

Tue Aug 13 00:37:11 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (rb_uint2big): there should be no zero sized bignum.

Mon Aug 12 23:45:28 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/extmk.rb.in: extmake() that works properly for both tkutil
	  (tk/tkutil.so) and digest/sha1.

Wed Aug  7 09:51:54 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* hash.c (rb_hash_equal): should check default values.

Fri Aug  2 01:21:52 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/socket/socket.c (s_recvfrom): update RSTRING len.

Thu Aug  1 13:51:30 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* io.c (io_fread): return value was longer when EWOULDBLOCK
	  occurred.

Wed Jul 31 14:11:43 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_undef): undef should be done for klass, not ruby_class.

Tue Jul 30 15:24:07 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/tcltklib/stubs.c (ruby_tcltk_stubs): win32_getenv returns
	  the same address always, so allocate string by ruby_strdup.

Mon Jul 22 17:23:00 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (error_handle): should handle TAG_THROW as well.

Fri Jul 12 00:51:09 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* eval.c (rb_eval): fixed line number in string interpolation.

	* parse.y (str_extend): ditto.

Thu Jul 11 21:30:38 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* parse.y (yylex): should pushback proper char after '<<'.

Thu Jul 11 09:00:43 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_slice_bang): if there's no corresponding
	  substring, slice! should return nil without exception.

Fri Jul  5 09:17:00 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_split_m): accept separator value nil as well.

Fri Jul  5 05:00:40 2002  Wakou Aoyama  <wakou@ruby-lang.org>

	* lib/cgi.rb (CGI#initialize): improvement for mod_ruby.
	thanks to Sean Chittenden <sean@ruby-lang.org>, Shugo Maeda
	<shugo@modruby.net>

Wed Jul  3 02:32:31 2002  Wakou Aoyama  <wakou@ruby-lang.org>

	* lib/cgi.rb (CGI#initialize): improvement for mod_ruby.

Tue Jul  2 14:53:10 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* class.c (include_class_new): module may be T_ICLASS; retrieve
	  original module information.

Tue Jul  2 14:13:11 2002  Wakou Aoyama  <wakou@ruby-lang.org>

	* lib/cgi.rb (CGI#header): accept any type as value.

Sun Jun 30 17:05:29 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in (seekdir, telldir): add ac_cv_func_telldir=yes,
	  ac_cv_func_seekdir=yes for MinGW.

Fri Jun 28 00:51:19 2002  NAKAMURA Usaku <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_stat): fix buffer overflow. (ruby-bugs:PR#329)

Thu Jun 27 03:42:04 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* re.c (rb_reg_expr_str): need to process backslashes properly.

Tue Jun 25 18:40:50 2002  KONISHI Hiromasa <konishih@fd6.so-net.ne.jp>

	* dln.c: remove definition rb_loaderror().

Thu Jun 20 21:09:37 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* ext/readline/readline.c (readline_readline): get rid of
	  libreadline's bug. (ruby-bugs-ja:PR#268)

Thu Jun 20 17:10:27 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* lib/ftool.rb (BUFSIZE): tuning, set buffer length to 8192.

	* configure.in (__NO_ISOCEXT): add for mingw-runtime 2.0-2.

	* configure.in (__MSVCRT__): removed because it is defined
	  in the GCC specs.

Wed Jun 19 14:46:18 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/extmk.rb, lib/mkmf.rb (xsystem): open the log file if xsystem
	  is called.

Mon Jun 17 10:51:37 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* dln.c (dln_load): need to preserve dln_strerror() result,
	  calling other dl family can clear it.

Sat Jun 15 19:30:44 2002  Akinori MUSHA  <knu@iDaemons.org>

	* dir.c (rb_glob_helper): Use lstat() instead of rb_sys_stat() so
	  it catches a dead symlink.  Given a dead symlink named "a",
	  Dir.glob("?") did catch it but Dir.glob("a") somehow didn't.

Sat Jun 15 01:59:05 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (yylex): no here document after a dot.

	* parse.y (yylex): should have set lex_state properly after '`'.

	* parse.y (yylex): should have set lex_state properly after
	  tOP_ASGN.

Fri Jun 14 15:22:19 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* parse.y (read_escape): deny zero-width hexadecimal character.
	  (ruby-bugs-ja:PR#260)

	* parse.y (tokadd_escape): ditto.

	* regex.c (re_compile_pattern): ditto.

Fri Jun 14 00:49:54 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (rb_big2dbl): return canonical HUGE_VAL for infinity.

Thu Jun 13 00:33:49 2002  takuma ozawa  <metal@mine.ne.jp>

	* hash.c (rb_hash_s_create): use rb_hash_aset() instead of calling
	  st_insert() directly, to dup&freeze string keys.

Thu Jun 13 00:12:54 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (yylex): proper error message for "@@0".

	* parse.y (yylex): paren to parse_string() must be zero for
	  unparenthesized strings.

	* parse.y (str_extend): broken string when unterminated "#{".

Wed Jun 12 18:04:44 2002  akira yamada  <akira@arika.org>

	* uri/common.rb (REGEXP::PATTERN::X_ABS_URI): 'file:/foo' is valid.

	* uri/generic.rb (Generic#xxx=): should return substituted value.
	  (ruby-dev:16728.)

	* test/generic.rb (test_set_component): added tests for the above
	  change.

Wed Jun 12 15:00:57 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* parse.y (stmt): fix typo.

Wed Jun 12 01:10:40 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (singleton): "def (()).a end" dumped core.

	* parse.y (cond2): node may be null.

	* parse.y (match_gen): ditto.

Tue Jun 11 17:12:04 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (arg): void value check for "..", "...", "!", and "not".

	* parse.y (match_gen): void value check for "=~".

	* parse.y (value_expr): check NODE_AND and NODE_OR recursively.

	* parse.y (cond0): void value check added for conditionals.

Mon Jun 10 19:02:19 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* numeric.c (fix_lshift): negative shift count means right shift.
	  (ruby-bugs-ja:PR#248)

	* numeric.c (fix_rshift): return -1 when left side operand is
	  negative. (ruby-bugs-ja:PR#247)

	* parse.y (yylex): `0_' should be an error. (ruby-bugs-ja:PR#249)

Mon Jun 10 01:53:54 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_eval): ruby_frame->last_func may be null, if it's
	  called outside of a method.

	* parse.y (arg): use INT2NUM, not INT2FIX for tUMINUS.

	* parse.y (arg): $1 may be null for tPOW.

Sat Jun  8 00:48:38 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (stmt,arg): too much void value check.

	* parse.y (arg): need to check void value on rules which does not
	  use node_assign().

Thu Jun  6 17:42:39 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/socket/socket.c (ipaddr): need not to taint hostnames.

Wed Jun  5 18:53:06 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* math.c (Init_Math): backport asin, acos, atan.

Tue Jun  4 00:45:50 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* ext/socket/addrinfo.h: typo.

	* ext/socket/socket.c (init_inetsock): ensures resources are
	  freed at exceptions.

	* ext/socket/socket.c (init_unixsock): ditto.

	* ext/socket/socket.c (udp_connect): ditto.

Mon Jun  3 07:07:07 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* parse.y (here_document): check if identifier is terminated.
	  (ruby-bugs-ja:PR#239)

	* parse.y (yylex): should pushback proper char after '**'.
	  (ruby-bugs-ja:PR#240)

Mon Jun  3 05:56:17 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_aset): should raise error if an indexing string
	  is not found in the receiver.

	* sprintf.c (rb_f_sprintf): "%d" should convert objects into
	  integers using Integer().

Thu May 30 09:16:36 2002  Wakou Aoyama  <wakou@ruby-lang.org>

	* lib/cgi.rb: if StringIO is usable then use it.

Wed May 29 13:45:15 2002  Wakou Aoyama  <wakou@ruby-lang.org>

	* lib/cgi.rb: not use const if GET, HEAD. check multipart form head.

Tue May 28 12:13:37 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* eval.c (scope_node): trick to keep the node has a scope.

	* eval.c (rb_eval): NODE_EVSTR: write back local_tbl to the node.

	* eval.c (rb_eval): NODE_SCOPE: hold the scope node in ruby_scope.

	* eval.c (module_setup): ditto.

	* eval.c (rb_call0): ditto.

	* node.h (NEW_DASGN, NEW_DASGN_CURR): remove surplus semicolons.

Fri May 24 09:06:29 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* time.c (time_arg): nil test against v[6] (usec).

Thu May 23 14:52:32 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ruby.c (proc_options): -v should not print version if
	  proc_options called via moreswitches().

Thu May 23 09:13:56 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ruby.c (proc_options): removed "-*-" support for #! line.

Wed May 22 21:36:11 2002  Tadayoshi Funaba  <tadf@dotrb.org>

	* lib/parsedate.rb: updated to the new version (based on date2 2.6.1).

Wed May 22 21:26:47 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* ruby.c (proc_options): -T consumes digits only.

Wed May 22 20:18:31 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in: need not link vsnprintf.o on MinGW.

Wed May 22 18:40:22 2002  Minero Aoki  <aamine@loveruby.net>

	* parse.y (yylex): case '<': here-document has eaten '-'.

Tue May 21 13:25:18 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* misc/ruby-mode.el (ruby-font-lock-keywords): symbols end with
	  '_'.

Tue May 21 04:48:37 2002  Sean Chittenden <sean@chittenden.org>

	* lib/cgi-lib.rb: Checking for constant MOD_RUBY instead of
	  environment variable. Remove a mod_ruby warning and use
	  Apache::request.headers_out[] instead.

Mon May 20 13:28:52 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* io.c (rb_io_clone): writing stream was not copied properly.

Fri May 17 16:16:19 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* sampl/test.rb: use eval instead of './miniruby -c',
	  in order to check a syntax error.

Thu May 16 16:14:25 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* eval.c (rb_thread_select): cleanup conditional compilation.

Thu May 16 15:14:48 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* djgpp/config.hin, djgpp/config.sed: catch up with the latest change.

Wed May 15 06:13:35 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_thread_schedule): need to preserve errno before
	  calling rb_trap_exec().

	* regex.c (calculate_must_string): a bug in charset/charset_not
	  parsing.

Tue May 14 14:49:05 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* gc.c (is_pointer_to_heap): avoid GCC 3.1 warnings.

	* missing/strftime.c (timezone): it should take no argument on Cygwin.

Tue May 14 09:15:39 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (blk_orphan): the wrong condition; backported from 1.7

Tue May 14 03:07:35 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_clear_cache_by_class): new function.

	* eval.c (set_method_visibility): should have clear cache forq
	  updated visibility.

Fri May 10 19:00:47 2002  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* parse.y (here_document): preserve line number begins here
	  document.

Tue May  7 15:24:32 2002  Minero Aoki  <aamine@loveruby.net>

	* eval.c (rb_yield_0): The destination of the goto jump was wrong.

Tue May  7 09:21:12 2002  Minero Aoki  <aamine@loveruby.net>

	* eval.c (superclass): undesirable "unexpected return" when the
	  superclass is not a Class.

Sat May  4 20:55:10 2002  Akinori MUSHA  <knu@iDaemons.org>

	* eval.c, gc.c, intern.h, variable.c: declare rb_gc_mark{,maybe}()
	  canonically in order not to confuse C++ compilers. (backported
	  from 1.7, problem noted by ttate)

Thu May  2 23:42:40 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* re.c (rb_reg_s_quote): # also should be quoted.

Thu May  2 18:27:13 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/extmk.rb.in, lib/mkmf.rb: use 'do...end' instead of '{}' for
	  Borland make.

Mon Apr 29 18:46:42 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* file.c (rb_find_file): load must be done from an abolute path if
	  $SAFE >= 4.

Sun Apr 28 17:01:56 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* win32/win32.c (insert): fix prototype for ANSI C.

Fri Apr 26 13:41:00 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* re.c (rb_reg_s_quote): quote whitespaces for /x cases.

Wed Apr 24 14:21:41 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in: set size of the initial stack from
	  2MB to 32MB on MinGW/Cygwin.

	* util.c (push_element): avoid warning for djgpp.

Wed Apr 24 01:16:14 2002  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (create_makefile): should print depend file when
	  make is other than nmake.

Wed Apr 24 00:42:41 2002  NAKAMURA Usaku <usa@ruby-lang.org>

	* ext/extmk.rb.in (create_makefile): use `{$(srcdir)}' directive instead
	  of `$(srcdir)/' when including depend file.

	* lib/mkmf.rb (create_makefile): add `{$(srcdir)}' when including depend
	  file.

Mon Apr 22 09:31:30 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_thread_cleanup): should not terminate main_thread by
	  Fatal error.

	* regex.c (is_in_list): need to not exclude NUL and NEWLINE.

Sat Apr 20 00:19:13 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* re.c (rb_reg_expr_str): wrong backslash escapement.

	* re.c (rb_reg_expr_str): do not escape embedded space
	  characters.

Fri Apr 19 17:06:48 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/socket/extconf.rb: include <windows.h>, <winsock.h> on _WIN32.
	
Fri Apr 19 01:08:20 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_thread_cleanup): current thread may be THREAD_STOPPED,
	  for example when terminated from signal handler.

Wed Apr 17 16:53:33 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* re.c (rb_reg_expr_str): should treat backslash specially in
	  escaping.

Mon Apr 15 18:12:57 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (rb_big_eq): check `y == x' if y is neither Fixnum,
	  Bignum, nor Float.

Mon Apr 15 09:27:31 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* pack.c (pack_unpack): should treat 'U' in character unit, not in
	  byte unit.

Thu Apr 11 23:54:36 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* marshal.c (w_uclass): should check based on rb_obj_class(), not
	  CLASS_OF().

Thu Apr 11 20:01:44 2002  Masahiro Tomita  <tommy@tmtm.org>

	* io.c (io_write): check error if written data is less than
	  specified size to detect EPIPE.

Thu Apr 11 18:40:38 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* io.c (read_all): return "" if file.size == 0.

	* random.c (rand_init): add check for initstate(3).

	* configure.in: ditto.

Thu Apr 11 07:57:48 2002  Michal Rokos  <m.rokos@sh.cvut.cz>

	* eval.c (assign): ruby_verbose should be surrounded by RTEST().

	* object.c (rb_str2cstr): ditto.

	* parse.y (void_expr): ditto.

	* parse.y (void_stmts): ditto.

	* variable.c (rb_ivar_get): ditto.

	* variable.c (rb_cvar_set): ditto.

	* variable.c (rb_cvar_get): ditto.

Thu Apr 11 01:55:52 2002  Wakou Aoyama  <wakou@fsinet.or.jp>

	* lib/cgi/session.rb: support for multipart form.

Wed Apr 10 17:30:19 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* variable.c (rb_obj_remove_instance_variable): raise NameError if
	  specified instance variable is not defined.

	* variable.c (generic_ivar_remove): modified to check ivar
	  existence.

Wed Apr 10 14:16:45 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* misc/ruby-mode.el (ruby-font-lock-keywords): fontify symbols for
	  unary operators and aset.

Sat Apr  6 02:04:49 2002  Guy Decoux  <ts@moulon.inra.fr>

	* class.c (rb_singleton_class): wrong condition; was creating
	  unnecessary singleton class.

Thu Apr  4 15:45:12 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* parse.y: avoid bison 1.34 warnings. add `;' at the end of a rule.

Thu Apr  4 01:08:23 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* numeric.c (int_step): step may be a float less than 1.

Wed Apr  3 01:54:10 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* ext/extmk.rb.in (enable_config): follow lib/mkmf.rb.

Mon Apr  1 10:56:40 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* re.c (match_setter): it's OK to assign nil to $~.

Fri Mar 29 20:21:58 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* lib/mkmf.rb (create_makefile): default FLAGS to empty strings.

Fri Mar 29 16:36:52 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* lib/mkmf.rb (arg_config): should use Shellwords::shellwords like
	  ext/extmk.rb.in.

	* lib/mkmf.rb (enable_config): default had priority over command
	  line options and configure_args.

	* lib/mkmf.rb: support autoconf 2.53 style variables from
	  environment.

	* lib/mkmf.rb: add directory options.

Wed Mar 27 14:38:16 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* io.c (READ_DATA_PENDING): uClibc 0.9.10 support.
	  use !feof(fp) for default behavior.

Wed Mar 27 04:44:48 2002  Akinori MUSHA  <knu@iDaemons.org>

	* file.c (rb_file_s_expand_path): Do not free the pointer obtained
	  from getenv().

Tue Mar 26 14:08:11 2002  okabe katsuyuki <HGC02147@nifty.ne.jp>

	* win32/mkexports.rb: support VC++.NET.

Mon Mar 25 19:30:25 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/extmk.rb.in (arg_config): get rid of single quotes
	  for autoconf 2.53.

	* ext/extmk.rb.in (arg_config): should use Shellwords::shellwords.

Mon Mar 25 13:24:20 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ext/socket/socket.c (bsock_do_not_rev_lookup_set): should not be
	  allowed when $SAFE > 3.

Mon Mar 25 11:32:21 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* dln.c (dln_argv0): unused unless USE_DLN_A_OUT.

	* ext/digest: add depend files.

	* ext/syslog: ditto.

Sun Mar 24 12:19:09 2002  Koji Arai  <jca02266@nifty.ne.jp>

	* dir.c (fnmatch): "*/bar" (with FNM_PATHNAME flag) does not
	  match "foo/bar".

Sat Mar 23 01:50:30 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (read_all): files on /proc filesystem with zero stat size,
	  may have contents.

Fri Mar 22 15:04:03 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (exec_under): changing ruby_class is OK, but should not
	  alter cbase.

	* eval.c (yield_under_i): ditto.

Fri Mar 22 14:32:14 2002  Minero Aoki  <aamine@loveruby.net>

	* lib/net/protocol.rb: Protocol#start should return self.

Wed Mar 20 22:08:51 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* eval.c (is_defined): label forgotten.

Wed Mar 20 20:46:36 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* win32/config.status.in: RUBY_SO_NAME had been changed long long
	  ago.

Wed Mar 20 16:24:49 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in: workaround for autoconf 2.53.

Wed Mar 20 00:46:54 2002  Akinori MUSHA  <knu@iDaemons.org>

	* dir.c (my_getcwd): the content of buf is uncertain and must not
	  be printed when getcwd(buf, size) has failed.

Wed Mar 20 16:05:37 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (is_defined): should check receiver only once.

	* eval.c (is_defined): should handle NODE_NEWLINE.

Wed Mar 20 11:29:25 2002  Aristarkh A Zagorodnikov  <xm@xml-objects.com>

	* file.c (rb_file_s_expand_path): memory leak fixed.

Mon Mar 18 10:55:03 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* enum.c (enum_find): catch a value before recycle.

	* enum.c (enum_min): ditto.

	* enum.c (enum_max): ditto.

	* parse.y (parse_string): part of multi-byte sequence must not
	  match to paren.

	* parse.y (parse_qstring): ditto.

	* parse.y (parse_quotedwords): ditto.

	* parse.y (str_extend): handle multi-byte characters.

Sat Mar 16 15:30:40 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* re.c (rb_reg_search): should clear last_match if pos is out of
	  string range.

	* string.c (rb_str_index_m): ditto.

	* string.c (rb_str_rindex): ditto.

Thu Mar 14 16:42:37 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* class.c (rb_define_class): should handle autoload.

	* class.c (rb_define_module): ditto.

Thu Mar 14 00:29:12 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* re.c (rb_reg_match): should clear $~ if operand is nil.

	* re.c (rb_reg_match2): ditto.

Wed Mar 13 18:50:29 2002  Akinori MUSHA  <knu@iDaemons.org>

	* lib/getopts.rb: Merge from 1.7.  Rewrite to fix some bugs and
	  complete features.
	    - Accept options with the colon in the first argument;
	      getopts("a:bcd:") is equivalent to getopts("bc", "a:", "d:").
	    - Do not discard the argument that caused an error.
	    - Do not discard '-', which commonly stands for stdin or stdout.
	    - Allow specifying a long option with a value using '='.
	      (command --long-option=value)
	    - Stop reading options when it meets a non-option argument.

Mon Mar 11 18:03:37 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* regex.c (re_compile_pattern): '\0111' should be '\011' plus '1',
	  since octal literals are formed by three digits at most.

Mon Mar 11 14:44:38 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_eval_cmd): cbase should not be NULL; it should be
	  either ruby_wrapper or Object.

Sun Mar 10 02:18:22 2002  Koji Arai  <jca02266@nifty.ne.jp>

	* enum.c (enum_each_with_index): should return self.

	* process.c (proc_setpgrp): should return value for non-void function.

	* process.c (proc_getpgid): should raise exception if getpgid() return -1.

	* string.c (rb_str_ljust): should return a duplicated string.

	* string.c (rb_str_rjust): ditto.

	* string.c (rb_str_center): ditto.

Fri Mar  8 02:21:32 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (cvar_cbase): utility function to find innermost non
	  singleton cbase.

	* eval.c (is_defined): adopt new cvar behavior.

	* eval.c (rb_eval): ditto.

	* eval.c (assign): ditto.

Thu Mar  7 20:08:25 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* gc.c (rb_source_filename): added. holds unique strings for file
	  names with GC space.

	* gc.c (rb_gc_mark): mark source file name.

	* gc.c (gc_sweep): ditto.

	* gc.c (Init_GC): initialize source file name table.

	* intern.h (rb_source_filename): added.

	* eval.c (rb_eval_string): use rb_source_filename().

	* parse.y (yycompile): ditto.

	* ruby.c (proc_options): ditto.

	* ruby.c (load_file): ditto.

	* ruby.c (ruby_script): ditto.

	* ruby.c (ruby_prog_init): ditto.

Wed Mar  6 17:58:08 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* dln.c (dln_load): use LoadLibrary instead of LoadLibraryEx.

Tue Mar  5 03:39:27 2002  Usaku Nakamura <usa@ruby-lang.org>

	* ext/extmk.rb.in (create_makefile): remove unnecessary -L option from
	  LIBS macro.

	* ext/extmk.rb.in (extmake): default $LIBPATH to $libdir.

	* win32/win32.c (NtCmdGlob): avoid VC++ warning.

Mon Mar  4 13:23:16 2002  Akinori MUSHA  <knu@iDaemons.org>

	* ext/extmk.rb.in (dir_config): Sync with mkmf.rb: Fix a bug where
	  --with-xx-{include,lib} is ignored when --with-xx-dir is
	  specified.

Mon Mar  4 00:09:55 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_eval): should initialize outer class variables from
	  methods in singleton class definitions.

	* eval.c (assign): ditto.

Sun Mar  3 15:02:23 2002  akira yamada  <akira@arika.org>

	* marshal.c (r_object): should call "call", not "yield".

Fri Mar  1 23:08:16 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* stable version 1.6.7 released.

Fri Mar  1 11:29:10 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/socket/{addinfo.h,getaddrinfo.c} (gai_strerror): add const
	  qualifier only for uClibc.

Wed Feb 27 16:30:50 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* st.c (st_init_table_with_size): num_bins should be prime numbers
	  (no decrement).

	* st.c (rehash): ditto.

Wed Feb 27 13:18:49 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* io.c (READ_DATA_PENDING): uClibc support.

	* random.c (rand_init): ditto.

	* ext/socket/{addinfo.h,getaddrinfo.c} (gai_strerror): ditto.

Wed Feb 27 07:08:16 2002  Akinori MUSHA  <knu@iDaemons.org>

	* ext/digest/sha2/sha2.c: Merge from rough.  Fix a couple of
	  off-by-one errors in Aaron Gifford's code.

	  Obtained from:  KAME via FreeBSD
	  KAME PR:        393
	  FreeBSD PR:     kern/34242

Tue Feb 26 21:36:01 2002  Usaku Nakamura <usa@ruby-lang.org>

	* bignum.c (rb_big_2comp): void function cannot return any value.

Tue Feb 26 16:52:12 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_f_missing): NoMethod error messages for true, false,
	  nil must respond visibility like for other objects.

Tue Feb 26 11:25:50 2002  akira yamada  <akira@arika.org>

	* lib/uri/generic.rb: merge0 should return [oth, oth] if oth is
	  absolute URI.

	* lib/uri/generic.rb: registry part must not be allowed for any
	  schemes for the Internet. (RFC2396, section 3.2.2 and 3.2.1.) 

Mon Feb 25 21:28:46 2002  Akinori MUSHA  <knu@iDaemons.org>

	* ext/syslog/syslog.c: Merge from rough.  Turn Syslog into a
	  module keeping backward compatibility intact.

Mon Feb 25 19:35:48 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* process.c (rb_syswait): argument order of rb_waitpid() inverted.

	* sample/test.rb (system): test with scripts under the source
	  directory.

Mon Feb 25 13:32:13 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* lib/shell.rb (Shell::expand_path): relative to @cwd.

Mon Feb 25 05:41:52 2002  Tanaka Akira  <akr@m17n.org>

        * lib/time.rb: fix unit tests before Unix Epoch.

Sun Feb 24 17:20:50 2002  Akinori MUSHA  <knu@iDaemons.org>

	* ext/digest/*/*.h: Merge from rough.
	  - Avoid namespace pollution. (MD5_* -> rb_Digest_MD5_*, etc.)

Sat Feb 23 21:12:13 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* process.c (rb_syswait): thread kludge; should be fixed to
	  support native thread.

Fri Feb 22 22:00:08 2002  Minero Aoki  <aamine@loveruby.net>

	* lib/net/protocol.rb: set read_timeout dynamically.

Fri Feb 22 19:59:33 2002  Usaku Nakamura <usa@ruby-lang.org>

	* win32/config.status.in: set LIBRUBY_SO.

Fri Feb 22 03:34:38 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (get2comp): need to specify to carry or not.

Wed Feb 20 15:15:03 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* intern.h: prototypes; rb_io_addstr(), rb_io_printf(),
	  rb_io_print(), rb_io_puts()

	* io.c (rb_io_addstr): make extern.

	* io.c (rb_io_printf): ditto.

	* io.c (rb_io_print): ditto.

	* io.c (rb_io_puts): ditto.

Wed Feb 20 12:41:59 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* hash.c (rb_any_cmp): should handle Qundef in keys.

	* eval.c (remove_method): should not remove an empty method to
	  implement "undef".

	* eval.c (rb_eval): should allow singleton class def for
	  true/false/nil.

Tue Feb 19 22:49:29 2002  Minero Aoki  <aamine@loveruby.net>

	* lib/net/http.rb: remove unused class Accumulator.

	* lib/net/http.rb: read response in HTTP#request. not
	  HTTPRequest#exec.

	* lib/net/http.rb: proxy related class instance variables are not
	  initialized correctly.

	* doc/net/http.rb: modify typo in the description of basic auth.

Tue Feb 19 20:20:12 2002  Ed Sinjiashvili  <edsin@swes.saren.ru>

	* parse.y (str_extend): backslash escape was done wrong.

Tue Feb 19 15:51:41 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* class.c (rb_include_module): should preserve ancestor order in
	  the included class/module.

Tue Feb 19 14:45:32 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* marshal.c (r_object): complete restoration before calling
	  r_regist(). 

	* parse.y (yylex): operators in the "op" rule should make
	  lex_state EXPR_ARG on EXPR_FNAME and EXPR_DOT.

Tue Feb 19 13:38:10 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* variable.c (rb_cvar_set): define new class variable if it's not
	  defined yet.

	* eval.c (rb_eval_string_wrap): should hide the toplevel local
	  variable bindings by PUSH_SCOPE().

Tue Feb 19 13:16:08 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* io.c (rb_io_ungetc): don't fail pushed EOF back.

Mon Feb 18 14:23:10 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* misc/ruby-mode.el (ruby-modifier-re): add rescue modifier.

	* misc/ruby-mode.el (ruby-font-lock-keywords): fontify
	  instance/class/global variables start with '_'.

Mon Feb 18 13:56:44 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (block_pass): "&nil" should clear block given.

Fri Feb 15 13:36:58 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (rb_big_rshift): should properly convert the nagative
	  value to 2's compliment.

Tue Feb 12 01:21:34 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (assignable): should emit CVASGN within the method
	  body.

Mon Feb 11 00:10:41 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* regex.c (re_compile_fastmap): skip begpos.

Sun Feb 10 16:52:53 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* ruby.c (load_file): avoid SEGV on '#' only input.

Fri Feb  8 23:07:23 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_eval): singleton check should be moved from yycompile
	  to here.

	* eval.c (is_defined): check should be added here too.

Fri Feb  8 05:39:15 2002  Minero Aoki  <aamine@loveruby.net>

	* lib/net/http.rb: HTTP.Proxy should use self for proxy-class's
	  super class.

	* lib/net/http.rb: initialize HTTP.proxy_port by HTTP.port.

Fri Feb  8 01:27:33 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (yycompile): should inherit "in_single" if eval happened
	  in a singleton method.

	* eval.c (rb_eval): class variables from singleton methods defined
	  within singleton class statement should work like ones defined
	  by singleton def statements.

Thu Feb 07 13:44:08 2002  akira yamada  <akira@arika.org>

	* uri/common.rb (URI::join): new method.

	* uri/generic.rb (Generic#merge): URI.parse("http://a/")+"b" should
	  return "http://a/b" but it returned "http://a//b".

	* uri/generic.rb (Generic#check_path): corrected error message, 
	  @path -> v

Wed Feb  6 17:18:54 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* configure.in: keep old config.h unless changed.

Mon Feb  4 15:38:29 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* object.c (rb_class_real): should not follow ICLASS link

	* variable.c (classname): should follow ICLASS link explicitly.

Thu Jan 31 20:45:33 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* lib/mkmf.rb (dir_config): prior --with flag.

	* lib/mkmf.rb (arg_config): avoid special variables for
	  font-lock-mode.

Wed Jan 30 13:37:05 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* re.c (rb_reg_search): should set regs.allocated.

Mon Jan 28 18:33:18 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* parse.y (yylex): strict check for numbers.

Mon Jan 28 13:29:41 2002  K.Kosako  <kosako@sofnec.co.jp>

	* eval.c (is_defined): defined?(Foo::Baz) should check constants
	  only, no methods.

	* eval.c (is_defined): should not dump core on defined?(a::b)
	  where a is not a class nor a module.

Fri Jan 25 17:48:43 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in (solaris): add '-shared' only for GNU ld.

Fri Jan 25 17:16:23 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* class.c (rb_include_module): detect cyclic module inclusion.

Fri Jan 25 02:17:56 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_thread_schedule): should check time only if BOTH
	  WAIT_SELECT and WAIT_TIME.

Thu Jan 24 05:42:01 2002  Koji Arai  <jca02266@nifty.ne.jp>

	* string.c (rb_str_split_m): no need to consider KANJI
	characters, if the length of separator is 1 (byte)

Wed Jan 23 13:27:44 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* eval.c (rb_yield_0): restore source file/line after yield.

Mon Jan 21 08:25:30 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (ruby_stop): should not trace error handler.

	* signal.c (install_sighandler): do not install sighandler unless
	  the old value is SIG_DFL.

	* io.c (io_write): should not raise exception on O_NONBLOCK io.

	* dir.c (dir_set_pos): seek should return dir, pos= should not.

Fri Jan 18 10:26:33 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* error.c (rb_sys_fail): replace INT2FIX() by INT2NUM() since
	  errno value may not fit in Fixnum size on Hurd.

	* error.c (set_syserr): ditto.

Fri Jan 18 02:27:48 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* dir.c (dir_s_glob): returns nil if block given.

	* io.c (rb_io_each_byte): should return self.

	* io.c (rb_io_close_m): close check added.

	* dir.c (dir_seek): should return pos.

Fri Jan 18 01:21:53 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (fixpos): orig may be (NODE*)1, which should not be
	  dereferenced.

Thu Jan 17 16:21:42 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (block_pass): should allow block argument relay even in
	  the tainted mode.

Wed Jan 16 18:25:08 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* st.c: primes should be primes.

Wed Jan 16 11:12:30 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* object.c (rb_Float): remove underscores between digits.

	* bignum.c (rb_cstr2inum): reject prefix followed by spaces only.

	* class.c (rb_class_inherited): should use Object when no super
	  class.

Tue Jan 15 12:43:34 2002  Minero Aoki  <aamine@loveruby.net>

	* lib/net/protocol.rb: Protocol#start returns the return value of
	  block.

	* lib/net/protocol.rb: set timeout limit by default.

	* lib/net/protocol.rb: new methods WriteAdapter#write, puts,
	  print, printf.

	* lib/net/protocol.rb: change template method scheme.

	* lib/net/http.rb: rename HTTP#get2 to request_get, post2 to
	  request_post ...

	* lib/net/pop.rb: POP#auth_only did not work.

	* lib/net/smtp.rb: should not resolve HELO domain automatically.

Mon Jan 14 13:06:02 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (block_pass): should not pass tainted block, if $SAFE > 0.

Sun Jan 13 09:31:41 2002  Koji Arai  <jca02266@nifty.ne.jp>

	* variable.c (rb_mod_remove_cvar): should pass the char*.

Fri Jan 11 05:06:25 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* class.c (rb_make_metaclass): [new]

	* class.c (rb_define_class_id): use rb_make_metaclass(), don't
	  call Class#inherited hook.

	* class.c (rb_class_inherited): [new]

	* class.c (rb_define_class): call Class#inherited hook here.

	* class.c (rb_define_class_under): ditto after class path is set.

	* class.c (rb_singleton_class): use rb_make_metaclass().

	* eval.c (rb_eval): same as rb_define_class_under().

	* intern.h: prototypes of rb_make_metaclass() and
	  rb_class_inherited().

	* object.c (rb_class_s_new): use rb_make_metaclass() and
	  rb_class_inherited().

	* object.c (Init_Object): use rb_make_metaclass().

	* struct.c (make_struct): use rb_class_inherited().

Thu Jan 10 19:15:15 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* eval.c (rb_add_method): should clear cache by id always.

	* eval.c (rb_disable_super): no longer need to clear cache before
	  rb_add_method().

	* eval.c (rb_export_method): ditto.

	* eval.c (rb_attr): ditto.

	* eval.c (rb_undef): ditto.

	* eval.c (rb_eval): ditto.

	* eval.c (rb_mod_modfunc): ditto.

	* eval.c (rb_mod_define_method): ditto.

Thu Jan 10 11:30:52 2002  Usaku Nakamura <usa@ruby-lang.org>

	* win32/resource.rb: Modify copyright in resource script.

Wed Jan  9 20:21:09 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* misc/ruby-mode.el (ruby-calculate-indent): indentation after
	  comment at beginning of buffer failed.

	* misc/ruby-mode.el (font-lock-defaults): unless XEmacs, set
	  font-lock variables in ruby-mode-hook.

Tue Jan  8 15:54:02 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* eval.c (rb_add_method): clear replaced method from the cache.

	* eval.c (rb_stack_check): should avoid stack length check during
	  raising SystemStackError exception.

Mon Jan  7 14:38:51 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* object.c (convert_type): backport from 1.7 to avoid NameError
	  messages with -d option.

Mon Jan  7 12:38:47 2002  Tanaka Akira  <akr@m17n.org>

        * lib/time.rb (Time#xmlschema): new optional argument 
	fractional_seconds to specify a number of digits of
	fractional part of the time.

Sat Jan  5 03:07:34 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_new2): NULL pointer check added.

Sat Jan  5 00:19:12 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* parse.y (yycompile): strdup()'ed twice.

Fri Jan  4 18:29:10 2002  Michal Rokos  <m.rokos@sh.cvut.cz>

	* class.c (rb_define_module_under): should locate predefined
	  module using rb_const_defined_at().

Fri Jan  4 17:23:49 2002  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* misc/ruby-mode.el (ruby-forward-string): forward a string. [new]

	* misc/ruby-mode.el (ruby-parse-region): handle nested parentheses
	  in a string and terminators in #{}.

	* misc/ruby-mode.el (ruby-calculate-indent): ditto.

Wed Jan  2 23:34:25 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* lib/mkmf.rb (create_makefile): add -I. to CPPFLAGS.

	* lib/mkmf.rb (create_makefile): srcdir support(.def and depend file).

Wed Jan  2 11:51:56 2002  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* process.c (rb_f_system): abandon vfork.

	* io.c (pipe_open): ditto.

Tue Jan  1 02:16:48 2002  WATANABE Hirofumi  <eban@ruby-lang.org>

	* Makefile.in (fake.rb): set RUBY_VERSION.

Mon Dec 31 14:20:46 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* parse.y (yycompile): always store copy of filename.

	* parse.y (rb_compile_file): no longer need to strdup() here.

Mon Dec 31 05:26:40 2001  Ferris McCormick  <fmccor@inforead.com>

	* defines.h: sparc linux needs different FLUSH_REGISTER_WINDOWS

Sun Dec 30 18:04:07 2001  Tanaka Akira  <akr@m17n.org>

	* time.c (time_utc_offset): new function.

	* time.c (Init_Time): new method gmtoff, gmt_offset and utc_offset.

	* lib/time.rb: new file.

Sun Dec 30 00:59:16 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/extmk.rb.in, lib/mkmf.rb (have_library): accept -lm
	  unconditionally on mswin32/mingw32.

Sat Dec 29 01:55:42 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* regex.c (re_search): abandon stclass optimization.

Thu Dec 27 18:43:04 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* bignum.c (rb_cstr2inum): deny "0_".

Thu Dec 27 01:54:02 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* bignum.c (rb_cstr2inum): allow "0\n" and so on.

Tue Dec 25 23:28:47 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* stable version 1.6.6 released.

Tue Dec 25 18:32:16 2001  K.Kosako  <kosako@sofnec.co.jp>

	* re.c (rb_reg_search): initialize taint status of match object.

Mon Dec 24 02:37:40 2001  Le Wang  <lewang@bigfoot.com>

	* misc/ruby-mode.el (ruby-font-lock-syntactic-keywords):
	  fix font-lock problem [ruby-talk:29296].

Fri Dec 21 20:33:34 2001  K.Kosako  <kosako@sofnec.co.jp>

	* parse.y (str_extend): make up "#$;" handling.

Fri Dec 21 16:18:17 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* dln.h, ruby.h, util.h: enable prototypes in C++.

Fri Dec 21 03:15:52 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* eval.c (rb_mod_define_method): must not convert Method to Proc.

Fri Dec 21 01:17:57 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* lib/mkmf.rb (with_destdir): new.

	* lib/mkmf.rb: prefix target directories with $(DESTDIR) all.

	* lib/mkmf.rb: no need to mkdir $(libdir)

Thu Dec 20 13:51:52 2001  K.Kosako  <kosako@sofnec.co.jp>

	* variable.c (rb_cvar_set): add frozen class/module check.

	* variable.c (rb_cvar_declare): add frozen class/module check.

Thu Dec 20 10:37:32 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* intern.h: added prototypes: rb_cv_set(), rb_cv_get(),
	  rb_define_class_variable()

Thu Dec 20 01:01:50 2001  takuma ozawa  <metal@mine.ne.jp>

	* re.c (match_to_a): should propagate taint.

	* re.c (rb_reg_s_quote): ditto.

Wed Dec 19 14:05:00 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_mod_define_method): define_method should follow
	  default method visibility.

	* eval.c (rb_attr): should warn if the default method visibility
	  is "module_function" (can be error). 

	* eval.c (rb_mod_define_method): should define class/module method
	  also if the visibility is "module_function".

	* eval.c (rb_mod_define_method): should call hook method
	  "method_added", and "singleton_method_added".

Tue Dec 18 01:02:13 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_thread_schedule): should not select a thread which is
	  not yet initialized.

Mon Dec 17 17:06:56 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* intern.h: add prototypes.
	  rb_str_dup_frozen()

	* ruby.h: added declaration.
	  rb_defout, rb_stdin, rb_stdout, rb_stderr, ruby_errinfo

	* rubyio.h: changed double include guard macro to RUBYIO_H.

	* array.c (inspect_call): make static.

	* eval.c (dvar_asgn): ditto.

	* io.c (rb_io_close_read): ditto.

	* lex.c (rb_reserved_word): ditto.

	* ruby.c: (req_list_head, req_list_last): ditto.

	* ruby.c (require_libraries): ditto.

Mon Dec 17 00:02:04 2001  Guy Decoux  <ts@moulon.inra.fr>

	* variable.c (find_class_path): should initialize iv_tbl if it's
	  NULL.

Fri Dec 14 00:16:06 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* class.c (rb_define_class): should return the existing class if
	  the class is already defined and its superclass is ideintical to
	  the specified superclass.

	* class.c (rb_define_class_under): ditto.

	* class.c (rb_define_module): should return the existing module if
	  the module is already defined.

Thu Dec 13 10:03:18 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* time.c (time_cmp): should handle Bignums.

Mon Dec 10 17:40:02 2001  K.Kosako  <kosako@sofnec.co.jp>

	* parse.y (str_extend): make up pushback call.

Mon Dec 10 01:06:56 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (gettable): should freeze __FILE__ string.

Sun Dec  9 23:00:54 2001  Keiju Ishitsuka <keiju@ishitsuka.com>
	* matrix.rb: Vector#* bug. reported from Massimiliano Mirra
	<info@chromatic-harp.com>. 

Sun Dec  9 18:06:05 2001  Minero Aoki  <aamine@loveruby.net>

	* lib/net/protocol.rb: calls on_connect before conn_command

Fri Dec  7 19:20:44 2001  Minero Aoki  <aamine@loveruby.net>

	* lib/net/smtp.rb: uses Digest::MD5 instead of MD5 (again).

	* lib/net/pop.rb: ditto.

	* lib/net/http.rb (HTTP#request): must pass block.

Fri Dec  7 18:47:54 2001  Minero Aoki  <aamine@loveruby.net>

	* lib/net/smtp.rb: SMTP.new requires at least one arg.

	* lib/net/pop.rb: POP.new requires at least one arg.

	* lib/net/pop.rb: uses "raise *Error.new" instead of simple raise.

	* lib/net/http.rb: HTTP.new requires at least one arg.

	* lib/net/http.rb: changes implicit start algolithm.

Fri Dec  7 15:52:05 2001  Usaku Nakamura <usa@ruby-lang.org>

	* ext/extmk.rb.in: ignore adding -Wl,-R to DLDFLAGS when the directory
	  is $topdir.

Fri Dec  7 09:51:00 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (str_extend): should not process immature #$x and
	  #@x interportation, e.g #@#@ etc.

Thu Dec  6 18:55:01 2001  Usaku Nakamura  <usa@ruby-lang.org>

	* ext/extmk.rb.in: add -Wl,-R flags to DLDFLAGS on netbsdelf.

	* lib/mkmf.rb: ditto.

Wed Dec  5 23:36:56 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* regex.c (WC2MBC1ST): should not pass through > 0x80 number in UTF-8.

Wed Dec  5 20:05:18 2001  Florian Frank  <flori@ping.de>

	* ext/socket/socket.c (bsock_send): should raise EWOULDBLOCK
	  exception.

	* ext/socket/socket.c (s_recvfrom): ditto.

	* ext/socket/socket.c (s_accept): ditto.

	* ext/socket/socket.c (udp_send): ditto.

Tue Dec  4 03:49:06 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (io_fread): EAGAIN/EWOULDBLOCK should not terminate and
	  throw away the input.

	* time.c (time_new_internal): underflow adjustment must not use
	  negative div/mod.

	* time.c (time_cmp): should consider tv_usec on non Fixnum number
	  comparison.

Mon Dec  3 16:06:57 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/socket/extconf.rb: remove -L/usr/local/lib.

	* configure.in: add -Wl,-export-dynamic on NetBSD.

Mon Dec  3 16:06:04 2001  Usaku Nakamura <usa@ruby-lang.org>

	* configure.in: not use X11BASE, since it's not always set.

Mon Dec  3 13:53:49 2001  Tanaka Akira  <akr@m17n.org>

	* time.c (rb_strftime): buffer length condition was wrong.

	* time.c (time_strftime): should backup buf to the original
	  buffer.

Mon Dec  3 09:59:08 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* time.c (time_new_internal): round usec overflow and underflow
	  here. 

	* time.c (time_plus): remove overflow/underflow check.

	* time.c (time_minus): ditto.

	* time.c (time_cmp): should consider tv_usec too.

Mon Dec  3 03:29:17 2001  Usaku Nakamura  <usa@ruby-lang.org>

	* configure.in: apply patch from NetBSD's pkgsrc (patch-aa).

Sun Dec  2 22:01:52 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in: use GCC, not without_gcc. remove without_gcc.

	* ext/curses/extconf.rb: check for curses.h.

Sat Dec  1 23:23:57 2001  Akinori MUSHA  <knu@iDaemons.org>

	* ext/Setup*, ext/syslog/*: import the "syslog" module from the
	  rough ruby project.

Sat Dec  1 12:13:20 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* time.c (time_gmtime): time_modify() should be called even if tm
	  struct is not calculated yet.

Fri Nov 30 00:30:00 2001  Usaku Nakamura  <usa@ruby-lang.org>

	* README.EXT: Appendix B is duplicated.

	* README.EXT.ja: ditto.

Thu Nov 29 00:28:07 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_equal): object with to_str must be treated as a
	  string.

Wed Nov 28 18:46:28 2001  Ville Mattila  <mulperi@iki.fi>

	* eval.c (rb_thread_select): should subtract timeofday() from
	  limit, not reverse.

Wed Nov 28 16:03:28 2001  K.Kosako  <kosako@sofnec.co.jp>

	* util.c (scan_hex): x is not a hexadecimal digit.

Wed Nov 28 13:38:04 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_thread_schedule): should treat the case that
	  select(2) returns 0, if a thread is under both WAIT_SELECT and
	  WAIT_TIME.  Jakub Travnik <J.Travnik@sh.cvut.cz> actually fixed
	  this bug.

Sun Nov 25 21:03:43 2001  Usaku Nakamura  <usa@ruby-lang.org>

	* parse.y (str_extend): change types of second and third arguments
	  from char to int.

Fri Nov 23 03:13:49 2001  Usaku Nakamura  <usa@ruby-lang.org>

	* process.c (Init_process): enable getpid and getppid on NT.
	  (ruby-bugs-ja:PR#152)

Thu Nov 22 00:28:13 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (str_extend): should check nesting parentheses in #{}.

Wed Nov 21 00:17:54 2001  Ville Mattila  <mulperi@iki.fi>

	* eval.c (rb_thread_select): tv_sec and tv_usec should not be
	  negative.

	* signal.c (posix_signal): do not set SA_RESTART for SIGVTALRM.

Tue Nov 20 01:07:13 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (str_extend): should not terminate string interpolation
	  with newlines in here-docs and newline terminated strings.

Mon Nov 19 14:14:58 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (str_extend): term can be any character.

Mon Nov 19 04:58:42 2001  Wakou Aoyama  <wakou@fsinet.or.jp>

	* lib/cgi.rb (header): support for Apache. thanks to
	  Shugo Maeda <shugo@ruby-lang.org>.

Mon Nov 19 01:58:14 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (parse_regx): should raise error on untermitated
	  expression interpolation.

Sun Nov 18 19:37:55 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* parse.y: needless conditional.

	* parse.y (parse_regx): parse error at unterminated regex /#{.
	  (ruby-bugs-ja:PR#142)

Sat Nov 17 12:37:39 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* pack.c (pack_unpack): should give length to utf8_to_uv().

	* pack.c (utf8_to_uv): add length check.

Sat Nov 17 01:41:52 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_thread_wait_for): select may cause ERESTART on
	  Solaris.

	* eval.c (rb_thread_select): ditto.

Tue Nov 13 19:50:30 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in: do not override CC if set.

Tue Nov 13 17:25:44 2001  Usaku Nakamura <usa@ruby-lang.org>

	* hash.c (envix): merge from 1.7: use GET_ENVIRON and FREE_ENVIRON to
	  get environment variables list.

	* hash.c (env_keys): ditto.

	* hash.c (env_each_key): ditto.

	* hash.c (env_values): ditto.

	* hash.c (env_keys): ditto.

	* hash.c (env_each_value): ditto.

	* hash.c (env_each): ditto.

	* hash.c (env_inspect): ditto.

	* hash.c (env_to_a): ditto.

	* hash.c (env_size): ditto.

	* hash.c (env_empty_p): ditto.

	* hash.c (env_has_value): ditto.

	* hash.c (env_index): ditto.

	* hash.c (env_to_hash): ditto.

	* win32/win32.c (win32_getenv): merge from 1.7: use static buffer.

	* win32/win32.c, win32/win32.h (win32_get_environ): merge from 1.7:
	  get environment variables list.

	* win32/win32.c, win32/win32.h (win32_free_environ): merge from 1.7:
	  free environment variables list.

	* win32/Makefile.sub: merge from 1.7: add -DLIBRUBY_SO to CPPFLAGS.

Tue Nov 13 14:39:11 2001  WATANABE Tetsuya  <tetsu@jpn.hp.com>

	* signal.c (sighandle): should not re-register sighandler if
	  POSIX_SIGNAL is defined.

Mon Nov 12 16:48:48 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (error_print): errat array may be empty.

Sat Nov 10 00:14:24 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (yylex): float '1_.0' should not be allowed.

	* variable.c (var_getter): should care about var as Qfalse
	  (ruby-bugs#PR199).

Fri Nov  9 13:52:18 2001  Usaku Nakamura <usa@ruby-lang.org>

	* win32/config.status.in: make CFLAGS same as Makefile's one.

Thu Nov  8 20:20:37 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* eval.c (rb_trap_eval): avoid annoying warning with signal.
	  [ruby-talk:23225]

	* eval.c (rb_call0): adjust caller source file/line while
	  evaluating optional arguments.

Thu Nov  8 18:41:58 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* array.c (cmpint): <=> or block for {min,max} may return bignum.

	* array.c (sort_1): use rb_compint.

	* array.c (sort_2): ditto.

	* enum.c (min_ii): ditto.

	* enum.c (min_ii): ditto.

	* enum.c (max_i): ditto.

	* enum.c (max_ii): ditto.

Thu Nov  8 14:52:15 2001  Tanaka Akira  <akr@m17n.org>

	* mkconfig.rb: use String#dump to generate Ruby string literal.

Thu Nov  8 15:46:54 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* range.c (range_eql): should override 'eql?'

Tue Nov  6 14:38:48 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* dir.c (my_getcwd): do not rely on MAXPATHLEN.

Mon Nov  5 17:09:55 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_yield_0): should not call rb_f_block_given_p().

Sat Nov  3 22:28:51 2001  Keiju Ishitsuka <keiju@ishitsuka.com>

	* forwardable.rb: change raise to Kernel::raise
	
	* matrix.rb (Matrix#column_vectors, Matrix#row_vectors): ditto bug. 
	  this bug report and fix by tsutomu@nucba.ac.jp.
	
Thu Nov  1 14:08:42 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (rb_big_aref): idx may be a Bignum.

	* numeric.c (fix_aref): negative index must return zero.

Wed Oct 31 16:59:25 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (exec_under): should initialize ruby_frame->self;

Wed Oct 31 15:09:28 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (POP_VARS): should not set DVAR_DONT_RECYCLE if _old
	  ruby_vars is already force_recycled.

Wed Oct 31 02:44:06 2001  Wakou Aoyama  <wakou@fsinet.or.jp>

	* lib/cgi.rb: CGI::Cookie::parse(): Ignore duplicate keys caused by
	  Netscape bug.

Tue Oct 30 14:04:04 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_f_eval): can't modify untainted binding.

Mon Oct 29 16:08:30 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* regex.c (re_compile_pattern): should preverve p0 value.

Mon Oct 29 07:57:31 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (str_extend): shuould allow interpolation of $-x.

Sat Oct 27 23:01:19 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (rb_big_eq): convert Bignum to Float, instead of
	  reverse.

Fri Oct 26 06:19:29 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* time.c (time_localtime): getting tm should not be prohibited for
	  frozen time objects.

	* time.c (time_gmtime): ditto.

	* version.c (Init_version): freeze RUBY_VERSION,
	  RUBY_RELEASE_DATE, and RUBY_PLATFORM.

	* file.c (Init_File): freeze File::SEPARATOR, ALT_SEPARATOR and
	  PATH_SEPARATOR.

	* file.c (rb_stat_cmp): should check operand type before calling
	  get_stat().

Thu Oct 25 10:28:15 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_eval_cmd): should not invoke "call" with a block on
	  any occasion.

Wed Oct 24 03:25:31 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* numeric.c (fix_aref): idx may be a Bignum.

Mon Oct 22 18:53:55 2001  Masahiro Tanaka  <masa@stars.gsfc.nasa.gov>

	* numeric.c (num_remainder): a bug in Numeric#remainder.

Mon Oct 22 15:21:55 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_exec_end_proc): END might be called within END
	  block.

Fri Oct 19 23:40:37 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* variable.c (remove_trace): should not access already freed area.

	* variable.c (rb_f_untrace_var): fix memory leak.

Tue Oct 16 21:38:15 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* eval.c (rb_f_missing): check stack level with rb_stack_check().

	* eval.c (rb_call0): ditto.

	* eval.c, intern.h (rb_stack_check): added. [new]

Tue Oct 16 00:07:06 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* parse.y (yylex): disallow alpha-numeric and mbchar for
	  terminator of %string.

Mond Oct 15 18:00:05 2001  Pit Capitain  <pit@capitain.de>

	* string.c (rb_str_index): wrong increment for non alphanumeric
	  string.

Wed Oct 10 03:11:47 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (parse_quotedwords): %w(...) is not a string.

Tue Oct  9 17:08:00 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* eval.c (thread_status_name): separated from
	  rb_thread_inspect(). return string expression for thread status.

	* eval.c (rb_thread_status, rb_thread_inspect): use
	  thread_status_name().

	* eval.c (rb_thread_priority_set): return the priority not but
	  self.

Sat Oct  6 23:07:08 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_eval): NODE_MATCH3 was confusing left and right. sigh.

Fri Oct  5 15:27:30 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* marshal.c: backport from 1.7 marshal.c

Thu Oct  4 14:11:03 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/socket/socket.c (ruby_connect): EALREADY is the equivalent
	  for EINPROGRESS in ws2_32.lib.

Wed Oct  3 13:32:06 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_aset): should maintain original negative
	  offset.

	* string.c (rb_str_aset_m): ditto.

	* re.c (rb_reg_nth_match): should check negative nth.

	* re.c (rb_reg_nth_defined): ditto.

Tue Oct  2 19:12:47 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* lib/ftools.rb (catname): allow trailing '/' for the destination.

Tue Oct  2 18:31:20 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_eval): should override existing class.

Mon Oct  1 19:18:54 2001  Tanaka Akira  <akr@m17n.org>

	* ext/socket/socket.c (unix_addr): getsockname(2) may result len = 0. 

	* ext/socket/socket.c (unix_peeraddr): getpeername(2) may result
	  len = 0.

Sat Sep 29 02:30:06 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (POP_BLOCK): rb_gc_force_recycle() was called too much.
	  Should not be called if SCOPE_DONT_RECYCLE is set.

Thu Sep 27 09:04:44 2001  Guy Decoux  <ts@moulon.inra.fr>

	* parse.y: allow 'primary[] += arg'

Tue Sep 25 10:42:46 2001  Usaku Nakamura  <usa@ruby-lang.org>

	* win32/win32.c (isInternalCmd): check return value of NtMakeCmdVector
	  (Tietew <tietew@tietew.net>'s patch).

Mon Sep 24 00:55:06 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_substr): should return an instance of
	  receiver's class.

	* string.c (rb_str_succ): ditto.

	* array.c (rb_ary_subseq): ditto.

Sat Sep 22 22:16:08 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_reverse): should return an instance of
	  reciever's class.

	* string.c (rb_str_times): ditto.

	* array.c (rb_ary_times): ditto

	* string.c (str_gsub): ditto.

	* string.c (rb_str_ljust): ditto.

	* string.c (rb_str_rjust): ditto.

	* string.c (rb_str_center): ditto.

Wed Sep 19 17:46:42 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* stable version 1.6.5 released.

Sat Sep  8 07:13:42 2001  Wakou Aoyama  <wakou@fsinet.or.jp>

	* lib/net/telnet.rb: waitfor(): improvement. thanks to
	  nobu.nakada@nifty.ne.jp

Sat Sep  8 04:34:17 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_thread_restore_context): save current value of
	  lastline and lastmatch in the thread struct for later restore.

	* eval.c (rb_thread_save_context): restore lastline and lastmatch.

Fri Sep  7 11:27:56 2001  akira yamada  <akira@ruby-lang.org>

	* numeric.c (flo_to_s): should handle negative float value.

Fri Sep  7 09:44:44 2001  Wakou Aoyama  <wakou@fsinet.or.jp>

	* lib/net/telnet.rb: waitfor(): bug fix.

Fri Sep  7 07:11:34 2001  Wakou Aoyama  <wakou@fsinet.or.jp>

	* lib/cgi.rb: CGI#doctype(): bug fix (html4Fr).

	* lib/net/telnet.rb, lib/cgi.rb: remove VERSION, RELEASE_DATE,
	  VERSION_CODE, RELEASE_CODE. please use REVISION.

	* lib/cgi.rb: CGI#header(): bug fix.

	* lib/net/telnet.rb, lib/cgi.rb: concat --> +=

Thu Sep  6 17:38:18 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* dir.c (dir_s_chdir): raise if environment variable HOME/LOGDIR
	  not set.

	* dir.c (glob_helper): avoid infinite loop on a file name with
	  wildcard characters. (ruby-bugs#PR177)

Thu Sep  6 03:15:24 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* class.c (rb_include_module): should check whole ancestors to
	  avoid duplicate module inclusion.

Thu Sep  6 14:27:54 2001  Akinori MUSHA  <knu@iDaemons.org>

	* ext/digest/digest.c (rb_digest_base_s_hexdigest): remove a debug
	  print.

Thu Sep  6 14:00:49 2001  Akinori MUSHA  <knu@iDaemons.org>

	* ext/digest/digest.c (rb_digest_base_s_digest,
	  rb_digest_base_s_hexdigest): ensure that a string is given.

Thu Sep  6 13:28:51 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* lib/jcode.rb (_regexp_quote): fix quote handling, again.

Thu Sep  6 12:02:49 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* file.c (rb_find_file_ext): add const qualifiers to ext.

	* intern.h (rb_find_file_ext): ditto.

Wed Sep  5 17:41:11 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* lib/jcode.rb (_regexp_quote): fix quote handling.

Wed Sep  5 20:02:27 2001  Shin'ya Adzumi  <adzumi@denpa.org>

	* string.c (trnext): should check backslash before updating "now"
	  position.

Mon Sep  3 20:26:08 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* intern.h (rb_find_file_ext): changed from rb_find_file_noext().

Mon Sep  3 15:12:49 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ruby.c (proc_options): should not adjust argc/argv if -e option
	  is supplied.

Mon Sep  3 14:38:24 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* eval.c (rb_f_require): should check static linked libraries
	  before raising exception(from 1.7).

Mon Sep  3 14:17:17 2001  Akinori MUSHA  <knu@iDaemons.org>

	* error.c: unbreak the build on *BSD with gcc 3.0.1 by removing
	  the conflicting declaration of sys_nerr for *BSD.

Sat Sep  1 09:50:54 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* ruby.c (set_arg0): prevent SEGV when val is longer than the
	  original arguments.

	* ruby.c (ruby_process_options): initialize total length of
	  original arguments at first.

Sat Sep  1 03:49:11 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (rb_io_popen): accept integer flags as mode.

Fri Aug 31 19:46:05 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* file.c (rb_find_file_ext): extension table can be supplied from
	  outside.  renamed.

	* eval.c (rb_f_require): replace rb_find_file_noext by
	  rb_find_file_ext.

Fri Aug 31 19:26:55 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* eval.c (rb_provided): should also check feature without
	  extension.

Fri Aug 31 13:06:33 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* numeric.c (flo_to_s): do not rely on decimal point to be '.'

Wed Aug 29 02:18:53 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (yylex): ternary ? can be followed by newline.

Mon Aug 27 07:32:23 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* dir.c (rb_glob_helper): merge from 1.7: traversed files twice
	  with pattern "*/**".  don't descend to non-existing directories.

Fri Aug 24 15:17:40 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* array.c (rb_ary_equal): check identiry equality first.

	* string.c (rb_str_equal): ditto.

	* struct.c (rb_struct_equal): ditto.

Fri Aug 24 14:45:26 2001  Usaku Nakamura  <usa@ruby-lang.org>

	* dln.c (dln_strerror): fix a bug that sometimes made null message on
	  win32 (Tietew <tietew@tietew.net>'s patch).

	* win32/win32.c (mystrerror): ditto.

Fri Aug 24 03:15:07 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* numeric.c (Init_Numeric): undef Integer::new.

Thu Aug 23 10:10:59 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (is_defined): should not dump core for "defined?(())".

	* eval.c (umethod_bind): recv can be an instance of descender of
	  oklass if oklass is a Module.

Wed Aug 22 23:20:03 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* hash.c (rb_hash_equal): check identiry equality first.

Mon Aug 20 19:53:16 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/digest/sha2/extconf.rb: fix support for cross-compiling.

	* mkconfig.rb: fix support for autoconf 2.52.

Mon Aug 20 16:09:05 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* variable.c (mod_av_set): detect constant overriding for built-in
	  classes/modules.

Mon Aug 20 12:43:08 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* marshal.c (w_object): should retrieve __member__ data from
	  non-singleton class.

Wed Aug 17 13:55:33 2001  Usaku Nakamura  <usa@ruby-lang.org>

	* win32/Makefile.sub: merge from 1.7: use del instead of rm.

Fri Aug 17 00:49:51 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (parse_regx): handle backslash escaping of delimiter here.

Thu Aug 16 23:03:40 2001  Koji Arai  <JCA02266@nifty.ne.jp>

       * io.c: prevent recursive malloc calls on NEC UX/4800.

       * ext/socket/socket.c: ditto.

Thu Aug 16 19:53:19 2001  Akinori MUSHA  <knu@iDaemons.org>

	* lib/resolv.rb, lib/resolv-replace.rb: Copy from 1.7.

Thu Aug 16 16:32:21 2001  Akinori MUSHA  <knu@iDaemons.org>

	* LEGAL, ext/Setup*, ext/digest/*: Merge from 1.7: Import digest
	  modules.

	* ext/md5/*: Move to ext/digest/md5.

Thu Aug 16 03:54:36 2001  Usaku Nakamura  <usa@ruby-lang.org>

	* lib/mkmf.rb: add -I$(srcdir) to CPPFLAGS.

Tue Aug 14 11:49:00 2001  TOYOFUKU Chikanobu  <toyofuku@juice.or.jp>

	* string.c (rb_str_cmp): remove needless conditional.

Sat Aug 11 23:08:01 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* object.c (rb_obj_inspect): merge from 1.7: remove useless space.

Sat Aug 11 14:43:47 2001  Tanaka Akira  <akr@m17n.org>

	* array.c (rb_inspecting_p): initialize inspect_key if it is
	  not initialized yet.

Tue Aug  7 09:12:55 2001  Usaku Nakamura  <usa@ruby-lang.org>

	* win32/win32.h: fix problems with BC++ (ruby-bugs#PR161).

Mon Aug  6 17:01:33 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_mark_end_proc): should mark ruby_cref, maybe should
	  not be here, but it's simplest way for a kludge.

Mon Aug  6 00:35:03 2001  Guy Decoux  <decoux@moulon.inra.fr>

	* struct.c (rb_struct_modify): should check frozen and taint
	  status.

Sun Aug  5 07:46:18 2001  Nobuyoshi Nakada <nobu.nakada@nifty.ne.jp>

	* eval.c (rb_undefined): do not recurse if method_missing is
	  undefined.

Wed Aug  1 20:45:14 2001  Usaku Nakamura  <usa@ruby-lang.org>

	* win32/Makefile.sub: changed path separator of $LIB to '\'.

Tue Jul 31 12:55:35 2001  Nobuyoshi.Nakada <nobu.nokada@softhome.net>  <nobu.nakada@nifty.ne.jp>

	* file.c (rb_file_s_expand_path): expanded path should not end
	  with "/.".
	  removed meaningless code.

Tue Jul 31 11:52:10 2001  akira yamada  <akira@ruby-lang.org>

	* marshal.c (marshal_load): ruby_verbose test should be wrapped by
	  RTEST().

Mon Jul 30 17:54:23 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* hash.c (rb_hash_index): should return nil (not the default
	  value) if value is not in the hash.

Mon Jul 30 03:19:53 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (rb_cstr2inum): "0 ff".hex should return 0, not 255.

Fri Jul 27 18:07:27 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_provided): extension should be guessed using
	  rb_find_file_noext().

	* eval.c (rb_f_require): should call rb_feature_p() after
	  extension completion.

Fri Jul 27 16:25:52 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_eval): add CHECK_INTS before next, redo, retry to
	  avoid potential uninterruptable infinite loop.

Thu Jul 26 11:27:12 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* file.c (rb_find_file_noext, rb_find_file): fix tilde expansion
	  problem.

Wed Jul 25 15:50:05 2001  Guy Decoux  <decoux@moulon.inra.fr>

	* file.c (rb_file_s_expand_path): should not expand "." and ".."
	  not following dirsep.

Wed Jul 25 12:15:32 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* file.c (rb_find_file_noext): should update f by expanded path.

	* file.c (rb_find_file): ditto.

Tue Jul 24 19:28:23 2001  Akinori MUSHA  <knu@iDaemons.org>

	* ext/extmk.rb.in, lib/mkmf.rb: dig the target subdirectory for
	  lib/* files properly in case of create_makefile("dir/name").

Mon Jul 23 00:26:04 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_provide_feature): should not tweak extension used for
	  loading.

Sun Jul 22 21:23:00 2001  Akinori MUSHA  <knu@iDaemons.org>

	* ext/extmk.rb.in, lib/mkmf.rb: introduce a couple of new make
	  variables: CLEANFILES and DISTCLEANFILES.  They'd typically be
	  defined in a file "depend".

Sat Jul 21 00:19:54 2001  Akinori MUSHA  <knu@iDaemons.org>

	* gc.c (ruby_xrealloc): fix a dangling bug which led memory
	  reallocation to fail even though the second try after a GC
	  succeeds.

Fri Jul 20 22:35:23 2001  Usaku Nakamura  <usa@osb.att.ne.jp>

	* win32/config.h.in: merge from 1.7: add SIZEOF___INT64 definition.

	* win32/config.status.in: merge from 1.7: add ENABLE_SHARED = yes.

Thu Jul 19 19:16:50 2001 Stephen White <spwhite@chariot.net.au>

	* lib/irb/input-method.rb: patch to irb to remove blank lines from
	  the readline history buffer.
	
Thu Jul 19 13:03:15 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* eval.c (rb_f_require): should not include path in $" value

	* file.c (rb_find_file): should return 0 explicitly on failure.

Sun Jul 19 06:01:12 2001  Minero Aoki  <aamine@loveruby.net>

	* doc/net/smtp.rd.ja, pop.rd.ja, http.rd.ja: new files.

Tue Jul 17 11:22:01 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* regex.c (NUM_FAILURE_ITEMS): was confusing NUM_REG_ITEMS and
	  NUM_NONREG_ITEMS, which have happened to be same value.

Tue Jul 17 11:18:42 2001  Usaku Nakamura  <usa@osb.att.ne.jp>

	* ext/extmk.rb.in: modify RM macro because command.com/cmd.exe don't
	  recognize single quotation as quote character.

	* lib/mkmf.rb: ditto.

Mon Jul 16 12:58:07 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (proc_invoke): should preserve iter status for embedded
	  frame in the block.

Mon Jul 16 00:04:39 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* file.c (rb_file_s_expand_path): may overrun buffer on stack.

Sat Jul 14 06:25:00 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* lib/net/http.rb: HTTP#proxy? did not worked.

Sat Jul 14 02:56:19 2001  Akinori MUSHA  <knu@iDaemons.org>

	* ext/extmk.rb.in: support multi-level ext/ directories.
	  (e.g. you can have ext/foo, ext/foo/bar and ext/foo/baz)

Sat Jul 14 02:55:02 2001  Akinori MUSHA  <knu@iDaemons.org>

	* ext/.cvsignore: let cvs ignore extinit.c.

Fri Jul 13 23:47:35 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* regex.c (re_search): should consider reverse search.

Fri Jul 13 23:18:19 2001  Akinori MUSHA  <knu@iDaemons.org>

	* lib/mkmf.rb: use File::split to split a target into a prefix and
	  a module name.  This also works around a just found bug of
	  String#rindex.

	* ext/extmk.rb.in: ditto.

Fri Jul 13 19:25:16 2001  Akinori MUSHA  <knu@iDaemons.org>

	* missing/strstr.c, missing/strtol.c: Merge from 1.7: replace with
	  public-domain ones.

Thu Jul 12 15:11:48 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/socket/socket.c (ruby_connect): workaround for the setup of
	  Cygwin socket(EALREADY).

Mon Jul  9 16:49:30 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/extmk.rb.in: modify RM macro.
	
	* lib/mkmf.rb: ditto.

Sun Jul  8 20:54:19 2001  Akinori MUSHA  <knu@iDaemons.org>

	* ruby.h: fix a wrong function name: rb_iglob() -> rb_globi().

Sun Jul  8 16:05:36 2001  Minero Aoki  <aamine@loveruby.net>

	* lib/net/protocol.rb (ProtoSocket#read): modify typo.

Fri Jul  6 18:01:10 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* object.c (rb_obj_dup): should free generic_ivar if original owns
	  them.

Fri Jul  6 15:11:38 2001  Akinori MUSHA  <knu@iDaemons.org>

	* lib/tempfile.rb: merge from 1.7: do not delete a used tempfile
	  from children processes.

	* lib/tempfile.rb: merge from 1.7: do not change the umask so as
	  not to affect other threads' file creation.  specify a file mode
	  (0600) when creating a tempfile instead.

Fri Jul  6 00:49:05 2001  Akinori MUSHA  <knu@iDaemons.org>

	* ext/readline/readline.c (readline_event): merge from 1.7: a
	  non-void function should return a value.

	* ext/readline/readline.c: merge from 1.7: add new methods:
	  Readline::completion_append_character and
	  Readline::completion_append_character=.

	* ext/readline/README, ext/readline/README.jp: merge from 1.7: add
	  an English version of the document.

Thu Jul  5 22:53:27 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* eval.c (rb_f_require): move rb_file_s_expand_path from
	  rb_find_file_noext().

	* file.c (rb_find_file_noext): move rb_file_s_expand_path to
	  rb_f_require(). 

Thu Jul  5 22:01:02 2001  Mitsuhiro Kondo  <kondo@nik-prt.co.jp>

	* dln.c (dln_load): should use NSLINKMODULE_OPTION_BINDNOW.

Thu Jul  5 20:28:53 2001  Tietew <tietew@tietew.net>

	* string.c (rb_str_each_line): should propagate taint mark. 

	* ext/nkf/nkf.c (rb_nkf_kconv): ditto.

Thu Jul  5 13:44:03 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ruby.c (load_file): local variables 'c' remain uninitialized on
	  xflag.

Thu Jul  5 10:00:59 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* regex.c (re_match): prefetched escaped character too early.

Wed Jul  4 08:58:30 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_call0): add argument check for attr_readers.

Wed Jul  4 00:12:37 2001  Akinori MUSHA  <knu@iDaemons.org>

	* lib/find.rb: merge from 1.7: rescue Errno::EACCES as well.

Wed Jul  4 00:09:16 2001  Akinori MUSHA  <knu@iDaemons.org>

	* lib/mathn.rb: merge from 1.7: add Rational#inspect().

Wed Jul  4 00:01:36 2001  Akinori MUSHA  <knu@iDaemons.org>

	* lib/mkmf.rb: distclean should remove mkmf.log as well.

Mon Jul  2 09:53:12 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_eval_string_wrap): extend new ruby_top_self, not
	  original self.

	* eval.c (rb_eval_cmd): respect ruby_wrapper if set.

	* eval.c (eval): do not update ruby_class unless scope is not
	  provided.

Sun Jul  1 10:51:15 2001  Shugo Maeda <shugo@ruby-lang.org>

	* eval.c (eval): preserve wrapper information.

	* eval.c (proc_invoke): ditto.

	* eval.c (block_pass): ditto.

Sat Jun 30 02:55:45 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (void_expr): too much warnings for void context
	  (e.g. foo[1] that can be mere Proc call).

Fri Jun 29 15:29:31 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lex.c (rb_reserved_word): lex_state after tRESCUE should be
	  EXPR_MID.

Thu Jun 28 00:36:19 2001 Keiju Ishitsuka <keiju@ishitsuka.com>
	
	* lib/matrix.rb: resolve 'ruby -w' warnings.

	* lib/irb/locale.rb: resolve 'ruby -w' warnings.

	* lib/irb/multi-irb.rb: resolve 'ruby -w' warnings.

	* lib/irb/ruby-lex.rb: fix problem for "\\M-\\..." and "\\C-\\..."
	  and resolve 'ruby -w' warnings.  

	* lib/irb/ruby-token.rb: fix typo

	* lib/shell/command-processor.rb: resolve 'ruby -w' warnings.
	
Wed Jun 27 08:53:04 2001  Minero Aoki  <aamine@loveruby.net>

	* lib/net/pop.rb: new methods POP3.auth_only, POP3#auth_only

	* lib/net/http.rb: HTTP.Proxy returns self if ADDRESS is nil.

	* lib/net/protocol.rb: new method ProtocolError#response

	* lib/net/protocol.rb,smtp.rb,pop.rb,http.rb: add document.

Tue Jun 26 18:42:42 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* gc.c (add_heap): allocation size of the heap unit is doubled for
	  each allocation.

Sat Jun 23 19:25:08 2001  Akinori MUSHA  <knu@iDaemons.org>

	* lib/thread.rb: Synchronize with HEAD.  The last change
	  (rev.1.9.2.2) against SizedQueue#max= was wrong and didn't fix
	  the bug in question.

Fri Jun 22 23:17:28 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/socket/socket.c (ruby_connect): workaround for the setup of
	  Cygwin socket.

Fri Jun 22 22:54:33 2001  Keiju Ishitsuka <keiju@ishitsuka.com>

	* lib/irb/locale.rb: fix for require "kconv" problem
	
Fri Jun 22 17:12:23 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* st.c (new_size): prime hash size enabled.

	* ext/socket/socket.c (Init_socket): SO_* constants added.

Tue Jun 19 22:24:07 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* gc.c (rb_setjmp): avoid GCC 3.0 warnings.

Mon Jun 18 17:38:50 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_f_require): searches ".rb" and ".so" at the same
	  time.  previous behavior (search ".rb", then ".so") has a
	  security risk (ruby-bugs#PR140).

Mon Jun 18 00:43:20 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* regex.c (re_compile_pattern): avoid pushing unnecessary
	  option_set.

Sat Jun 16 10:58:48 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_load): tainted string is OK if wrapped *and*
	  $SAFE >= 4.

Thu Jun 14 16:27:07 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_thread_start_0): should not nail down higher blocks
	  before preserving original context (i.e. should not alter
	  original context).

Tue Jun 12 14:24:02 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* lib/mkmf.rb: target_prefix is only for installation, not for
	  build.

Mon Jun 11 14:29:41 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* confgure.in: add RUBY_CANONICAL_BUILD.

Sat Jun  9 17:04:30 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* hash.c (ruby_setenv): readline library leaves their environment
	  strings uncopied.  "free" check revised.

Fri Jun  8 18:14:12 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* st.c (numhash): should shuffle bits by dividing by prime number.

Fri Jun  8 22:37:40 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* gc.c (Init_stack): avoid __builtin_frame_address(2) to retrieve
	  stack bottom line.

Fri Jun  8 18:14:12 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* st.c (numhash): should shuffle bits by dividing by prime number.

Fri Jun  8 15:25:09 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_f_require): should set SCOPE_PUBLIC before calling
	  dln_load().

Wed Jun  6 16:11:06 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_load): should check if tainted even when wrap is
	  specified.

Wed Jun  6 14:34:27 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* regex.c (re_compile_pattern): too much optimization for the
	  cases like /(.|a)b/.

Tue Jun  5 23:58:43 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* variable.c (fc_i): removed vast string allocation.

Tue Jun  5 15:16:06 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_add_method): should not call rb_secure(), for
	  last_func may not be set.

	* io.c (rb_io_ctl): ioctl should accept any integer within C long
	  range.

Tue Jun  5 13:41:13 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/etc/extconf.rb: use egrep_cpp.

Tue Jun  5 12:44:59 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* marshal.c (r_object): wrong type check for modules.

	* marshal.c (w_object): should not dump anonymous classes/modules.

Mon Jun  4 17:57:56 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* stable version 1.6.4 released.

Mon Jun  4 04:14:53 2001  Wakou Aoyama  <wakou@fsinet.or.jp>

	* lib/shellwords.rb: don't destroy argument.

Sat Jun  2 23:23:05 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* regex.c (re_compile_pattern): should push option modifier at the
	  right place.

Sat Jun  2 23:05:20 2001  Shugo Maeda <shugo@ruby-lang.org>

	* lib/cgi/session.rb: don't use module_function for Class.

Sat Jun  2 00:02:22 2001  Keiju Ishitsuka <keiju@ishitsuka.com>

	* irb messages: fix typos.

Fri Jun  1 17:26:24 2001  K.Kosako  <kosako@sofnec.co.jp>

	* hash.c (replace_i): ignore when key == Qundef.

Fri Jun  1 11:21:04 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in: use waitpid on mingw32.

Thu May 31 18:34:57 2001  K.Kosako  <kosako@sofnec.co.jp>

	* file.c (rb_file_s_unlink): should not allow if $SAFE >= 2.

Thu May 31 13:30:25 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* mkconfig.rb, ext/configsub.rb: VERSION -> RUBY_VERSION.

Thu May 31 08:31:22 2001  Usaku Nakamura  <usa@osb.att.ne.jp>

	* dln.c: #define S_ISDIR if not defined.

Thu May 31 01:28:54 2001  Akinori MUSHA  <knu@iDaemons.org>

	* configure.in: default --with-libc_r to `no' until the problem is
	  fixed. (FreeBSD only)

Wed May 30 14:09:00 2001  K.Kosako  <kosako@sofnec.co.jp>

	* object.c (rb_obj_taint): backport from 1.7.

	* object.c (rb_obj_untaint): add frozen status check (backport from 1.7).

Tue May 29 17:24:23 2001  K.Kosako  <kosako@sofnec.co.jp>

	* ruby.c (proc_options): unexpected SecurityError happens when -T4.

Tue May 29 18:46:04 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* regex.c (re_compile_pattern): * \1 .. \9 should be
	  backreferences always.

	* regex.c (re_match): backreferences corresponding to
	  unclosed/unmatched parentheses should fail always.

Mon May 28 23:20:43 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in: remove unnecessary AC_CANONICAL_BUILD

	* defins.h: #define HAVE_SETITIMER on Cygwin(bug fixed).

	* ruby.c: use relative path from LIBRUBY_SO.

	* ruby.c: don't use -mwin32 option on Cygwin.

	* cygwin/GNUmakefile.in: ditto.

	* ext/sdbm/_sdbm: ditto.

	* ext/tcltklib/extconf.rb: ditto.

	* ext/tcltklib/stubs.c: ditto.

Mon May 28 22:12:01 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* ext/extconf.rb.in: make the priority of the make rule of .c
	  higher than .C .

Mon May 28 02:43:16 2001  Akinori MUSHA  <knu@iDaemons.org>

	* dir.c (rb_glob_helper): teach has_magic() to handle flags and
	  get rb_glob_helper to properly support FNM_NOESCAPE.

	* dir.c (fnmatch): fix a bug when FNM_PATHNAME and FNM_PERIOD are
	  specified at the same time.

Sat May 26 07:19:48 2001  Usaku Nakamura  <usa@osb.att.ne.jp>

	* win32/win32.c (opendir): add const directive.

Sat May 26 07:00:05 2001  Usaku Nakamura  <usa@osb.att.ne.jp>

	* MANIFEST: add win32/dir.h .

Sat May 26 00:15:57 2001  Usaku Nakamura  <usa@osb.att.ne.jp>

	* win32/dir.h: replace missing/dir.h .

	* dir.c: ditto.

Fri May 25 14:19:25 2001  K.Kosako  <kosako@sofnec.co.jp>

	* string.c (rb_str_replace): add taint status infection
	  (OBJ_INFECT()).

	* string.c (rb_str_crypt): ditto.

	* string.c (rb_str_ljust): ditto.

	* string.c (rb_str_rjust): ditto.

	* string.c (rb_str_center): ditto.

Fri May 25 01:55:32 2001  Akinori MUSHA  <knu@iDaemons.org>

	* MANIFEST: Re-adjust the entries to coincide with HEAD.

Fri May 25 01:36:52 2001  Akinori MUSHA  <knu@iDaemons.org>

	* MANIFEST: update the entries I forgot to add or remove.

Thu May 24 16:08:21 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* mkconfig.rb: autoconf 2.50 support.

Thu May 24 14:23:35 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_yield_0): need argument adjustment for C defined
	  blocks too.

Tue May 22 17:10:35 2001  K.Kosako  <kosako@sofnec.co.jp>

	* variable.c (rb_alias_variable): should not allow variable
	  aliasing if $SAFE >= 4.

Mon May 21 15:26:05 JST 2001  Keiju Ishitsuka <keiju@ishitsuka.com>

	* lib/irb/multi-irb.rb: delete japanese messages.

Mon May 21 13:15:25 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (rb_big2str): t should be protected from GC.

Sun May 20 00:28:43 2001  Akinori MUSHA  <knu@iDaemons.org>

	* ext/socket/extconf.rb: do not clobber $CFLAGS when setting
	  -DSOCKS.

Fri May 18 05:42:28 2001  Akinori MUSHA  <knu@iDaemons.org>

	* lib/thread.rb: rescue ThreadError in case the thread is dead
	  just before calling Thread#run.

Fri May 18 05:29:21 2001  Akinori MUSHA  <knu@iDaemons.org>

	* lib/mkmf.rb (xsystem): make a temporary fix to get $(...) macros
	  properly expanded on a command execution.

Fri May 18 03:49:55 2001  Brian F. Feldman  <green@FreeBSD.org>

	* lib/mkmf.rb: unbreak "make install".  lib/* must be installed
	  under $rubylibdir, not under $libdir.

Thu May 17 19:36:47 2001  Akinori MUSHA  <knu@iDaemons.org>

	* lib/shell.rb, lib/shell/process-controller.rb,
	  lib/shell/command-processor.rb: translate Japanese comments into
	  English.

	* doc/shell.rd.jp: RD'ify and make some fixes.

	* doc/shell.rd: RD'ify, delete Japanese leftovers, make overall
	  English fixes, and sync with doc/shell.rd.jp.

Thu May 17 19:34:11 2001  Akinori MUSHA  <knu@iDaemons.org>

	* doc/shell.rd*, lib/shell*: bring shell.rb 0.6 onto the ruby_1_6
	  branch.

Thu May 17 17:35:04 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_call0): address of local_vars might change during eval.

Thu May 17 07:30:15 2001  Akinori MUSHA  <knu@iDaemons.org>

	* ext/md5/md5.txt, ext/md5/md5.txt.jp: s/SuperClass/Superclass/.

Thu May 17 06:37:14 2001  Akinori MUSHA  <knu@iDaemons.org>

	* ext/md5/md5.txt: make wording fixes.

	* ext/md5/md5.txt.jp: ditto.

Thu May 17 05:23:52 2001  Keiju Ishitsuka <keiju@ishitsuka.com>
	* lib/irb.rb lib/irb/multi-irb.rb lib/irb/ruby-lex.rb lib/irb/version.rb
	  resolve ctrl-c problem

Tue May 15 17:46:37 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* array.c (rb_ary_and): should not push frozen key string.

	* array.c (rb_ary_or): ditto.

Mon May 14 13:50:22 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_thread_schedule): should save context before raising
	  deadlock, saved context for current thread might be obsolete.

	* time.c (make_time_t): non DST timezone shift supported (hopefully).

Mon May 14 11:54:20 2001  Tanaka Akira  <akr@m17n.org>

	* signal.c: SIGINFO added.

Mon May 14 08:57:06 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_ensure): should not SEGV when prot_tag is NULL.

Sun May 13 23:49:25 2001  Usaku Nakamura  <usa@osb.att.ne.jp>

	* win32/resource.rb: Modify copyright in resource script.

Fri May 11 23:51:54 2001  Usaku Nakamura  <usa@osb.att.ne.jp>

	* process.c: silence VC++ warnings.

	* sprintf.c: ditto.

Fri May 11 03:38:11 2001  Akinori MUSHA  <knu@iDaemons.org>

	* README.EXT: Document find_library(), with_config() and
	  dir_config().

Fri May 11 03:37:53 2001  Akinori MUSHA  <knu@iDaemons.org>

	* README.EXT.jp: Remove the description of find_header() because
	  such a function does not actually exist.
    
	* README.EXT.jp: Update the description of dir_config().

Fri May 11 02:42:40 2001  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* README, README.jp: Fix CVS access and mailing lists info.

Fri May 11 02:00:44 2001  Ryo HAYASAKA  <ryoh@jaist.ac.jp>

	* bignum.c (bigdivrem): access boundary bug.

Wed May  9 14:38:33 2001  K.Kosako  <kosako@sofnec.co.jp>

	* eval.c (rb_yield_0): preserve and restore ruby_cref as well.

Tue May  8 17:12:43 2001  K.Kosako  <kosako@sofnec.co.jp>

	* eval.c (is_defined): core dumped during instance_eval for
	  special constants.

	* eval.c (rb_eval): ditto.

Tue May  8 08:59:01 2001  Akinori MUSHA  <knu@iDaemons.org>

	* doc/forwardable.rd, doc/forwardable.rd.jp: Hit `=begin' and
	  `=end' in proper places so rd2 can format them without a problem.

	* doc/irb/irb-tools.rd.jp, doc/irb/irb.rd, doc/irb/irb.rd.jp:
	  ditto.

Tue May  8 08:56:05 2001  Akinori MUSHA  <knu@iDaemons.org>

	* doc/forwardable.rd, doc/forwardable.rd.jp, lib/forwardable.rb:
	  Bring forwardable 1.1 onto the ruby_1_6 branch.

Tue May  8 08:35:09 2001  Akinori MUSHA  <knu@iDaemons.org>

	* doc/irb/irb-tools.rd.jp, doc/irb/irb.rd.jp: Convert from JIS to
	  EUC.

Tue May  8 03:46:24 2001  Akinori MUSHA  <knu@iDaemons.org>

	* sample/rbc.rb: Obsoleted by IRB.

Mon May  7 15:58:45 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (arg): "||=" should not warn for uninitialized instance
	  variables.

	* eval.c (rb_eval): ditto.

	* eval.c (eval): preserve and restore ruby_cref as well.

Mon May  7 15:45:48 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* lib/ftools.rb (syscopy): chmod destination file only if
	  it does not exist.

Thu May  3 03:41:01 2001  SHIROYAMA Takayuki <psi@fortune.nest.or.jp>

	* configure.in: get --enable-shared to work on MacOS X.

	* Makefile.in: make $(LIBRUBY_SO) depend on miniruby properly.
	  Now `make -jN' should work without a problem.

Wed May  2 20:39:35 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* dir.c (rb_glob, rb_iglob): remove unnecessary FNM_PATHNAME.

Wed May  2 11:46:13 2001  K.Kosako  <kosako@sofnec.co.jp>

	* eval.c (block_pass): should not downgrade safe level.

Tue May  1 17:55:58 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (yylex): lex_state after RESCUE_MOD should be EXPR_BEG.

Tue May  1 03:36:50 2001  Akinori MUSHA  <knu@iDaemons.org>

	* sample/irb.rb, lib/irb.rb, lib/irb/*, doc/irb/*: Merge from irb
	  0.7.3 and irb-tools 0.7.1.

	* instruby.rb: Install help-message's too.

	* lib/irb/main.rb: This file is not needed anymore.

Thu Apr 26 22:36:11 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in:  don't use tzname on cygwin 1.3.1+.

	* configure.in: add -mieee/-ieee to CFLAGS on OSF1/Alpha
	  to disable "DIVISION BY ZERO" exception.

Thu Apr 26 22:30:43 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_eval): should preserve value of ruby_errinfo.

Thu Apr 26 10:36:09 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

       * eval.c (rb_thread_schedule): infinite sleep should not cause
	  dead lock.

Wed Apr 25 16:40:44 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* array.c (rb_ary_flatten_bang): proper recursive detection.

Wed Apr 25 15:36:15 2001  K.Kosako  <kosako@sofnec.co.jp>

       * eval.c (yield_under): need not to prohibit at safe level 4.

Tue Apr 24 16:03:25 2001  Hiroshi Igarashi  <iga@ruby-lang.org>

	* ext/extmk.rb.in: add target `distclean' in Makefile for extlib.
	  target `clean' doesn't remove Makefile.

Tue Apr 24 15:57:45 2001  Akinori MUSHA  <knu@iDaemons.org>

	* ext/extmk.rb.in, lib/mkmf.rb: (dir_config) do not add the
	  specified include directory if already included in $CPPFLAGS.

	* ext/extmk.rb.in, lib/mkmf.rb: (dir_config) return a more useful
	  value, [include_dir, lib_dir].

Tue Apr 24 15:35:32 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ruby.c (set_arg0): wrong predicate when new $0 value is bigger
	  than original space.

Mon Apr 23 14:43:59 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* gc.c (id2ref): should use NUM2ULONG()

	* object.c (rb_mod_const_get): check whether name is a class
	  variable name.

	* object.c (rb_mod_const_set): ditto.

	* object.c (rb_mod_const_defined): ditto.

Sun Apr 22 17:44:37 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in: add -mieee to CFLAGS on Linux/Alpha
	  to disable "DIVISION BY ZERO" exception.

	* configure.in: remove -ansi on OSF/1.

Sat Apr 21 22:33:26 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* marshal.c (w_float): precision changed to "%.16g"

Sat Apr 21 22:07:58 2001  Guy Decoux  <decoux@moulon.inra.fr>

	* eval.c (rb_call0): wrong retry behavior.

Fri Apr 20 19:12:20 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* numeric.c (fix_aref): a bug on long>int architecture.

Fri Apr 20 14:57:15 2001  K.Kosako  <kosako@sofnec.co.jp>

	* eval.c (rb_eval_string_wrap): should restore ruby_wrapper.

Wed Apr 18 04:37:51 2001  Wakou Aoyama  <wakou@fsinet.or.jp>

	* lib/cgi.rb: CGI::Cookie: no use PATH_INFO.

Wed Apr 18 00:24:40 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* regex.c (re_compile_pattern): char class at either edge of range
	  should be invalid.

Tue Apr 17 16:54:39 2001  K.Kosako  <kosako@sofnec.co.jp>

	* eval.c (safe_getter): should use INT2NUM().

Tue Apr 17 15:12:56 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (rb_big2long): 2**31 cannot fit in 31 bit long.

Sat Apr 14 22:46:43 2001  Guy Decoux  <decoux@moulon.inra.fr>

	* regex.c (calculate_must_string): wrong length calculation.

Sat Apr 14 13:33:32 2001  Usaku Nakamura  <usa@osb.att.ne.jp>

	* win32/config.status.in: no longer use missing/alloca.c.

	* win32/Makefile.sub: ditto.

Fri Apr 13 12:40:48 2001  K.Kosako  <kosako@sofnec.co.jp>

	* eval.c (rb_thread_start_0): fixed memory leak.

Fri Apr 13 16:41:18 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (none): should clear cmdarg_stack too.

Fri Apr 13 06:19:29 2001  GOTOU YUUZOU  <gotoyuzo@notwork.org>

	* io.c (rb_fopen): use setvbuf() to avoid recursive malloc() on
	  some platforms.

Wed Apr 11 23:36:26 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* file.c (rb_stat_dev): device functions should honor stat field
	  types (except long long such as dev_t).

Wed Apr 11 18:07:53 2001  K.Kosako  <kosako@sofnec.co.jp>

	* eval.c (rb_mod_nesting): should not push nil for nesting array.

	* eval.c (rb_mod_s_constants): should not search array by
	  rb_mod_const_at() for nil (happens for singleton class).

Wed Apr 11 13:29:26 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* class.c (rb_singleton_class_attached): should modify iv_tbl by
	  itself, no longer use rb_iv_set() to avoid freeze check error.

	* variable.c (rb_const_get): error message "uninitialized constant
	  Foo at Bar::Baz" instead of "uninitialized constant Bar::Baz::Foo".

Tue Apr 10 02:24:40 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* io.c (opt_i_set): should strdup() inplace_edit string.

Mon Apr  9 23:29:54 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (exec_under): need to push cref too.

Mon Apr  9 12:05:44 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* file.c (Init_File): should redifine "new" class method.

Mon Apr  9 11:56:52 2001  Shugo Maeda <shugo@ruby-lang.org>

	* lib/net/imap.rb: fix typo.

Thu Apr  5 22:40:12 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* variable.c (rb_const_get): no recursion to show full class path
	  for modules.

	* eval.c (rb_set_safe_level): should set safe level in curr_thread
	  as well.

	* eval.c (safe_setter): ditto.

Thu Apr  5 13:46:06 2001  K.Kosako  <kosako@sofnec.co.jp>

	* object.c (rb_obj_is_instance_of): nil belongs to false, not true.

Thu Apr  5 02:19:03 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* time.c (make_time_t): proper (I hope) daylight saving time
	  handling for both US and Europe.  I HATE SUMMER TIME!

	* eval.c (rb_thread_wait_for): non blocked signal interrupt should
	  stop the interval.

Wed Apr  4 03:47:03 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* class.c (rb_mod_clone): should copy method bodies too.

	* bignum.c (bigdivrem): should trim trailing zero bdigits of
	  remainder, even if dd == 0.

Tue Apr  3 15:29:10 2001  Akinori MUSHA  <knu@iDaemons.org>

	* Makefile.in: Introduce MAINLIBS.

	* configure.in: Link libc_r against the ruby executable on
	  FreeBSD, which is the first attempt to work around a certain
	  problem regarding pthread on FreeBSD.  It should make ruby/libruby
	  happy when it loads an extention to a library compiled and linked
	  with -pthread.  Note, however, that libruby is _not_ linked with
	  libc_r so as not to mess up pthread unfriendly stuff including
	  apache+mod_ruby and vim6+ruby_interp.

Tue Apr  3 09:56:20 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/extmk.rb.in (create_makefile): create def file only if
	  it does not yet exist.

	* lib/mkmf.rb: ditto.

Tue Apr  3 00:05:07 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* time.c (make_time_t): remove HAVE_TM_ZONE code since it
	  sometimes reports wrong time.

	* time.c (make_time_t): remove unnecessary range check for
	  platforms where negative time_t is available.

Mon Apr  2 14:25:49 2001  Shugo Maeda <shugo@ruby-lang.org>

	* lib/monitor.rb (wait): ensure reentrance.

	* lib/monitor.rb (wait): fix timeout support.

Mon Apr  2 12:44:53 2001  Shugo Maeda <shugo@ruby-lang.org>

	* lib/net/imap.rb: backport from ruby-1.7.

Mon Apr  2 01:16:24 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* win32/win32.c: use ruby's opendir on mingw32.

	* missing/dir.h, dir.c, Makefile: ditto.

Sun Apr  1 23:26:14 2001  TOYOFUKU Chikanobu  <toyofuku@juice.or.jp>

	* numeric.c (flodivmod): a bug in no fmod case.

Sun Apr  1 18:36:14 2001  Koji Arai  <JCA02266@nifty.ne.jp>

	* process.c (pst_wifsignaled): should apply WIFSIGNALED for status
	  (int), not st (VALUE).

Sat Mar 31 03:24:10 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* class.c (rb_include_module): module inclusion should be check
	  taints.

Fri Mar 30 12:51:19 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* class.c (rb_include_module): freeze check at first.

Thu Mar 29 17:05:09 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_attr): sprintf() and rb_intern() moved into
	  conditional body.

Wed Mar 28 23:43:00 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* ext/extmk.rb.in, lib/mkmf.rb: add C++ rules in addition to C
	  rules for the mswin32 platforms.

Wed Mar 28 19:29:21 2001  Akinori MUSHA  <knu@iDaemons.org>

	* ext/extmk.rb.in, lib/mkmf.rb: move C++ rules to the right place.

Wed Mar 28 17:39:04 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* object.c (rb_str2cstr): warn if string contains \0 and length
	  value is ignored.

Wed Mar 28 15:00:31 2001  K.Kosako  <kosako@sofnec.co.jp>

	* class.c (rb_singleton_class_clone): should copy class constant
	  table as well.

Wed Mar 28 15:03:23 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* class.c (rb_include_module): sometimes cache was mistakenly left
	  uncleared - based on the patch by K.Kosako.

Wed Mar 28 09:52:33 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* win32/Makefile.sub: disable global optimization.

Tue Mar 27 15:00:54 2001  K.Kosako  <kosako@sofnec.co.jp>

	* eval.c (rb_mod_define_method): should have clear method cache.

	* eval.c (rb_mod_define_method): should have raised exception for
	  type error.

Tue Mar 27 14:48:17 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ruby.h: changed "extern INLINE" to "static inline".

Mon Mar 26 23:19:33 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* time.c (rb_strftime): check whether strftime returns empty string.

Mon Mar 26 18:14:47 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* dir.c (rb_glob_helper): part of 1.7 globber backported to proper
	  following of symlinks.

Mon Mar 26 17:21:07 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c: remove TMP_PROTECT_END to prevent C_ALLOCA crash.

Mon Mar 26 14:04:41 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/Win32API/Win32API.c: remove Init_win32api().

Sat Mar 24 23:44:50 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (ev_const_defined): should ignore toplevel cbase (Object).

	* eval.c (ev_const_get): ditto.

Fri Mar 23 12:18:44 2001  SHIROYAMA Takayuki  <psi@fortune.nest.or.jp>

	* ext/curses/curses.c: curses on Mac OS X public beta does not
	  have _maxx etc.

Fri Mar 23 10:50:31 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* marshal.c (w_object): should truncate trailing zero short for
	  bignums.

Thu Mar 22 22:15:45 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/Win32API/extconf.rb: add -fno-omit-frame-pointer.

Thu Mar 22 17:43:44 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ruby.h: better inline function support.

	* configure.in (NO_C_INLINE): check if inline is available for the
	  C compiler.

Wed Mar 21 23:07:45 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* win32/win32.c (win32_stat): WinNT/2k "//host/share" support.

Wed Mar 21 01:26:14 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* gc.c (id2ref): sometimes confused symbol and reference.

Tue Mar 20 23:09:33 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* win32/win32.c (win32_stat): UNC support.

	* dir.c (extract_path): fix "./*" problem.

Mon Mar 19 19:14:47 2001  Guy Decoux  <decoux@moulon.inra.fr>

	* marshal.c (shortlen): shortlen should return number of bytes
	  written.

Mon Mar 19 18:56:55 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* stable version 1.6.3 released.

Mon Mar 19 16:52:23 2001  K.Kosako  <kosako@sofnec.co.jp>

	* eval.c (ev_const_defined): need not to check if cbase->nd_class
	  is rb_cObject.

	* eval.c (ev_const_get): ditto.

Mon Mar 19 16:27:32 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (THREAD_ALLOC): flags should be initialized.

	* signal.c (rb_f_kill): should use FIX2INT, not FIX2UINT.

Mon Mar 19 11:03:10 2001  Koji Arai  <JCA02266@nifty.ne.jp>

	* marshal.c (r_object): len calculation patch was wrong for
	  machines SIZEOF_BDIGITS == SIZEOF_SHORT.

	* gc.c: alloca prototype reorganized for C_ALLOCA machine.

Sun Mar 18 08:58:18 2001  Wakou Aoyama  <wakou@fsinet.or.jp>

	* lib/cgi.rb: // === '' --> //.match('')

	* lib/cgi.rb: cgi#header(): improvement for mod_ruby.

	* lib/cgi.rb: cgi#rfc1123date(): improvement.
	  thanks to TADA Tadashi <sho@spc.gr.jp>.

	* lib/cgi.rb: cgi#rfc1123date(): document bug fix.
	  thanks to Kazuhiro NISHIYAMA <zn@mbf.nifty.com>.

	* lib/cgi.rb: cgi#header(): bug fix.
	  thanks to IWATSUKI Hiroyuki <don@na.rim.or.jp>.

Fri Mar 16 17:21:25 2001  Akinori MUSHA  <knu@iDaemons.org>

	* configure.in: Set SOLIBS properly for all ELF and
	  FreeBSD/NetBSD/OpenBSD a.out platforms so that the shlib
	  dependencies are recorded in the libruby shlib.

Wed Mar 14 16:41:45 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_thread_schedule): raise FATAL just once to
	  THREAD_TO_KILL.

Wed Mar 14 10:41:34 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_yield_0): 0 (= Qfalse) is a valid value, so that
	  default self should be checked by klass == 0.

	* bignum.c (rb_cstr2inum): should disallow '++1', '+-1', etc.

Tue Mar 13 17:51:09 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (ev_const_defined): add new parameter self for special
	  const fallback.

	* eval.c (ev_const_get): ditto.

Tue Mar 13 16:39:45 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* dir.c (rb_glob_helper): fix drive letter handling on DOSISH.

Tue Mar 13 15:01:12 2001  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/http.rb: add HTTPRequest#basic_auth.

	* lib/net/smtp.rb: raise if only account or password is given.

	* lib/net/protocol.rb: WriteAdapter#<< returns self.

Tue Mar 13 14:41:16 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (argf_seek): wrong calling sequence of rb_io_seek().

Mon Mar 12 18:59:38 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* lib/mkmf.rb (create_makefile): save/restore $libs and $LIBPATH.

Sun Mar 11 00:55:31 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* lib/mkmf.rb (install_rb): fix handling of destination path.

Sat Mar 10 02:34:18 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* math.c (math_log, math_log10): use nan() instead of 0.0/0.0 on Cygwin.

Thu Mar  8 17:43:59 2001  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb: one write(2) per one line.

Wed Mar  7 14:26:11 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* math.c (math_log, math_log10): should return NaN if x < 0.0
	  on Cygwin.

Thu Mar  7 10:31:26 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* parse.y (stmt): while/until modifier must work for empty body.

Tue Mar  6 22:53:58 2001  Kazuhiro Yoshida   <moriq.kazuhiro@nifty.ne.jp>

	* ruby.c (ruby_set_argv): clear ARGV contents before adding args.

Tue Mar  6 10:50:29 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (primary): rescue and ensure clauses should be allowed
	  to appear in singleton method body.

Mon Mar  5 17:25:13 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (proc_eq): compare Procs using blocktag equality.

	* eval.c (proc_to_s): stringify according to block tag address.

Mon Mar  5 17:19:56 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* win32/win32.c (gettimeofday): use GetLocalTime() instead of ftime()
	  for high-resolution timing.

Sun Mar  4 20:45:20 2001  Akinori MUSHA  <knu@iDaemons.org>

	* ext/extmk.rb.in, lib/mkmf.rb: add C++ rules in addition to C
	  rules.

Sun Mar  4 17:01:09 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* string.c (trnext): support backslash escape in String#tr.

Wed Feb 28 11:02:41 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_delete_bang): delete! should take at least 1
	  argument. 

Tue Feb 27 16:38:15 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (ev_const_get): retrieve Object's caonstat if no current
	  class is available (e.g. defining singleton class for Fixnums).

	* eval.c (ev_const_defined): check Object's constant if no current
	  class is available (e.g. defining singleton class for Fixnums).

	* eval.c (proc_call): ignore block to `call' always, despite of
	  being orphan or not.

Wed Feb 27 10:16:32 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* eval.c (rb_yield_0): should check based on rb_block_given_p()
	  and rb_f_block_given_p().

Mon Feb 26 16:20:27 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ruby.c (proc_options): call ruby_show_version() just once.

Mon Feb 26 00:04:52 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (proc_call): should not modify ruby_block->frame.iter
	  based on ruby_frame->iter altered by PUSH_ITER().

Mon Feb 26 05:27:52 2001  Wakou Aoyama  <wakou@fsinet.or.jp>

	* lib/net/telnet.rb: #telnetmode(), #binmode(): bug fix.
	  thanks to nobu.nakada@nifty.ne.jp.

Mon Feb 26 04:55:50 2001  Wakou Aoyama  <wakou@fsinet.or.jp>

	* lib/cgi.rb: CGI#form(): bug fix.
	  thanks to MoonWolf <moonwolf@moonwolf.com>.

	* lib/cgi.rb: CGI#rfc1123_date(): improvement.
	  thanks to Tomoyasu Akita <genzo-@dm4lab.to>.

	* lib/cgi.rb: CGI#header(): improvement for mod_ruby.
	  thanks to Shugo Maeda <shugo@ruby-lang.org>.

Sun Feb 25 02:45:30 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* file.c (rb_file_s_rename): avoid Cygwin's bug.

Sat Feb 24 23:32:55 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_thread_fd_close): should save current context before
	  raising exception.

Sat Feb 24 22:14:00 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* win32/win32.c (myrename): fix error handling.

Sat Feb 24 15:43:31 2001  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb: use net 1.2 for also ruby 1.6 branch.

	* lib/net/smtp.rb: ditto.

	* lib/net/pop.rb: ditto.

	* lib/net/http.rb: ditto.

Fri Feb 23 16:36:09 2001  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/http.rb: always close connection if body is not exist.

Fri Feb 23 13:27:05 2001  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/http.rb: keep-alive detection was incomplete.

Fri Feb 23 08:24:53 2001  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb: clear read buffer after reopen.

	* lib/net/http.rb: update RD document.

Tue Feb 20 16:37:58 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (rb_big2long): should not raise RangeError for Bignum
	  LONG_MIN value.

Mon Feb 19 17:46:37 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_substr): "a"[1,2] should return ""; need
	  rubicon upgrade.

Mon Feb 19 01:55:43 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (secure_visibility): visibility check for untainted modules.

Mon Feb 19 00:29:29 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* signal.c (sigpipe): sighandler which does nothing.

	* signal.c (trap): set sigpipe function for SIGPIPE.

	* signal.c (Init_signal): default SIGPIPE handler should be
	  sigpipe function.

Sun Feb 18 15:42:38 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/curses/extconf.rb: add dir_config.

	* missing/flock.c: use fcntl(2) instead of lockf(2).

Sun Feb 18 13:02:03 2001  Yasushi Shoji  <yashi@yashi.com>

	* array.c (rb_ary_subseq): wrong boundary check.

Fri Feb 16 01:44:56 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (set_outfile): f should be the FILE* from the assigning value.

Thu Feb 15 11:33:49 2001  Shugo Maeda <shugo@ruby-lang.org>

	* lib/cgi/session.rb (close): fixed reversed condition.

Wed Feb 14 17:28:24 2001  Shugo Maeda <shugo@ruby-lang.org>

	* lib/net/imap.rb: supports unknown resp_text_code.

Wed Feb 14 00:44:17 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* dir.c (dir_s_glob): call rb_yield directly (via push_pattern) if
	  block is given to the method.

	* dir.c (push_pattern): do not call rb_ary_push; yield directly.

Tue Feb 13 23:05:38 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* dir.c (lstat): should use rb_sys_stat if lstat(2) is not
	  available.

Tue Feb 13 17:00:18 2001  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/http.rb: supports HTTP 1.0 server.

Tue Feb 13 01:13:43 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (primary): preserve and clear in_single and in_def using
	  stack to prevent nested method errors in singleton class bodies.

Sun Feb 11 16:00:30 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* eval.c (stack_length): use __builtin_frame_address() only if
	  GCC and i386 CPU.

	* gc.c (rb_gc, Init_stack): ditto.

	* configure.in: add ac_cv_func_getpgrp_void=yes on DJGPP.

Sat Feb 10 23:43:49 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* hash.c (rb_any_hash): dumped core on machines sizeof(int) != sizeof(long).

Sat Feb 10 23:07:15 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* regex.c (PREV_IS_A_LETTER): should not treat c>0x7f as a word
	  character if -Kn.

Sat Feb 10 00:06:28 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* win32/win32.c (win32_stat): replace stat for enable when pathname
	  ends with '/' or '\' for mswin32 on Win9X / Win2k.

	* win32/win32.h: ditto.

	* ruby.h: ditto.

	* dir.c (rb_glob_helper): ditto.

	* file.c (rb_stat, rb_file_s_stat, eaccess, check3rdbyte): ditto.

Fri Feb  9 22:54:57 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ruby.c (ruby_init_loadpath): convert '\\' to '/'
	  before finding executable file path.

Fri Feb  9 17:41:53 2001  Triet H. Lai  <thlai@mail.usyd.edu.au>

	* dir.c (rb_glob_helper): do not follow symbolic links.

Fri Feb  8 23:53:08 2001  Usaku Nakamura  <usa@osb.att.ne.jp>

	* win32/config.h.in (inline): add inline definition.

Thu Feb  8 21:27:24 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* lib/mkmf.rb (install_rb): fix handling of relative path.

	* lib/mkmf.rb (create_makefile): add srcdir.

Wed Feb  7 16:05:22 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* parse.y (parse_quotedwords): %w should allow parenthesis escape.

Wed Feb  7 00:57:42 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (parse_qstring): %q should allow terminator escape.

Wed Feb  7 00:57:42 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* re.c (rb_reg_equal): all option flags should be same to be equal.

Tue Feb  6 21:01:29 2001  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb: ignore EOFError on only specified case.

	* lib/net/http.rb: take HTTP 1.0 server into account.

Mon Feb 5 00:39:06 2001  KANEKO Naoshi  <wbs01621@mail.wbs.ne.jp>

	* dir.c: use ISXXX() instead of isxxx().

	* dln.c (aix_loaderror): ditto.

	* file.c (rb_file_s_expand_path): ditto.

	* string.c (rb_str_upcase_bang): ditto.

	* win32/win32.c (do_spawn): ditto.

	* win32/win32.c (NtMakeCmdVector): ditto.

	* win32/win32.c (opendir): ditto.

Fri Feb  3 00:48:50 2001  Usaku Nakamura  <usa@osb.att.ne.jp>

	* win32/win32.c (isInternalCmd): ignore case for shell's internal
	  command. (marge from HEAD)

Fri Feb  2 16:14:51 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (POP_VARS): propagate DVAR_DONT_RECYCLE, if
	  SCOPE_DONT_RECYCLE of ruby_scope is set.

Wed Jan 31 22:27:29 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in: gcc-2.95.2-7(cygwin) support.
	  add -mwin32 if available.

	* cygwin/GNUmakefile: ditto.

Mon Jan 29 17:36:19 2001  TOYOFUKU Chikanobu  <toyofuku@juice.or.jp>

	* eval.c (rb_eval): nd_iter evaluation should be wrapped by
	  BEGIN_CALLARGS and END_CALLARGS.

Mon Jan 29 01:40:27 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (str_independent): should not clear str->orig here.
	  it's too early.

Wed Jan 24 01:45:49 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (POP_BLOCK_TAG): call rb_gc_force_recycle() if block has
	  not been objectified.

	* eval.c (rb_callcc): should nail down block->tag history to avoid
	  rb_gc_force_recycle(). 

Tue Jan 23 18:51:57 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* gc.c (rb_gc_call_finalizer_at_exit): should finalize objects in
	  deferred_final_list too.

Tue Jan 23 16:10:12 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* gc.c (os_live_obj): do not list terminated object.

	* gc.c (os_obj_of): ditto.

	* gc.c (rb_gc_mark): support new T_BLKTAG tag.

	* gc.c (obj_free): ditto.

	* eval.c (new_blktag): creation of new block tag, which holds
	  destination of global jump and orphan status.

	* eval.c (block_pass): break from orphan Proc object will raise a
	  LocalJumpError exception.

Mon Jan 22 16:33:16 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* mkconfig.rb: autoconf 2.49 support.

Sat Jan 20 03:54:00 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (yylex): fixed serious syntax misbehavior.  do's
	  preceding was too high.  a block in `foo bar do .. end' should
	  be passed to `foo', not `bar'.

	* parse.y (block_call): syntax restructure.

Fri Jan 19 04:04:31 2001  Akinori MUSHA  <knu@iDaemons.org>

	* lib/irb/ruby-lex.rb: Merge from HEAD: rev.1.4

Wed Jan 17 13:28:26 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in: remove DEFS definition.

	* mkconfig.rb: ditto.

	* win32/config.status.in: ditto.

Tue Jan 16 16:59:14 2001  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb: ignore EOFError for read

Sun Jan 14 21:49:28 2001  Koji Arai  <JCA02266@nifty.ne.jp>

	* sprintf.c (rb_f_sprintf): simple typo.  binary base should be 2,
	  not '2'.

Sun Jan 14 02:49:57 2001  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb (adding): too few "yield" in case of arg is
	  not String/File.

Sat Jan 13 19:18:18 2001  WATANABE Hirofumi  <eban@ruby-lang.org>

	* re.c (rb_reg_desc): separate RE_OPTION_MULTILINE

	* re.c (rb_reg_options): add RE_OPTION_{POSIXLINE,RE_OPTION_MULTILINE,
	  RE_OPTION_EXTENDED}

Thu Jan 11 06:45:55 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* object.c (rb_mod_dup): should propagate FL_SINGLETON.

	* object.c (inspect_obj): handles the case of no instance variable.

Wed Jan 10 01:50:45 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_reverse_bang): forgot to call rb_str_modify().

Tue Jan  9 17:41:40 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* object.c (rb_obj_taint): check frozen status before modifying
	  taint status.

	* object.c (rb_obj_untaint): ditto.

Mon Jan  8 21:35:10 2001  Guy Decoux  <decoux@moulon.inra.fr>

	* file.c (path_check_1): should restore modified path.

Mon Jan  8 21:24:37 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (bigdivrem): t2 might be too big for signed long; do
	  not use rb_int2big(), but rb_uint2big().

Mon Jan  8 03:09:58 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* error.c (rb_load_fail): new func to report LoadError.

	* ruby.c (load_file): use rb_load_fail.

Sat Jan  6 00:55:59 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* pack.c (pack_pack): template "m2" or "u2" caused inifinite loop.

Fri Jan  5 01:02:17 2001  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (ruby_finalize): should enclosed by PUSH_TAG/POP_TAG.

Sun Dec 31 01:39:16 2000  Guy Decoux  <decoux@moulon.inra.fr>

	* eval.c (rb_mod_define_method): wrong comparison for blocks.

Sat Dec 30 19:28:50 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* gc.c (id2ref): should handle Symbol too.

	* gc.c (id2ref): should print original ptr value

Sat Dec 30 03:14:22 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_iterate): NODE_CFUNC does not protect its data
	  (nd_tval), so create new node NODE_IFUNC for iteration C
	  function. 

	* eval.c (rb_yield_0): use NODE_IFUNC.

	* gc.c (rb_gc_mark): support NODE_IFUNC.

Fri Dec 29 11:41:55 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* gc.c (mem_error): prohibit recursive mem_error().
	  (ruby-bugs-ja:PR#36)

Fri Dec 29 11:05:41 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_thread_fd_writable): should not switch context if
	  rb_thread_critical is set.

	* eval.c (rb_thread_wait_fd): ditto.

	* eval.c (rb_thread_wait_for): ditto.

	* eval.c (rb_thread_select): ditto.

	* eval.c (rb_thread_join): join during critical section causes
	  deadlock. 

Tue Dec 26 18:46:41 2000  NAKAMURA Hiroshi  <nakahiro@sarion.co.jp>

	* lib/debug.rb: Avoid thread deadlock in debugging stopped thread.

	* lib/debug.rb: Uncleared 'finish' state.

Tue Dec 26 16:53:55 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_yield_0): remove dvar node by rb_gc_force_recycle()
	  more eagerly.

	* eval.c (rb_f_binding): recycling should be stopped for outer
	  scope too.

	* eval.c (proc_new): ditto.

Tue Dec 26 15:45:35 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_inspect): should treat multibyte chracters
	  properly.

Mon Dec 25 17:49:08 2000  K.Kosako  <kosako@sofnec.co.jp>

	* string.c (rb_str_replace_m): unexpected string share happens if
	  replace is done for associated (STR_NO_ORIG) string.

Tue Dec 26 15:01:53 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (rb_f_p): should not call rb_io_flush() if rb_defout is not
	  an IO (T_FILE).

Mon Dec 25 15:52:39 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* stable version 1.6.2 released.

Mon Dec 25 05:11:04 2000  Wakou Aoyama  <wakou@fsinet.or.jp>

	* lib/cgi.rb: version 2.1.2 (some bug fixes).

	* lib/cgi.rb: Regexp::last_match[1] --> $1

	* lib/net/telnet.rb: ditto.

Mon Dec 25 04:43:02 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/http.rb: does not send HEAD on closing socket.

Mon Dec 25 00:44:48 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* hash.c (rb_any_cmp): should use rb_str_cmp() if TYPE == T_STRING
	  and CLASS_OF == rb_cString.

	* string.c (rb_str_new4): should copy class of original too.

Mon Dec 25 00:04:54 2000  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* eval.c (rb_thread_schedule): initial value of `max' changed to -1.

Mon Dec 25 00:16:14 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_replace_m): copy-on-write replace.

	* parse.y (yylex): should handle => after identifier as well as ==
	  and =~.

Sat Dec 23 23:55:57 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (rb_cstr2inum): Integer("") should not return 0.

Sat Dec 23 11:55:57 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* array.c (rb_ary_and): Array#& should preverve original order.

Sat Dec 23 03:44:16 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb: set @closed false in Socket#reopen.

	* lib/net/pop.rb: add POP3.foreach, delete_all.

	* lib/net/pop.rb: add POP3#delete_all.

	* lib/net/http.rb: add HTTP.version_1_1, version_1_2

	* lib/net/http.rb: refactoring.

Fri Dec 22 23:11:12 2000  Ueno Katsuhiro  <unnie@blue.sky.or.jp>

	* eval.c (rb_feature_p): ext might be null.

Fri Dec 22 17:04:12 2000  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* win32/win32.c (myselect): avoid busy loop by adjusting fd_count.

Fri Dec 22 15:07:55 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (rb_cstr2inum): prefix like '0x' had removed too much.

Thu Dec 21 13:01:46 2000  Tanaka Akira  <akr@m17n.org>

	* lib/net/ftp.rb (makeport): don't use TCPsocket.getaddress.

Wed Dec 20 12:00:15 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (rb_big_lshift): should cast up to BDIGIT_DBL.

	* parse.y (yylex): disallow trailing '_' for numeric litrals.

	* bignum.c (rb_cstr2inum): allow `_' within converting string.

	* eval.c (specific_eval): should take no argument if block is
	  supplied.

Tue Dec 19 13:44:50 2000  K.Kosako  <kosako@sofnec.co.jp>

	* io.c (rb_f_p): should flush rb_defout, not stdout.

Tue Dec 19 00:57:10 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* time.c (time_minus): usec might overflow. (ruby-bugs-ja:PR#35)

	* eval.c (rb_obj_extend): Object#extend should take at least one
	  argument.

	* parse.y (mrhs_basic): should check value_expr($3), not $1.

Mon Dec 18 23:18:39 2000  WATANABE Hirofumi  <eban@ruby-lang.org>

	* util.c (mblen, __crt0_glob_function): add for multibyte
	  on DJGPP 2.03.

Mon Dec 18 18:10:30 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* time.c (time_plus): usec might underflow (ruby-bugs-ja:#PR33).

Mon Dec 18 08:11:20 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* hash.c (rb_hash_set_default): should call rb_hash_modify().

Sat Dec 16 02:58:26 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* eval.c (rb_eval): should clear ruby_errinfo on retry.

	* eval.c (rb_rescue2): ditto.

Thu Dec 14 13:06:18 2000  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* class.c (rb_include_module): prohibit fronzen class/module.

	* eval.c (rb_frozen_class_p): make external.

	* intern.h (rb_frozen_class_p): prototyped.

	* intern.h (rb_undef): prototyped not but rb_undef_method()
	  which is also in ruby.h.

Thu Dec 14 09:20:26 2000  Wakou Aoyama  <wakou@fsinet.or.jp>

	* lib/cgi.rb: support -T1 on ruby 1.6.2

	* lib/cgi.rb: $1 --> Regexp::last_match[1]

	* lib/net/telnet.rb: ditto.

Wed Dec 13 23:27:06 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_eval): handles case statement without expr, which
	  looks for any TRUE (non nil, non false) when expression.

	* parse.y (primary): case expression should not be compstmt, but
	  mere expr.

	* parse.y (primary): case without following expression is now
	  separated rule.

Wed Dec 13 12:41:27 2000  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ruby.c (proc_options): accept "--^M" for DOS line endings.

Tue Dec 12 15:45:42 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (newline_node): cancel newline unification.

Mon Dec 11 23:01:57 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (yylex): supports cases `?' precedes EOF and newline.

Mon Dec 11 12:11:25 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (call_end_proc): some frame members were left
	  uninitialized.

Mon Dec 11 01:14:58 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (rb_io_fptr_finalize): do not fclose stdin, stdout and
	  stderr at exit.

Sat Dec  9 17:34:48 2000  Tachino Nobuhiro <tachino@open.nm.fujitsu.co.jp>

	* time.c (time_cmp): should check with kind_of?, not instance_of?

	* time.c (time_eql): ditto.

	* time.c (time_minus): ditto.

Fri Dec  8 17:23:25 2000  Tachino Nobuhiro <tachino@open.nm.fujitsu.co.jp>

	* sprintf.c (rb_f_sprintf): proper string precision treat.

Fri Dec  8 10:44:05 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* variable.c (rb_mod_remove_cvar): Module#remove_class_variable
	  added.

Thu Dec  7 17:35:51 2000  Shugo Maeda  <shugo@ruby-lang.org>

	* eval.c (stack_length): don't use __builtin_frame_address() on alpha.

Wed Dec  6 18:07:13 2000  WATANABE Hirofumi  <eban@ruby-lang.org>

	* djgpp/config.sed, win32/Makefile.sub: typo.

	* eval.c (rb_mod_define_method): avoid VC4.0 warnings.

Wed Dec  6 13:38:08 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* array.c (rb_ary_and): tuning, make hash from shorter operand.

Wed Dec  6 01:28:50 2000  SHIROYAMA Takayuki  <psi@fortune.nest.or.jp>

	* gc.c (rb_gc): __builtin_frame_address() should not be used on
	  MacOS X.

	* gc.c (Init_stack): ditto.

Mon Dec  4 13:44:01 2000  WATANABE Hirofumi  <eban@ruby-lang.org>

	* lib/jcode.rb: consider multibyte. not /n.

Mon Dec  4 09:49:36 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_inspect): output whole string contents. no more `...'

	* string.c (rb_str_dump): should propagate taintness.

	* hash.c (env_inspect): hash like human readable output.

	* variable.c (rb_ivar_get): prohibiting instance variable access
	  is too much restriction.

	* class.c (method_list): retrieving information should not be
	  restricted where $SAFE=4.

	* class.c (rb_obj_singleton_methods): ditto.

	* eval.c (rb_thread_priority): ditto.

	* eval.c (rb_thread_local_aref): ditto.

	* variable.c (rb_obj_instance_variables): ditto.

	* variable.c (rb_mod_const_at): ditto.

	* variable.c (rb_mod_class_variables): ditto.

	* eval.c (rb_exec_end_proc): end_proc should be preserved.

Sat Dec  2 22:32:43 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_yield_0): || should accept exactly zero argument.

	* parse.y (stmt): multiple right hand side for single assignment
	  (e.g. a = 1,2) is allowed.

Wed Nov 29 07:55:29 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* marshal.c (w_long): dumping long should be smaller than 32bit max.

	* marshal.c (w_long): shorter long format for small integers(-123..122).

	* marshal.c (r_long): ditto.

Tue Nov 28 18:10:51 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_mod_define_method): quick hack to implement
	  on-the-fly method definition.  experimental.

Mon Nov 27 17:00:35 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_eval): should not redefine builtin classes/modules
	  from within wrapped load.

Mon Nov 27 08:57:33 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (call_end_proc): should be isolated from outer block.

Mon Nov 27 00:10:08 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (rb_io_ctl): call ioctl/fcntl for fptr->f2 too.

	* process.c (rb_f_fork): call rb_thread_atfork() after creating
	  child process.

	* eval.c (rb_thread_atfork): kill all other threads immediately,
	  then turn the current thread into the main thread.

Sat Nov 25 23:12:22 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (ruby_run): move calling point of rb_trap_exit after
	  cleaning up threads.

	* eval.c (ruby_finalize): new function to call EXIT trap, END
	  procs and GC finalizers.

	* eval.c (rb_exec_end_proc): prevent recursion.

	* gc.c (rb_gc_call_finalizer_at_exit): ditto.

	* signal.c (rb_trap_exit): ditto. made static.

	* process.c (rb_f_fork): should swallow all exceptions from block
	  execution.

	* process.c (fork_rescue): should call ruby_finalize().

	* parse.y (yycompile): rb_gc() removed.  I don't remember why I put
	  this here.  test code?

Fri Nov 24 22:03:48 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* range.c (EXCL): exclusive infomation is now stored in an
	  instance variable.  this enables proper marshal dump.

	* process.c (proc_waitpid): should clear rb_last_status ($?) if
	  no pid was given by waitpid(2).

Thu Nov 23 01:35:38 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* process.c (proc_waitpid2): returns nil if no pid found.

Wed Nov 22 23:45:15 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* range.c (range_eq): new method.  Compares start and end of range
	  respectively.

Wed Nov 22 11:01:32 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* variable.c (rb_mod_class_variables): should honor singleton
	  class variable rule defined yesterday.

Tue Nov 21 23:24:14 2000  Mitsuteru S Nakao  <nakao@kuicr.kyoto-u.ac.jp>

	* numeric.c (flodivmod): missing second operand (typo).

Tue Nov 21 03:39:41 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* marshal.c (marshal_load): marshal format compatibility check
	  revised.   greater minor revision is UPWARD compatibile;
	  downward compatibility is not assured.

	* eval.c (is_defined): clarify class variable behavior for
	  singleton classes.  class variables within singleton class
	  should be treated like within singleton method.

Mon Nov 20 13:45:21 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_eval): set ruby_sourceline before evaluating
	  exceptions.

	* gc.c (gc_sweep): defer finalization in GC during compilation or
	  interrupt prohibit section.

	* gc.c (gc_sweep): mark all nodes before sweeping if GC happened
	  during compilation.

	* eval.c (rb_eval): should treat class variables specially in a
	  method defined in the singleton class.

Mon Nov 20 10:20:21 2000  WATANABE Hirofumi  <eban@ruby-lang.org>

	* dir.c, win32/win32.c, ruby.h: add rb_iglob().

Mon Nov 20 00:18:16 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* array.c (rb_ary_subseq): should return nil for outbound start
	  index.

	* marshal.c (marshal_load): show format versions explicitly when
	  format version mismatch happens.

Sun Nov 19 06:13:24 2000  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* marshal.c: use long for string/array length.

	* pack.c (swaps): use bit-or(|) instead of plus(+).

	* pack.c (swapl): ditto.

Sat Nov 18 15:18:16 2000  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* array.c (rb_ary_replace): array size should be in long.

	* array.c (rb_ary_concat): ditto.

	* array.c (rb_ary_hash): ditto.

Sat Nov 18 14:07:20 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/http.rb: Socket#readline() reads until "\n", not "\r\n"

Fri Nov 17 14:55:18 2000  WATANABE Hirofumi  <eban@ruby-lang.org>

	* string.c (rb_str_succ): output should be NUL terminated.

Fri Nov 17 02:54:15 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (rb_io_close): need not to flush before closing.

	* eval.c (rb_thread_join): should preserve last thread status when
	  THREAD_TO_KILL.

	* eval.c (rb_thread_stop): ditto.

	* io.c (io_fflush): wrap fflush by TRAP_BEG, TRAP_END.

	* eval.c (rb_eval): method defined within singleton class
	  definition should behave like singleton method about class
	  variables.

	* eval.c (is_defined): ditto.

Thu Nov 16 23:06:07 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/http.rb: can call {old,new}_implementation any times.

	* lib/net/http.rb: HTTP#connecting, receive ->
	  common_oper, connecting.

	* lib/net/http.rb: output warning if u_header includes
	  duplicated header.

	* lib/net/http.rb: not check Connection:/Proxy-Connection;
	  always read until eof.

	* lib/net/protocol.rb: detects and catches "break" from block.

Thu Nov 16 16:32:45 2000  Masahiro Tanaka  <masa@stars.gsfc.nasa.gov>

	* bignum.c (bigdivrem): should have incremented ny first.

Thu Nov 16 14:58:00 2000  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* ext/socket/socket.c (sock_new): duplicates file descriptor 
	  with myfddup() on mswin32/mingw32.

	* win32/win32.h: uses system original fdopen().

	* win32/win32.c (myfddup): newly added instead of myfdopen().

	* win32/win32.c (mybind, myconnect, mygetsockname, mygetsockopt, 
	  mylisten, mysetsockopt): now accept file descriptor only, not 
	  SOCKET.

	* win32/win32.c (myaccept, mysocket): return file descriptor, 
	  instead of SOCKET.

Thu Nov 16 10:23:24 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (massign): too strict check for nameless rest argument.

	* eval.c (method_arity): mere * should return -1.

	* eval.c (intersect_fds): should check all FDs in the fd_set.

Wed Nov 15 19:33:20 2000  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* eval.c (rb_attr): should clear method cache before calling hook.

	* eval.c (rb_eval): ditto.

	* eval.c (rb_mod_modfunc): ditto.

Mon Nov 13 22:44:52 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* error.c (rb_bug): print version to stderr.

Mon Nov 13 19:02:08 2000  WATANABE Hirofumi  <eban@ruby-lang.org>

	* win32/win32.c, io.c, process.c: the exit status of program must be
	  multiplied 256 on mswin32 and msdosdjgpp(system(), ``).

Sat Nov 11 22:57:38 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (arg): uniformed treatment of -a**b, where a is a
	  number literal;  hacky but behavior appears more consistent.

	* parse.y (newline_node): reduce newline node (one per line).

	* random.c (rb_f_srand): should be prohibited in safe level
	  greater than 4.

Sat Nov 11 22:37:36 2000  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* rubysig.h: do not use rb_trap_immediate on win32.

	* rubysig.h: new macros, ATOMIC_TEST, ATOMIC_SET, ATOMIC_INC,
	  ATOMIC_DEC, RUBY_CRITICAL and new definition of TRAP_BEG,
	  TRAP_END.

	* gc.c (ruby_xmalloc): should wrap malloc() by RUBY_CRITICAL.

	* signal.c (sighandle): better win32 sig handling.

	* win32/win32.c (flock): better implementation.

	* win32/win32.c (myselect): ditto.

	* win32/win32.c (myaccept): ditto.

	* win32/win32.c (waitpid): ditto.

	* win32/win32.c (myrename): ditto.

	* win32/win32.c (wait_events): support function for win32 signal
	  handling.

Sat Nov 11 08:34:18 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.31.

	* lib/net/http.rb: initializes header in HTTP, not HTTPCommand.

	* lib/net/protocol.rb, http.rb: rewrites proxy code.

Fri Nov 10 16:15:53 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* numeric.c (rb_num2long): use to_int, not to_i.

	* error.c: T_SYMBOL was misplaced by T_UNDEF.

	* parse.y (yylex): eval("^") caused infinite loop.

Thu Nov  9 14:22:13 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (rb_io_taint_check): should check IO taintness; no
	  operation for untainted IO should be allowed in the sandbox.

	* rubyio.h (GetOpenFile): check IO taintness inside using
	  rb_io_taint_check().

Wed Nov  8 03:08:53 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (io_fflush): ensure fflush(3) would not block by calling
	  rb_thread_fd_writable(). 

Tue Nov  7 20:29:56 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.30.

	* lib/net/protocol.rb, smtp.rb: Command#critical_ok -> error_ok

	* lib/net/http.rb: reads header when also "100 Continue".

Tue Nov  7 04:32:19 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (bigdivrem): use bit shift to make y's MSB set.

Mon Nov  6  1:22:49 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* error.c (warn_print): do not use err_append(), to ensure output
	  to stderr.

	* error.c (rb_warn): use warn_print() instead of err_print().

	* error.c (rb_warning): ditto.

	* error.c (rb_bug): ditto.

	* eval.c (rb_load): re-raise exceptions during load.

	* time.c (make_time_t): remove useless adjust

Thu Nov  2 18:01:16 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* random.c (rb_f_rand): half-baked float support fixed.  This fix
	  was originally proposed by K.Kosako <kosako@sofnec.co.jp>.

Tue Oct 31 17:27:17 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c: change digit size to `long|int' if long long is
	  available.

	* marshal.c (w_object): support `long|int' digits.

	* marshal.c (r_object): ditto.

Sat Oct 28 23:54:22 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (yylex): allow =end at the end of file (without a
	  newline at the end).

Fri Oct 27 10:00:27 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (rb_cstr2inum): should ignore trailing white spaces.

	* bignum.c (rb_str2inum): string may not have sentinel NUL.

Fri Oct 27 02:37:22 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (rb_cstr2inum): wrongly assigned base to c before
	  badcheck check.

Thu Oct 26 02:42:50 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb: Command#critical_ok

	* lib/net/smtp.rb: clear critical flag before go to SMTP

Wed Oct 25 12:30:19 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* array.c (rb_ary_concat): replacing array might be the receiver
	  itself.  do not call rb_ary_push_m.

	* array.c (rb_ary_replace): replacing array might be the receiver
	  itself.  use memmove.

Fri Oct 20 07:56:23 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_eval): ARGSPUSH should not modify args array.

Thu Oct 19 14:58:17 2000  WATANABE Tetsuya  <tetsu@jpn.hp.com>

	* pack.c (NUM2U32): should use NUM2ULONG().

Tue Oct 17 17:30:34 2000  WATANABE Hirofumi  <eban@ruby-lang.org>

	* eval.c (error_print): ruby_sourcefile may be NULL.

Tue Oct 17 16:36:28 2000  Wes Nakamura  <wknaka@pobox.com>

	* pack.c (NATINT_U32): wrong use of sizeof.

Tue Oct 17 12:48:20 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* eval.c (rb_abort): nil check against ruby_errinfo.

	* eval.c (rb_thread_schedule): use FOREACH_THREAD_FROM instead of
	  FOREACH_THREAD, since curr_thread may be removed from thread ring.

	* eval.c (THREAD_ALLOC): errinfo should be Qnil.

	* eval.c (rb_callcc): th->prev,th->next are now already
	  initialized in THREAD_ALLOC.

Mon Oct 16 15:37:33 2000  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* eval.c (rb_thread_inspect): tag size was shorter than required.

	* object.c (rb_obj_inspect): ditto.

Mon Oct 16 14:25:18 2000  Shugo Maeda  <shugo@ruby-lang.org>

	* object.c (sym_inspect): used `name' before initialization.

Mon Oct 16 14:06:00 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* pack.c (pack_pack): use NATINT_U32 for 'l', 'L', and 'N'.

	* pack.c (I32,U32): 32 bit sized integer.

	* pack.c (OFF16,OFF32B): big endian offset for network byteorder.

Mon Oct 16 06:39:32 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/http.rb: hex-alpha is not [a-h] but [a-f].

Mon Oct 16 01:02:02 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_thread_start_0): should not abort on exception if
	  $SAFE >= 4.

	* parse.y (sym): symbols for class variable names.

Sun Oct 15 01:49:18 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* file.c (rb_file_flock): should accept interrupt.

	* process.c (rb_waitpid): ditto.

	* process.c (rb_waitpid): ditto.

	* process.c (proc_wait): ditto.

	* process.c (proc_waitpid2): wrong recursion.

Sat Oct 14 03:32:13 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_thread_alloc): should not link a new thread in the
	  live thread ring before initialization.

Fri Oct 13 17:08:09 2000  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/imap.rb: new file.

Thu Oct 12 18:56:28 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/pop.rb: POP3#reset

	* lib/net/http.rb: a code for "Switch Protocol" was wrongly 100.

Thu Oct 12 01:23:38 2000  Wakou Aoyama  <wakou@fsinet.or.jp>

	* lib/cgi.rb: bug fix: CGI::html(): PRETTY option didn't work.

Thu Oct 12 00:03:02 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* object.c (sym_inspect): should adjust string length.

	* struct.c (rb_struct_to_s): ditto.

	* struct.c (rb_struct_inspect): ditto.

Wed Oct 11 22:15:47 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* eval.c (rb_thread_inspect): should adjust string length.

	* object.c (rb_any_to_s): ditto.

	* object.c (rb_obj_inspect): ditto.

Wed Oct 11 18:13:50 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_thread_start_0): should check insecure exit.

Wed Oct 11 14:29:51 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb: 2nd arg for ProtocolError#initialize is
	  optional.

	* lib/net/http.rb: code refining.

Wed Oct 11 11:13:03 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (primary): setter method (e.g. foo=) should always be
	  public.

	* eval.c (rb_thread_raise): should not raise SecurityError if
	  exception raised by the interpreter.

	* eval.c (rb_thread_cleanup): skip all THREAD_KILLED threads
	  before FOREACH_THREAD.

Tue Oct 10 16:11:54 2000  WATANABE Hirofumi  <eban@ruby-lang.org>

	* dln.c (dln_load): remove unused code for cygwin.

Tue Oct 10 09:49:23 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* file.c (Init_File): FileTest.size should return 0 (not nil) for
	  empty files.

Sun Oct  8 13:20:26 2000  Guy Decoux  <decoux@moulon.inra.fr>

	* eval.c (POP_SCOPE): not just set SCOPE_DONT_RECYCLE, but do
	  scope_dup().

Sat Oct  7 15:10:50 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_reverse_bang): unnecessary ALLOCA_N() was
	  removed.

Fri Oct  6 14:50:24 2000  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/extmk.rb.in, lib/mkmf.rb: remove "DESTDIR =".

	* Makefile.in, win32/Makefile.sub, ruby.1: renamed -X to -C.

Fri Oct  6 12:50:52 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* array.c (rb_ary_plus): use to_ary(), not Check_Type().

	* array.c (rb_ary_concat): ditto.

	* gc.c (rb_gc): use __builtin_frame_address() for gcc.

	* eval.c (stack_length): ditto.

	* parse.y (assign_in_cond): stop warning till some better warning
	  condition will be found.

Thu Oct  5 18:02:39 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* object.c (rb_obj_dup): should have propagated taint flag.
	  (ruby-bugs:#PR64,65)

Wed Oct  4 00:26:11 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (proc_arity): proc{|a|}'s arity should be -1.

Mon Oct  2 05:28:58 2000  akira yamada  <akira@ruby-lang.org>

	* string.c (trnext): minus at the end of pattern.

Sun Oct  1 00:43:34 2000  WATANABE Hirofumi  <eban@ruby-lang.org>

	* configure.in: exp-name was wrong on cygwin and mingw32.

Thu Sep 28 14:57:09 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* regex.c (re_compile_pattern): should try must_string calculation
	  every time.

Tue Sep 19 23:47:44 2000  SHIROYAMA Takayuki  <psi@fortune.nest.or.jp>

	* configure.in, config.guess, config.sub: MacOS X support.

Wed Sep 27 18:40:05 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* stable version 1.6.1 released.

Wed Sep 27 16:13:05 2000  WATANABE Hirofumi  <eban@ruby-lang.org>

	* mkconfig.rb: variables should be expanded only if /\$\{?\w+\}?/.

Tue Sep 26 18:09:51 2000  WATANABE Hirofumi  <eban@ruby-lang.org>

	* string.c: include <math.h>

Tue Sep 26 15:59:50 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* object.c (rb_mod_dup): metaclasses of class/module should not be
	  cleared by rb_obj_dup.

Tue Sep 26 02:44:54 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* gc.c (GC_MALLOC_LIMIT): size extended.

	* regex.c (DOUBLE_STACK): use machine's stack region for regex
	  stack if its size is small enough.

Mon Sep 25 18:13:07 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* regex.c: include <defines.h>.

	* eval.c (rb_add_method): cache mismatch by method
	  definition. need to clear_cache_by_id every time.

Mon Sep 25 13:31:45 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* win32/win32.c (NtCmdGlob): substitute '\\' with '/'.

Mon Sep 25 00:35:01 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* defines.h: #undef HAVE_SETITIMER on cygwin.

Sun Sep 24 03:01:53 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, http.rb: typo.

Sat Sep 23 07:33:20 2000  Aleksi Niemela  <aleksi.niemela@cinnober.com>

	* regex.c (re_compile_pattern): nicer regexp error messages for
	  invalid patterns.

Sat Sep 23 03:06:25 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* variable.c (rb_autoload_load): should not require already
	  provided features. 

Fri Sep 22 15:46:21 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/http.rb: too early parameter expansion in string.

Fri Sep 22 13:58:51 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* ext/extmk.rb.in: don't use default $:

Fri Sep 22 13:42:50 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* regex.c (PUSH_FAILURE_COUNT): avoid casting warning on alpha.

	* regex.c (PUSH_FAILURE_POINT): ditto.

Fri Sep 22 10:16:21 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* win32/config.h.in: add HAVE_TELLDIR, HAVE_SEEKDIR

Thu Sep 21 19:04:34 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* ext/extmk.rb, lib/mkmf.rb (install_rb): check whether libdir is
	  directory or not.

Thu Sep 21 17:23:05 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* file.c (rb_file_s_symlink): use HAVE_SYMLINK.

	* file.c (rb_file_s_readlink): use HAVE_READLINK.

	* dir.c (dir_tell): use HAVE_TELLDIR.

	* dir.c (dir_seek): use HAVE_SEEKDIR.

	* configure.in (AC_CHECK_FUNCS): lstat, symlink, readlink,
	  telldir, seekdir checks added.

	* file.c (lstat): should use stat(2) if lstat(2) is not
	  available.

Thu Sep 21 15:59:23 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.29.

	* lib/net/http.rb: HTTPReadAdapter -> HTTPResponseReceiver

	* lib/net/http.rb (connecting): response is got in receive()

Thu Sep 21 15:49:07 2000  Wayne Scott  <wscott@ichips.intel.com>

	* lib/find.rb (find): should not follow symbolic links;
	  tuned performance too.

Wed Sep 20 23:21:38 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ruby.c (load_file): two Ctrl-D was required to stop ruby at the
	  beginning of stdin script read.

Wed Sep 20 14:01:45 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_provided): detect infinite load loop.

	* eval.c (rb_provided): too weak filename comparison.

	* eval.c (rb_thread_alloc): avoid recycling still referenced
	  dvar structures. 

	* eval.c (rb_callcc): ditto.

	* eval.c (THREAD_ALLOC): fiil dyna_vars field by ruby_dyna_vars.

Tue Sep 19 17:47:03 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* stable version 1.6.0 released.

Tue Sep 19 16:24:52 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* marshal.c (Init_marshal): provide marshal.so no more.

Tue Sep 19 14:01:01 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* configure.in, win32/setup.mak: include version number
	  in RUBY_SO_NAME.

Tue Sep 19 13:07:47 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (yylex): was confusing $~ and $_.

Tue Sep 19 13:06:53 2000  GOTOU YUUZOU  <gotoyuzo@notwork.org>

	* signal.c (rb_f_kill): signum may be a negative number, should be
	  treated by signed number.

Tue Sep 19 01:14:56 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_provide): better feature handling.

	* eval.c (rb_f_require): loading ruby library may be partial
	  state.  checks in rb_thread_loading is integrated.

	* eval.c (rb_provided): better thread awareness.

	* lib/irb/frame.rb: 6 (not 5) parameters for trace_func proc.

	* eval.c (error_print): should print error position even if
	  get_backtrace() failed.

Sat Sep 16 03:29:59 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_f_require): rb_provided() was called too early; does
	  not work well with threads.

	* parse.y (ensure): should distinguish empty ensure and non
	  existing ensure.

	* file.c (Init_File): extending File by class of FileTest was
	  serious mistake.

Thu Sep 14 02:46:54 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_thread_yield): array strip should be done in this
	  function. 

Wed Sep 13 17:01:03 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* bignum.c (rb_big_eq): incomplete value comparison of bignums.

Wed Sep 13 06:39:54 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* variable.c (rb_mod_class_variables): Module#class_variables added.

Wed Sep 13 06:09:26 2000  Wakou Aoyama  <wakou@fsinet.or.jp>

	* lib/cgi.rb: bug fix: CGI::header(): output status header.

Wed Sep 13 01:09:12 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (yylex): allow global variables like '$__a'.

Tue Sep 12 22:28:43 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* ext/socket/extconf.rb: avoid using terrible <netinet/tcp.h>
	  on cygwin 1.1.5.

Tue Sep 12 16:01:58 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* array.c (rb_ary_unshift_m): typo.

Tue Sep 12 15:37:55 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_yield_0): stripped array too much, should remove just
	  for proc_call().

Tue Sep 12 07:05:24 2000  Wakou Aoyama  <wakou@fsinet.or.jp>

	* lib/cgi.rb: version 2.0.0: require ruby1.5.4 or later.

	* lib/net/telnet.rb: version 1.6.0

Tue Sep 12 03:26:07 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (massign): use to_ary to get an array if available.

	* object.c (rb_Array): ditto.

Mon Sep 11 14:24:47 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* hash.c (ruby_setenv): should not free the element of
	  origenvironment.

	* parse.y (command_call): kYIELD moved to this rule to allow
	  'a = yield b'. (ruby-bugs-ja:#PR15) 

Mon Sep 11 01:27:54 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_yield_0): proc#call([]) should pass single value to
	  the block.

	* eval.c (callargs): reduce array allocation.

	* eval.c (massign): precise check for argument number.

Fri Sep  8 10:05:17 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* gc.c (STR_NO_ORIG): should be FL_USER2.

Thu Sep  7 14:17:51 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* string.c (rb_str_cat): should work even for concatenating same
	  string.

Wed Sep  6 17:06:38 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* variable.c (rb_cvar_declare): should check superclass's class
	  variable first.

Wed Sep  6 10:42:02 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* misc/ruby-mode.el (ruby-calculate-indent): shift continuing line
	  if previous line ends with modifier keyword.

	* misc/ruby-mode.el (ruby-parse-region): should not give up if
	  modifiers are at the end of line.

	* misc/ruby-mode.el (ruby-expr-beg): indented wrongly if modified
	  statement was size 1.

Wed Sep  6 10:41:19 2000  Kenichi Komiya  <kom@mail1.accsnet.ne.jp>

	* misc/ruby-mode.el (ruby-parse-region): modifier was not handled
	  well on emacs19.

Tue Sep  5 17:10:12 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* time.c (time_to_s): fixed zone string UTC for utc time object.

Tue Sep  5 00:26:06 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* regex.c (re_search): range worked wrongly on bm_search().

Mon Sep  4 13:40:40 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* configure.in: renamed libruby.a to libruby.{cygwin,mingw32}.a
	  on cygwin and mingw32.

Sun Sep  3 23:44:04 2000  Noriaki Harada  <tenmei@maoh.office.ne.jp>

	* io.c (NO_SAFE_RENAME): for BeOS too.

Sun Sep  3 11:31:53 2000  Takaaki Tateishi  <ttate@jaist.ac.jp>

	* parse.y (rescue): no assignment was done if rescue body was
	  empty.

Sat Sep  2 10:52:21 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (call_args,aref_args): block_call can be the last
	  argument.

	* parse.y (COND_PUSH,COND_POP): maintain condition stack to allow
	  kDO2 in parentheses in while/until/for conditions.

	* parse.y (yylex): generate kDO2 for EXPR_ARG outside of
	  while/until/for condition.

Fri Sep  1 10:36:29 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (aref_args,opt_call_args): add block_call to allow a
	  method without parentheses and with block as a last argument.

	* hash.c (rb_hash_sort): should not return nil.

	* re.c (match_aref): should use rb_reg_nth_match().

	* eval.c (POP_SCOPE): recycled scopes too much

	* eval.c (Init_eval): extend room for stack allowance.

	* eval.c (POP_SCOPE): frees scope too much.

Thu Aug 31 14:28:39 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* gc.c (rb_gc_mark): T_SCOPE condition must be more precise.

	* eval.c (scope_dup): should not make all duped scope orphan.

Thu Aug 31 10:11:47 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (stmt): allow stmt_rhs to be right hand side of multiple
	  assignment.

	* time.c (rb_time_timeval): type error should not mention the word
	  'interval'.

Wed Aug 30 23:21:20 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* numeric.c (rb_num2long): use rb_Integer() instead of independent
	  convert routine.

	* eval.c (rb_rescue2): now takes arbitrary number of exception types.

	* object.c (rb_convert_type): use rb_rescue2 now to handle NameError.

	* object.c (rb_convert_type): better error message.

Wed Aug 30 17:09:14 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* ext/Win32API/Win32API.c (Win32API_initialize): AlphaNT support.

Wed Aug 30 14:19:07 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (node_assign): should support NODE_CVASGN2 too.

Wed Aug 30 11:31:47 2000  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* ext/Win32API/Win32API.c (Win32API_initialize): add the
	  arguments checking.

	* ext/Win32API/Win32API.c (Win32API_initialize): add taint
	  checking. allow String object in the third argument.

Wed Aug 30 10:29:40 2000  Masahiro Tomita  <tommy@tmtm.org>

	* io.c (rb_f_p): flush output buffer.

Tue Aug 29 16:29:15 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (assignable): remove NODE_CVASGN3.

	* parse.y (gettable): remove NODE_CVAR3.

Tue Aug 29 02:02:14 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* lib/mkmf.rb (create_makefile): handles create_makefile("a/b").

	* ext/extmk.rb.in (create_makefile): ditto

Mon Aug 28 18:43:54 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (is_defined): now handles class variables.

	* eval.c (rb_eval): class variable behavior revisited.

	* parse.y (assignable): ditto.

	* parse.y (gettable): ditto.

	* regex.c (PUSH_FAILURE_COUNT): push/pop interval count on failure
	  stack.  this fix is inspired by the Emacs21 patch from Stefan
	  Monnier <monnier@cs.yale.edu>.

Fri Aug 25 15:24:39 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* variable.c (rb_cvar_get): should not follow __attached__.

	* variable.c (rb_cvar_set): ditto.

	* variable.c (rb_cvar_declare): ditto.

	* variable.c (mod_av_set): second class variable assignment at the
	  toplevel should not give warning.

Fri Aug 25 01:18:36 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (next_argv): prepare path for open file.

	* string.c (rb_str_setter): moved from io.c.

	* io.c (next_argv): filename should be "-" for refreshed ARGF.

Thu Aug 24 15:27:39 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* ext/socket/socketport.h: use `extern int h_errno' if needed.

Sat Aug 19 01:34:02 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* ext/sdbm/_sdbm.c (sdbm_prep): flags should be or-ed by O_BINARY on
	  Win32 too.

	* ext/sdbm/_sdbm.c (makroom): fill hole with 0 on Win32 too.

Fri Aug 18 13:23:59 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_eval): should preserve and clear $! value before
	  compilation. 

	* eval.c (eval): ditto.

Fri Aug 18 11:06:19 2000  Shugo Maeda  <shugo@ruby-lang.org>

	* ext/socket/socket.c (s_accept): start GC on EMFILE/ENFILE.

Thu Aug 17 16:04:48 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (is_defined): should clear ruby_errinfo.

Thu Aug 17 04:26:31 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.27.

	* lib/net/protocol.rb: writing methods returns written byte size.

	* lib/net/smtp.rb: send_mail accepts many destinations.

Wed Aug 16 00:43:47 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* time.c (time_s_times): use CLK_TCK for HZ if it's defined.

Tue Aug 15 17:30:59 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (frame_dup): should set flag FRAME_MALLOC after
	  argv allocation.

	* eval.c (blk_free): should not free argv if GC was called before
	  frame_dup.

Tue Aug 15 16:08:40 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* configure.in: add ac_cv_func_times=yes for mingw32.

	* win32/win32.c (mytimes): typo.

Tue Aug 15 01:45:28 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* io.c (argf_eof): should return true at the end of ARGF without
	  checking stdout if arguments are given.

Mon Aug 14 10:34:32 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_thread_status): status should return false for normal
	  termination, nil for termination by exception.

Fri Aug 11 15:43:46 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_undef): give warning for undefining __id__, __send__.

Thu Aug 10 08:05:03 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_callcc): returned current thread instead of
	  continuation wrongly.

Thu Aug 10 05:40:28 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* ext/extmk.rb.in: $CPPFLAGS should be initialized.

	* ext/tcltklib/depend: add stubs.o.

	* ext/tcltklib/extconf.rb: use $CPPFLAGS instead of $CFLAGS.

Wed Aug  9 16:31:48 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* eval.c (rb_callcc): thread status for continuations must be
	  THREAD_KILLED, otherwise thread_free() breaks other threads.

Wed Aug  9 13:24:25 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* win32/win32.[ch]: emulate rename(2).

Tue Aug  8 14:01:46 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* ext/tcltklib/tcltklib.c: support --enable-tcltk_stubs

	* ext/tcltklib/extconf.rb: ditto.

	* ext/tcltklib/stubs.c: created. examine candidate shared libraries.

Mon Aug  7 13:59:12 2000  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* ruby.h (CLONESETUP): should copy flags before any potential
	  object allocation.

	* regex.c (re_match): check for stack depth was needed.

Sat Aug  5 16:43:43 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* djgpp/*: convert DOS line endings to UNIX style.

	* djgpp/config.status: rename to config.sed for SFN.

	* lib/ftools.rb (compare, safe_unlink, chmod): avoid warnings.

	* lib/ftools.rb (move): typo. not `tpath', but `to'.

Fri Aug  4 23:26:48 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (proc_call): gives warning if a block is supplied.

	* eval.c (rb_eval): no warning for discarding if an alias for the
	  method is already made.

Fri Aug  4 16:32:29 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* array.c (rb_ary_reject_bang): returns nil if no element removed.

	* hash.c (rb_hash_reject_bang): returns nil if no element removed.

Thu Aug  3 19:44:26 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (rb_thread_fd_writable): should return integer value.

	* array.c (rb_ary_assoc): search array element whose length is
	  longer than 0 (not 1).

Wed Aug  2 18:27:47 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (rb_thread_wait_fd): prohibit thread context switch
	  during compilation.

	* eval.c (rb_cont_call): prohibit Continuation#call across threads.

Wed Aug  2 08:22:04 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* gc.c (rb_gc): clear malloc_memories to zero, to avoid potential
	  super frequent GC invocation. (ruby-bugs:#PR48)

	* gc.c (rb_gc): only add_heap() if GC trigger condition is
	  satisfied.

Tue Aug  1 16:41:58 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* ruby.c (proc_options): global load path setting moved from
	  ruby_prog_init().

	* ruby.c (incpush): renamed.  push path entry at the END of the
	  load path array.  This makes -I directories sorted in order in
	  the arguments.

Sat Jul 29 23:42:04 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* dir.c (dir_each): should check whether dir is closed during the
	  block execution. (ruby-bugs:#PR47)

Sat Jul 29 21:57:30 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* ruby.c (rubylib_mangle): provide another buffer for the result.

Wed Jul 26 10:09:01 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* configure.in: set SOLIBS to LIBS on Cygwin.

	* configure.in: LIBRUBY_SO='$(RUBY_INSTALL_NAME)'.$target_os.dll
	  on cygwin and mingw32. ruby-cygwin.dll is bad. why?

Wed Jul 26 10:04:03 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* gc.c (gc_sweep): avoid full scan during compilation.

	* gc.c (rb_gc): add heap during no gc period (including
	  compilation).

Tue Jul 25 19:03:04 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* cygwin/GNUmakefile: use puts instead of print, because
	  Cygwin DLL's behavior is changed(or bug?).

	* configure.in: LIBRUBY_SO='$(RUBY_INSTALL_NAME)'-$target_os.dll
	  on cygwin and mingw32.

	* cygwin/GNUmakefile: ditto.

	* Makefile.in: $(SOLIBS) should be put after dmyext.@OBJEXT@.

	* instruby.rb: install $(LIBRUBY) to libdir
	  if $(LIBRUBY) != $(LIBRUBY_A_).

Tue Jul 25 15:16:00 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* io.c (rb_p): redirect to $defout.

Mon Jul 24 18:52:55 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* win32/win32.c (win32_getenv): should remove `static'.

	* ruby.c (rubylib_mangle): support "/hoge;/foo"

Mon Jul 24 10:28:55 2000  GOTO Kentaro  <gotoken@math.sci.hokudai.ac.jp>

	* string.c (rb_str_count): raise exception if no argument is
	  given.

Sun Jul 23 12:55:04 2000  Dave Thomas  <Dave@Thomases.com>

	* string.c (rb_str_rindex): Support negative end position.

Fri Jul 21 17:35:01 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* parse.y (aref_args): command_call now be permitted as
	  aref_args.

	* process.c (proc_getpriority): getpriority(2) may return valid
	  negative number.  use errno to detect error.

	* marshal.c (dump_ensure): dumped string should be tainted if
	  any among target objects is tainted.

	* marshal.c (r_regist): restored object should be tainted if and
	  only if the source is a file or a tainted string.

Wed Jul 19 15:14:04 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* bignum.c (bigdivrem): should use rb_int2big(), not rb_uint2big().

Tue Jul 18 14:58:30 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (ruby_options): should treat SystemExit etc. properly.

	* parse.y (yycompile): should check compile_for_eval, not
	  ruby_in_eval.

Mon Jul 17 04:29:50 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/mkmf.rb: converts extension of $objs into $OBJEXT.

Sun Jul 16 03:02:34 2000  Dave Thomas <dave@thomases.com>

	* lib/weakref.rb: Change to use new ObjectSpace calls.

Sat Jul 15 21:59:58 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (rb_eval): should not redefine __id__ nor __send__.

	* gc.c (define_final): integrate final.rb features into the
	  interpreter.  define_finalizer and undefine_finalizer was
	  added to ObjectSpace.  plus, add_finalizer, remove_finalizer,
	  and call_finalizer are deprecated now.

Sat Jul 15 01:32:34 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (rb_mod_method): implements unbound method.

	* eval.c (Init_eval): should prohibit `module_function' for class
	  Class.

Fri Jul 14 17:19:59 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* cygwin/GNUmakefile.in: use miniruby instead of sed.

Fri Jul 14 12:49:50 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* io.c (argf_eof): need to check stdin, when next_p == -1.

	* io.c (read_all): use io_fread() instead of fread(3).

	* io.c (io_reopen): should clearerr FILE if fd < 3.

	* re.c (rb_reg_match_m): the result is exported, so it should be
	  declared as busy.

	* eval.c (rb_eval): should preserve errinfo even if return, break,
	  etc. is called in rescue clause.

	* instruby.rb: install irb too.

Wed Jul 12 15:32:57 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* variable.c (rb_const_get): constants for builtin classes must
	  have higher priority than constants from included modules at
	  Object class.

	* bignum.c (bigdivrem): small embarrassing typo.

Wed Jul 12 15:06:28 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (rb_eval): use rb_const_get_at().

	* variable.c (top_const_get): retrieve toplevel constants only,
	  not ones of Object (and its included modules) in general.

Wed Jul 12 15:04:11 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.26.

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb:
	  add module Net::NetPrivate and its inner classes
	  {Read,Write}Adapter, Command, Socket,
	  SMTPCommand, POP3Command, APOPCommand, HTTPCommand

Wed Jul 12 13:10:30 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* bignum.c (bigdivrem): defer bignorm().

	* bignum.c (bignorm): accepts accidental fixnums.

Tue Jul 11 16:54:17 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* parse.y (yylex): `@<digit>' is no longer a valid instance
	  variable name.

Tue Jul 11 01:51:50 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* bignum.c (rb_big_divmod): should not use Integer(float) for
	  the right operand.

	* bignum.c (rb_big_remainder): ditto.

	* bignum.c (rb_big_modulo): ditto.

Mon Jul 10 15:27:16 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* io.c (pipe_finalize): should set rb_last_status when pclose().

Mon Jul 10 09:07:54 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* error.c (rb_bug): print version number and such too.

Sat Jul  8 23:08:40 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (rb_thread_start_0): should copy previous scopes to
	  prevent rb_gc_force_recycle().

Fri Jul  7 23:36:36 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* ext/socket/addrinfo.h: move IN_EXPERIMENTAL and IN_LOOPBACKNET
	  definitions to ext/socket/sockport.h.

	* ext/socket/extconf.rb: add getservbyport() and arpa/inet.h check.

	* ext/socket/getaddrinfo.c (getaddrinfo): SOCK_RAW may not be
	  defined (ex. BeOS, Palm OS 2.x or before).

	* ext/socket/getnameinfo.c (getnameinfo): getservbyport() may not
	  exist (ex. BeOS, Palm OS).

	* ext/socket/sockport.h: add IN_EXPERIMENTAL, IN_CLASSA_NSHIFT,
	  IN_LOOPBACKNET, AF_UNSPEC, PF_UNSPEC and PF_INET.

Fri Jul  7 03:30:00 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* parse.y (aref_args): should allow Hash[:a=>2] etc.

	* numeric.c (fix_aref): convert index by NUM2INT, not FIX2INT. 
	  (ruby-bugs:#PR37)

	* time.c (time_localtime): should prohibit for frozen time.

	* time.c (time_gmtime): ditto.

Thu Jul  6 19:12:12 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* io.c (rb_file_s_open): should not terminate fptr; just clear it.

	* ruby.c (proc_options): should not call require_libraries()
	  twice.

	* ruby.c (require_libraries): clear req_list_head.next after
	  execution. 

Thu Jul  6 13:51:57 2000  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* object.c (rb_to_id): name may not be symbol nor fixnum.

	* struct.c (rb_struct_s_def): name may be nil.

Thu Jul  6 02:09:06 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* bignum.c (bigdivrem): new function to return remainder.

	* numeric.c (fixdivmod): now returns modulo, not remainder.

	* numeric.c (flodivmod): ditto.

	* bignum.c (bigdivmod): ditto.

	* numeric.c (num_modulo): new method; alias to '%'.

Thu Jul  6 00:51:43 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* win32/win32.c (NtCmdGlob): patterns should be separated and
	  NUL terminated.

Wed Jul  5 22:27:56 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* cygwin/GNUmakefile: use ruby.def to make rubycw.dll.

	* ext/extmk.rb.in: create target.def.

	* lib/mkmf.rb: ditto.

Wed Jul  5 09:47:14 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* time.c (time_arg): Time::local, Time::gm now take 7th optional
	  argument for usec.

	* numeric.c (num_ceil, etc): default ceil, floor, round, truncate
	  implementation for Numeric, using `to_f'.

	* io.c (rb_io_reopen): clear fptr->path after free() to prevent
	  potential GC crash.

	* io.c (rb_file_s_open): terminate fptr unless null.

	* io.c (rb_file_initialize): ditto.

	* lib/tempfile.rb: specify FILE::CREAT|File::EXCL to open for
	  better security.

	* numeric.c (flo_truncate): new method.

Wed Jul  5 01:02:53 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* ext/extmk.rb.in: join ' ' -> join(' ').

	* lib/mkmf.rb: ditto.

Tue Jul  4 13:51:29 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* ext/dbm/dbm.c: add methods added to Hash in 1.5.x.

	* ext/gdbm/gdbm.c: ditto.

	* ext/sdbm/init.c: ditto.

	* eval.c (proc_call): args may be Qundef (means no argument), do
	  not call TYPE() for args.

Tue Jul  4 13:20:56 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* ext/extmk.rb.in: make command line must be single-quoted.
	  $(RUBY_INSTALL_NAME) is command substitution in the POSIX sh.

Tue Jul  4 13:16:02 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* util.c (rb_type): should add T_UNDEF.

Tue Jul  4 09:30:35 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* parse.y (here_document): supports EOF right after terminator.

	* random.c (rb_f_rand): argument is now optional (rand(max=0)). 

Tue Jul  4 01:50:49 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* win32/ruby.def: remove ruby_mktemp.

Tue Jul  4 01:27:13 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (rb_rescue2): new function to rescue arbitrary exception.

	* numeric.c (do_coerce): should catch NameError explicitly.

Tue Jul  4 00:15:23 2000  Dave Thomas  <Dave@thomases.com>

	* numeric.c (Init_Numeric): forgot to register Numeric#remainder.

Mon Jul  3 23:46:56 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* win32/win32.c (myselect, myaccept): disable interrupt while
	  executing accept() or select() to avoid Ctrl-C causes
	  "unknown software exception (0xc0000029)".

Mon Jul  3 18:35:41 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* lib/mkmf.rb: use null device if it exists for cross-compiling.

Mon Jul  3 18:19:51 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.26.

	* lib/net/protocol.rb (finish): do nothing unless active.

	* lib/net/http.rb: HTTP#{get,post}2 again (for new impl).

Mon Jul  3 16:47:22 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* cygwin/GNUmakefile: librubys.a -> lib$(RUBY_INSTALL_NAME)s.a

	* configure.in: use AC_CANONICAL_{HOST,TARGET,BUILD}.

Mon Jul  3 13:15:02 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* numeric.c (fix_divmod): x * d + m = y where d, m = x.divmod(y).

	* bignum.c (rb_big_divmod): ditto.

	* numeric.c (fixdivmod): does not depend C's undefined %
	  behavior.  adopt to fmod(3m) behavior.

	* numeric.c (flo_mod): modulo now reserves fmod(3m) behavior.

	* numeric.c (num_remainder): 'deprecated' warning.

Mon Jul  3 10:27:28 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* configure.in: use AC_CANONICAL_SYSTEM.

Sun Jul  2 21:17:37 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* configure.in: support without --enable-shared for cygwin/mingw32.

	* cygwin/GNUmakefile: ditto.

	* ext/extmk.rb.in: use null device if it exists for cross-compiling.

	* lib/mkmf.rb: ditto.

	* util.c (ruby_mktemp): remove unused ruby_mktemp().

Sun Jul  2 14:18:04 2000  Koji Arai  <JCA02266@nifty.ne.jp>

	* eval.c (TMP_PROTECT_END): tmp__protect_tmp may be NULL.

Sun Jul  2 03:37:50 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.25.

	* lib/net/protocol.rb (each_crlf_line): beg = 0 is needed in adding{}

	* lib/net/smtp.rb: allow String for to_addr of SMTP#sendmail

Sat Jul  1 15:22:35 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* numeric.c (fix_rshift): should handle shift value more than
	  sizeof(long). 

Sat Jul  1 15:22:35 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (rb_eval): the value from RTEST() is not valid Ruby
	  object.  result should be either true or false.

Sat Jul  1 09:30:06 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* re.c (rb_reg_initialize): was freeing invalid pointer.

Sat Jul  1 03:25:56 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* parse.y (call_args): command_call can be the last argument of
	  call_args.  It had to be the only argument.

	* re.c (rb_reg_s_quote): should not dump core even for unsane mbc
	  string.

Fri Jun 30 01:36:20 2000  Aleksi Niemela  <aleksi.niemela@cinnober.com>

	* parse.y (f_norm_arg): better, nicer error message.

Thu Jun 29 07:45:33 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* ext/socket/socket.c (udp_send): destination may be packed
	  struct sockaddr.

	* object.c (rb_Integer): Integer(nil) should be invalid, on the
	  other hand, nil.to_i is OK.

Wed Jun 28 17:26:06 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* ext/socket/socket.c (ip_recvfrom): udp_recvfrom and tcp_recvfrom
	  is merged and moved to IPSocket#recvfrom.

	* ext/socket/socket.c (sock_s_getaddrinfo): family can be a
	  strings such as "AF_INET" etc.

	* ruby.c (require_libraries): . and RUBYLIB added to $load_path
	  just before -r procedure.

	* ruby.c (proc_options): -e, - did not exec -r.

Wed Jun 28 14:52:28 2000  Koga Youichirou <y-koga@mms.mt.nec.co.jp>

	* config.sub: NetBSD/hpcmips support.

Wed Jun 28 10:11:06 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* gc.c: gc trigger threshold changed; GC_NEWOBJ_LIMIT removed,
	  FREE_MIN is increased to 4096.

Tue Jun 27 22:39:28 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.24.

	* lib/net/protocol.rb: modified each_crlf_line again.

	* lib/net/protocol.rb: do_write_beg,do_write_end -> writing{}
	  do_write_do -> do_write

	* lib/net/http.rb: can make proxy connection by passing
	  addresses to HTTP.new, start.

	* lib/net/http.rb: HTTP.new_implementation, old_implementation:
	  can use 1.2 implementation of head, get, post, put.
	  (see document)

Tue Jun 27 12:05:10 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* win32.c (myfdclr): new function.

	* win32.h: add FD_CLR.

Mon Jun 26 23:41:41 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* ruby.h: add cast for ANSI style.

	* gc.c (rb_data_object_alloc): use RUBY_DATA_FUNC.

Mon Jun 26 22:20:03 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* win32/win32.c (is_socket, extract_file_fd): New function.

	* win32/win32.c (myfdopen): use is_socket().

	* win32/win32.c (myselect): return non socket files immediately
	  if file and socket handles are mixed.

Mon Jun 26 16:21:30 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (rb_thread_schedule): wait_for cleared too early.

Mon Jun 26 09:15:31 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* pack.c: remove obsolete 'F', 'D' specifiers.

Sun Jun 25 00:55:03 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* ext/socket/socket.c (sock_s_getnameinfo): `res' would not
	  be assigned if TYPE(sa) == T_STRING.

Sat Jun 24 14:36:29 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* config*.dj, configure.bat, top.sed: move to djgpp/.

Sat Jun 24 02:34:17 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* ruby.c (load_file): call require_libraries() here to let
	  debug.rb work properly.

Fri Jun 23 22:34:51 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* bignum.c (rb_big_lshift): reorder xds assignment to avoid
	  reusing `x' as `len' by VC++ 6.0 SP3 compiler with -Ox switch.

Fri Jun 23 01:11:27 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* string.c (rb_str_substr): should return empty string (""), 
	  if beg == str.size and len == zero, mostly for convenience and
	  backward compatibility.

	* parse.y (new_super): should tweak block_pass node for super too.

	* string.c (rb_str_split_m): last split element should not be nil,
	  but "" when limit is specified.

Thu Jun 22 17:27:46 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* string.c (rb_str_substr): str[n,m] now returns nil when n equals
	  to str.size.

Thu Jun 22 13:49:02 2000  Uechi Yasumasa <uechi@ryucom.ne.jp>

	* lib/net/ftp.rb: support resuming.

Thu Jun 22 13:37:19 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* eval.c (rb_thread_sleep_forever): merge pause() macro.

Wed Jun 21 08:49:04 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (rb_eval): should not raise exception just by defining
	  singleton class.

Wed Jun 21 01:18:03 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* ruby.h: two macros RUBY_DATA_FUNC and RUBY_METHOD_FUNC are added
	  to make writing C++ extensions easier.

	* array.c (rb_ary_dup): internal classes should not be shared by dup.

	* hash.c (rb_hash_dup): ditto.

	* object.c (rb_obj_dup): ditto.

	* string.c (rb_str_dup): ditto.

	* error.c (Init_Exception): renamed NotImplementError to
	  NotImplementedError. 

Tue Jun 20 16:22:38 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* time.c (make_time_t): bug in DST boundary.

Tue Jun 20 10:54:19 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* configure.in: add eval sitedir.

Tue Jun 20 06:14:43 2000  Wakou Aoyama  <wakou@fsinet.or.jp>

	* lib/cgi.rb: change: version syntax. old: x.yz, now: x.y.z

	* lib/net/telnet.rb: ditto.

Tue Jun 20 00:37:45 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* re.c (rb_reg_kcode_m): Regexp#kcode returns nil for code unfixed
	  regexp object.

	* bignum.c (bigdivmod): bignum zero check was wrong.

Mon Jun 19 10:48:28 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* variable.c (rb_cvar_set): forgot to add security check for class
	  variable assignment.

Sun Jun 18 22:49:13 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* configure.in: single quoted sitedir.

	* mkconfig.rb: add DESTDIR for cross-compiling.

	* lib/mkmf.rb: add DESTDIR.

	* ruby.c (load_file): force binmode if fname includes ".exe"
	  on DOSISH.

Sat Jun 17 23:22:17 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* sprintf.c (rb_f_sprintf): should ignore negative precision given
	  by <%.*>.

	* sprintf.c (rb_f_sprintf): should allow zero precision.

Sat Jun 17 03:13:29 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* time.c (time_localtime): avoid unnecessary call of localtime.

	* time.c (time_gmtime): avoid unnecessary call of gmtime.

	* process.c (proc_wait2): new method.

	* process.c (proc_waitpid): second argument made optional.

	* process.c (proc_waitpid2): new method.

Sat Jun 17 00:05:00 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* re.c (rb_reg_clone): should initialize member fields.

Fri Jun 16 22:49:34 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* io.c (rb_io_rewind): set lineno to zero.

Fri Jun 16 22:47:47 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.23.

	* lib/net/protocol.rb: too many CRLF in last line.

Fri Jun 16 21:23:59 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* configure.in: add pause(2) checking.

	* eval.c: define pause() if missing.

Fri Jun 16 18:41:58 2000  Koji Arai  <JCA02266@nifty.ne.jp>

	* process.c (proc_setsid): BSD-style setpgrp() don't return 
	  process group ID, but 0 or -1.

Fri Jun 16 16:23:35 2000  Koji Arai  <JCA02266@nifty.ne.jp>

	* file.c (rb_stat_inspect): gives detailed information;
	  compatibility with ruby-1.4.x.

Fri Jun 16 05:18:45 2000  Yasuhiro Fukuma  <yasuf@bsdclub.org>

	* configure.in: FreeBSD: do not link dummy libxpg4 which was
	  merged into libc.

Fri Jun 16 03:17:36 2000  Satoshi Nojo  <nojo@t-samukawa.or.jp>

	* ext/dbm/dbm.c (fdbm_length): use GetDBM. empty?, [] too.

	* ext/gdbm/gdbm.c (fgdbm_length): ditto.

	* ext/sdbm/init.c (fsdbm_length): ditto.

Fri Jun 16 01:57:31 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (rb_thread_sleep_forever): pause(2) instead of sleep(3).

Thu Jun 15 10:46:36 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* string.c (rb_str_sub_bang): should probagate taintness from
	  replacement string.

Wed Jun 14 17:01:41 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* rubytest.rb: add CONFIG['EXEEXT'] to the executable file name.

Wed Jun 14 14:50:00 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* string.c (rb_f_sub): assign to $_ only if modification happens.

	* string.c (rb_f_gsub): ditto.

	* string.c (rb_f_chop): ditto.

	* string.c (rb_f_chomp): ditto.

	* io.c (io_reopen): preserve file position by ftell/fseek, if io
	  is a seekable.

	* eval.c (method_arity): wrong arity number for the methods with
	  optional arguments.

	* time.c (make_time_t): opposite timezone shift (should be negative).

Wed Jun 14 14:07:38 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* io.c: typo(ig/if).

	* re.c: typo(re/reg). add rb_reg_check().

	* time.c: remove unneeded declare(daylight, timezone).

	* configure.in: add include <time.h> when daylight checking.

Wed Jun 14 11:36:52 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* marshal.c (r_object): modified for symbols.

	* marshal.c (w_object): ditto.

Wed Jun 14 10:04:58 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* re.c (rb_memcmp): should compare according to ruby_ignorecase.

	* string.c (rb_str_cmp): use rb_memcmp.

	* string.c (rb_str_index): ditto.

	* string.c (rb_str_rindex): ditto.

	* string.c (rb_str_each_line): ditto.

Wed Jun 14 04:58:53 2000  Dave Thomas  <dave@thomases.com>

	* io.c (rb_io_set_lineno): should have returned VALUE, not
	  integer.

Wed Jun 14 09:29:42 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* string.c (rb_str_dup): dup should always propagate taintness.

Wed Jun 14 00:50:14 2000  Wakou Aoyama  <wakou@fsinet.or.jp>

	* lib/cgi.rb: read_multipart(): if no content body then raise EOFError.

Tue Jun 13 11:46:17 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* process.c (proc_setsid): try implement it using setpgrp() and
	  ioctl(fd, TIOCNOTTY, NULL).

	* re.c (rb_reg_prepare_re): magic variable $= should affect regex
	  pattern match. 

	* time.c (make_time_t): use tm.tm_gmtoff if possible.

	* time.c (time_zone): use tm.tm_zone if available.

Tue Jun 13 01:50:57 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.22.

	* lib/net/http.rb: HTTPResponse#body returns body.

Mon Jun 12 23:41:54 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* configure.in (daylight): avoid GCC optimization.

Mon Jun 12 19:02:27 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* configure.in: cygwin has strange timezone.

	* time.c (time_zone): use tzname and daylight.

Sat Jun 10 23:10:32 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* io.c (rb_io_seek): whence is optional, default is SEEK_SET.

Fri Jun  9 17:00:29 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.21.

	* lib/net/http.rb: exception is raised with response object.

Fri Jun  9 15:11:35 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* time.c (make_time_t): supports daylight saving time.

	* eval.c (rb_thread_safe_level): should retrieve current $SAFE
	  value if a thread is the current thread.

Thu Jun  8 14:25:45 2000  Hiroshi Igarashi  <iga@ruby-lang.org>

	* lib/mkmf.rb: add target `distclean' in Makefile for extlib.
	  target `clean' doesn't remove Makefile.

Thu Jun  8 13:34:03 2000  Dave Thomas  <dave@thomases.com>

	* numeric.c: add nan?, infinite?, and finite? to Float

Thu Jun  8 00:31:04 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* regex.h: export re_mbctab properly on cygwin.

	* dln.c: use dlopen instead of LoadLibrary on cygwin.

Thu Jun  8 13:41:34 2000  Tadayoshi Funaba  <tadf@kt.rim.or.jp>

	* file.c (rb_file_s_basename): might dump core.

Tue Jun  6 03:29:12 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* dir.c (dir_foreach): now returns nil for consistency.

	* bignum.c (bigdivmod): modulo by small numbers was wrong.

Mon Jun  5 00:18:08 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* bignum.c: avoid conflict with USHORT on mingw32.

Mon Jun  5 00:13:35 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* eval.c (rb_thread_schedule): =/== typo.

Sun Jun  4 03:17:36 2000  Wakou Aoyama  <wakou@fsinet.or.jp>

	* lib/cgi.rb: improve: CGI::pretty()

Sun Jun  4 02:01:10 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* lib/mkmf.rb: do not need to add -L$(topdir) in --enable-shared case.

Sat Jun  3 13:50:06 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* parse.y (rb_id2name): should support constant attrset
	  identifiers. 

	* bignum.c (rb_big_eq): Bignum#== should not raise exception.

Fri Jun  2 11:24:48 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* io.c (rb_io_popen): open with a block returns the value from the
	  block.  old behavior was back.

Fri Jun  2 00:42:31 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>


	* eval.c (rb_thread_cleanup): should clear priority for thread
	  termination.

Thu Jun 01 22:39:41 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.20.

	* lib/net/http.rb: wrongly closed the socket twice
	  when no Content-Length: was given.

Thu Jun  1 00:59:15 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (rb_yield_0): convert Qundef to [].

Wed May 31 20:45:59 2000  Dave Thomas  <Dave@Thomases.com>

	* string.c (rb_str_slice_bang): wrong argument number.

Wed May 31 12:37:04 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (rb_exec_end_proc): print error message from END procs.

Wed May 31 04:06:41 2000  Wakou Aoyama  <wakou@fsinet.or.jp>

	* lib/cgi.rb: change: CGI#out() if "HEAD" == REQUEST_METHOD then
	  output only HTTP header.

Wed May 31 01:54:21 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (rb_thread_schedule): set main_thread->status to
	  THREAD_TO_KILL, before raising deadlock error.

	* eval.c (rb_thread_deadlock): if curr_thread == main_thread, do
	  not call rb_thread_restore_context()

Tue May 30 23:33:41 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* lib/mkmf.rb (create_makefile): add $(TARGET).ilk and *.pdb
	  to cleanup files for mswin32.

Mon May 29 10:41:10 2000  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* file.c (rb_file_s_basename): should propagate taintness.

Sun May 28 21:37:13 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* eval.c: bug fix: DLEXT2.

Sun May 28 19:21:43 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* win32/win32.c: use ruby's glob.

	* dir.c: "glob" exported and renamed to "rb_glob".

	* ruby.h: ditto.

	* main.c: turn off command line mingw32's globbing.

Wed May 25 22:25:13 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* ext/extmk.rb.in: use "ftools" instead of "rm -f".

	* lib/mkmf.rb: ditto.

Thu May 25 22:01:32 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* defines.h: mswin32: remove obsolete USHORT definition.

	* re.h: mswin32: use EXTERN instead of extern.

	* regex.h: mswin32: export re_mbctab properly.

	* win32/ruby.def: add ruby_ignorecase and regex.c's exports.

Thu May 25 21:28:44 2000  Minero Aoki <aamine@dp.u-netsurf.ne.jp>

	* re.c (rb_reg_expr_str): escape un-printable character.

Thu May 25 01:35:15 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* parse.y (tokadd_escape): forgot to add `\x' to hexadecimal
	  escape sequences.

	* object.c (rb_obj_dup): dup for normal object (T_OBJECT) copies
	  instance variables only.

Wed May 24 23:49:47 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* object.c (rb_mod_initialize): should provide initialize.

Wed May 24 23:17:50 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* win32/Makefile: remove unnecessary mv and rm command call.

Wed May 24 21:01:04 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* ext/pty/pty.c: use "" instead of <> to include ruby.h and rubyio.h
	  for BeOS (PowerPC).

	* file.c (rb_find_file): should check dln_find_file() result.

	* win32/ruby.def: add rb_block_given_p.

Wed May 24 16:32:45 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* io.c (rb_io_popen): popen does not take 3rd argument anymore.

	* re.c (rb_reg_desc): re may be zero, check before dereferencing.

Wed May 24 16:03:06 2000  Wakou Aoyama  <wakou@fsinet.or.jp>

	* lib/cgi.rb: bug fix: CGI::escape(), CGI::Cookie::new()

	* lib/net/telnet.rb: improve: binmode(), telnetmode() interface

Wed May 24 13:12:31 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* misc/ruby-mode.el (ruby-parse-region): support `while .. do'
	  etc. But corresponding keywords must be at the beginning of
	  line. 

Tue May 23 23:50:12 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* re.c (rb_reg_initialize_m): wrong kcode value.

	* re.c (rb_reg_s_new): forgot to initialize re->ptr.

Tue May 23 08:36:24 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* regex.c (re_compile_pattern): forgot to restore old option
	  status by (?ix-ix).

	* regex.c (re_compile_fastmap): anychar may match newline if
	  RE_OPTION_MULTILINE or RE_OPTION_POSIXLINE is set.

Mon May 22 22:45:06 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.19.

	* lib/net/http.rb: do not use Regexp "p" option.

Mon May 22 21:56:43 2000  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* struct.c (rb_struct_getmember): should use ID2SYM, not INT2NUM.

Mon May 22 15:07:37 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* file.c (rb_find_file): should check if the file really exists.

Mon May 22 09:08:12 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* io.c (rb_io_popen): _exit(0) after processing block under the
	  child process.

	* io.c (rb_io_popen): flush stdout/stderr before subprocess
	  termination.

	* eval.c (rb_check_safe_str): insert rb_secure(4); operation
	  requires untainted string should be prohibited in level 4.

Sun May 21 21:17:00 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* configure.in: add Setup.dj for djgpp cross-compiling.

	* Setup.dj: add readline.

	* instruby.rb: copy win32/win32.h to archlibdir on mingw32.

Sun May 21 20:58:08 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* pack.c: fix OFF16 and OFF32 definitions for Alpha and IRIX64.

Sun May 21 17:31:37 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* instruby.rb: support "make install" for cross-compiling.

	* ext/extmk.rb.in: ditto.

Sun May 21 14:22:49 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* Makefile.in: rename prep.rb to fake.rb.

	* configure.in: ditto.

Sat May 20 23:29:14 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* dir.c (dir_s_new): does not take block; "open" does.

	* io.c (rb_io_s_new): ditto.

Fri May 19 07:44:26 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* dir.c (dir_s_open): Dir#open does not returns closed Dir if a
	  block is given to the method.

	* re.c (rb_reg_initialize_m): Regexp::new calls initialize now.

	* string.c (Init_String): String#delete_at removed.

	* string.c (rb_str_aset_m): should have checked argc != 2.

	* eval.c (rb_thread_schedule): select(2) was called too many.

	* regex.c (re_compile_pattern): a bug in (?m) support.  Pointed
	  out by Dave Thomas <Dave@thomases.com>.

Thu May 18 23:55:26 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* dln.c (search_undef): st_lookup()'s 3rd parameter should be
	  a pointer of the variable which has the same size and alignment
	  as `char *'.

	* marshal.c (w_symbol, w_object): ditto.

	* parse.y (rb_intern): ditto.

Thu May 18 18:00:35 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.18.

	* lib/net/protocol.rb: Net::Version was removed.

	* lib/net/smtp.rb: use Socket.gethostname to get local host name.

Thu May 18 13:34:57 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* ext/socket/socket.c (ruby_connect): should not have replaced
	  thread_write_select() by rb_thread_fd_writable().

Thu May 18 09:01:25 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* configure.in, ext/extmk.rb.in, lib/mkmf.rb: remove BeOS R3 support.
	  Make a shared library (libruby.so) only if the --enable-shared
	  option is specified.

	* instruby.rb: no longer use libruby.so.LIB and import.h.

	* io.c: fix READ_DATA_PENDING definition for BeOS (PowerPC).

Wed May 17 14:14:23 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* re.c (rb_reg_new_1): use /m instead of /p.

Wed May 17 02:22:03 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (rb_thread_polling): wait 0.06 second to let other
	  processes run.

	* process.c (rb_waitpid): avoid busy wait using rb_thread_polling.

	* file.c (rb_thread_flock): ditto.

	* parse.y (expr): avoid calling value_expr() twice.

Wed May 17 00:45:57 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* io.c (rb_io_binmode): should check PLATFORMs, not O_BINARY, sigh...

Wed May 17 00:40:15 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* win32/config.h: add DLEXT2, now DLEXT on mswin32 is "so".

	* win32/config.status: ditto.

	* win32/ruby.def: add symbol "rb_big_divmod".

Tue May 16 19:45:32 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* intern.h: use EXTERN instead of extern.

	* win32/ruby.def: add rb_defout, rb_stdout, ruby_errinfo,
	  ruby_sourceline, ruby_sourcefile to work with eruby
	  reported by Hiroshi Saito <HiroshiSaito@pob.org>.
	  Export both ruby_xmalloc and xmalloc etc.

Tue May 16 17:00:05 2000  Masaki Fukushima  <fukusima@goto.info.waseda.ac.jp>

	* eval.c (rb_thread_select): should check whether fds are null.

Tue May 16 11:51:31 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* io.c (pipe_open): synchronize subprocess stdout/stderr.

Mon May 15 15:38:09 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* ruby.h: exported symbols should be for xmalloc etc. are now
	  prefixed by 'ruby_', e.g. ruby_xmalloc().

	* eval.c (rb_thread_select): remove busy wait for select.

	* dir.c (glob): trailing path may be null, e.g. glob("**").

Mon May 15 14:48:41 2000  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* io.c (rb_io_pid): new method; returns nil if no process attached
	  to the IO.

Mon May 15 01:18:20 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* io.c (rb_io_s_popen): _exit after Proc execution.

Sun May 14 18:05:59 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* Makefile.in: missing/nt.c -> win32/win32.c

	* configure.in: bug fix; static linking on mingw32.

	* cygwin/GNUmakefile.in: remove VPATH.

	* ext/extmk.rb.in: Makefile set binmode with mingw32 on cygwin32.

	* lib/mkmf.rb: ditto.

	* win32/config.h: undef HAVE_SYS_FILE_H.

Sun May 14 02:02:48 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* lib/irb/ruby-lex.rb: '/' should be escaped in character class.

Sun May 14 00:54:43 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* configure.in, ...: support mingw32.

	* defines.h: ditto. undef EXTERN for tcl/tk on cygwin.

	* ext/*/extconf.rb: replace PLATFORM with RUBY_PLATFORM.

	* ext/socket/sockport.h: define IN_MULTICAST for missing IN_MULTICAST.

	* ext/tcltklib/tcltklib.c: remove declaration of rb_argv0.

	* file.c: should check S_IXGRP, S_ISGID, not NT.

	* io.c (rb_io_binmode): should check _IOBIN, O_BINARY, not PLATFORMs.

Sat May 13 14:21:15 2000  Koji Arai  <JCA02266@nifty.ne.jp>

	* io.c (rb_io_s_popen): should check whether a block is given.

Fri May 12 17:33:44 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* regex.c (re_compile_pattern): charset_not should not exclude
	  newline from matching set.

Thu May 11 22:51:05 2000  Ryunosuke Ohshima  <ryu@jaist.ac.jp>

	* pack.c (pack_pack): Bignum support.

	* pack.c (pack_unpack): ditto.

Thu May 11 21:19:29 2000  Hiroshi Igarashi  <iga@ruby-lang.org>

	* intern.h: add missing declarations of ruby API functions.

	* ruby.h: fix function name in declarations.

Thu May 11 22:29:25 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* ext/md5/depend: add $(topdir)/config.h dependency to md5c.o.

	* ext/md5/extconf.rb: new file to add -DHAVE_CONFIG_H flag for Alpha.

Thu May 11 10:55:52 2000  Ryunosuke Ohshima  <ryu@jaist.ac.jp>

	* pack.c (pack_pack): packing BER compressed integer by `w'.

	* pack.c (pack_unpack): unpacking BER.

Thu May 11 00:37:55 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* parse.y (parse_regx): remove in_brack.

Wed May 10 12:51:18 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* ruby.c (proc_options): move adding RUBYLIB and "." to the load
	  path after #! line parsing.

	* parse.y (parse_regx): should parse backslash escape like `\c['
	  here to avoid causing `unterminated regexp' error.

Wed May 10 00:19:53 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* MANIFEST, beos/GNUmakefile.in, configure.in: no longer need
	  beos/GNUmakefile.in to support BeOS R4.5.2 (Intel) as a result
	  of eban's Makefile.in change.

	* io.c: NOFILE is already defined on BeOS R4.5 (Intel) or later.

	* lib/matrix.rb: remove debug print.

	* regex.c: don't use nested comment.

Tue May  9 17:08:43 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (massign): no longer convert nil into empty array.

	* io.c (rb_io_s_popen): optional 3rd argument to give proc, which
	  will be executed in spawned child process.

Mon May  8 23:47:39 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* eval.c (rb_callcc): prev & next should be initialized to zero.

Mon May  8 23:17:36 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* dln.c (dln_init): remove possible buffer overrun.  This is
	  suggested by Aleksi Niemela <aleksi.niemela@cinnober.com>.

	* dln.c (init_funcname): ditto.

Sat May  6 23:35:47 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* parse.y (lhs): should allow `obj.Attr = 5' type expression.

Sat May  6 15:46:08 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* ext/socket/extconf.rb: add a new configure option to force use
	  of the WIDE Project's getaddrinfo(): --enbale-wide-getaddrinfo.

Fri May  5 21:19:22 2000  MOROHOSHI Akihiko  <moro@remus.dti.ne.jp>

	* parse.y (yylex): allow '$1foo' and such.

Fri May  5 17:57:24 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.17.

	* lib/net/http.rb: write also port number in Host: field.

	* lib/net/http.rb: see Proxy-Connection: to decide socket connection.

Fri May  5 03:25:15 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* regex.c (re_compile_fastmap): charset_not for multibyte
	  characters excluded too many characters.

Tue May  2 13:23:43 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (rb_thread_schedule): little bit more impartial context
	  switching.

Tue May  2 09:50:03 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* configure.in: add DLDLIBS to set platform specific library
	  for extensions.

	* ext/extmk.rb.in: use @DLDLIBS@ instead of RUBY_PLATFORM choice.

	* lib/mkmf.rb: use CONFIG["DLDLIBS"] instead of RUBY_PLATFORM choice.

	* config_s.dj: add @DLDLIBS@.

	* win32/config.status: ditto.

	* win32/ruby.def: regular maintenance.

Mon May  1 23:42:44 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* configure.in, eval.c: add DLEXT2. now DLEXT on Cygwin is "so".

	* defines.h: use dllimport, dllexport for Cygwin 1.1.x.

	* ruby.h: ditto.

	* cygwin/GNUmakefile.in: ditto.

	* ext/Win32API/Win32API.c: directly "call" in asm statement for
	  gcc 2.95.x or newer.

Sat Apr 29 04:58:12 2000  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* array.c (rb_ary_unshift_m): performance improvement.

Fri Apr 28 00:19:22 2000  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* array.c (rb_ary_unshift_m): takes items to push.

Wed Apr 26 15:23:02 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* string.c (rb_str_succ): insert carrying character just before
	  the leftmost alpha numeric character.

	* string.c (rb_str_succ): proper behavior for "".succ and "\377".succ.

	* string.c (rb_str_succ): use realloc and memmove.

Tue Apr 25 18:28:45 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.16.

	* lib/net/smtp.rb: add SMTP AUTH

Tue Apr 25 14:30:13 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* io.c (rb_io_gets_internal): shortcut when rs == rb_default_rs.

Sat Apr 22 23:14:41 2000  SHIROYAMA Takayuki  <psi@fortune.nest.or.jp>

	* configure.in: MacOS X support.

Sat Apr 22 16:37:10 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.15.

	* lib/net/http.rb:  closing socket by watching both
	  user header and server response

Fri Apr 21 21:44:34 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* io.c (rb_io_s_pipe): should set FMODE_SYNC.

Thu Apr 20 16:59:22 2000  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* eval.c (massign): `*lvalue = false' should assign `[false]' to
	  lvalue.

Wed Apr 19 08:35:08 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* class.c (rb_singleton_class): generate singleton class for
	  special constants: nil, true, false.

Wed Apr 19 02:09:30 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* class.c (rb_singleton_class): singleton method for nil, true,
	  false is possible now.

	* eval.c (rb_eval): ditto.

Tue Apr 18 18:54:25 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.14.

	* lib/net/http.rb: new method HTTP#head2.

	* lib/net/http.rb: get2/post2 does not raise exceptions.

Mon Apr 17 15:16:31 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* io.c (rb_io_close): to detect some exceptional status, writable
	  IO should be flushed before close;

Sat Apr 15 18:29:00 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* array.c (rb_ary_collect_bang): Array#filter renamed.

Fri Apr 14 19:47:11 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.13.

	* lib/net/pop.rb: accept illegal timestamp

	* lib/net/http.rb: when body was chunked, does not set Content-Length:

Tue Apr 11 21:14:42 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* config_s.dj: add @sitedir@.
	* configure.in: add --with-sitedir=DIR option.
	* instruby.rb: use CONFIG["sitedir"].
	* lib/mkmf.rb: support 'make site-install'.
	* win32/config.status: add @sitedir@.

Tue Apr 11 16:25:15 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* bignum.c (rb_big_2comp): unnecessary lvalue cast removed.

Tue Apr 11 02:25:53 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* hash.c (env_fetch): new method.

	* marshal.c (marshal_dump): accepts depth = nil for unlimited depth.

Sun Apr  9 20:49:19 2000  Dave Thomas  <Dave@Thomases.com>

	* parse.y (str_extend): Allow class variables to be expanded.

Fri Apr  7 02:03:54 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* error.c (rb_sys_fail): escape non-printable characters.

Thu Apr  6 20:10:47 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* ext/extmk.rb.in (create_makefile): BeOS --program-suffix support.
	* lib/mkmf.rb (create_makefile): ditto.

Thu Apr  6 09:55:26 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* error.c (rb_sys_fail): need rb_exc_new2() call on BeOS.

Mon Apr  3 17:22:27 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* io.c (rb_io_reopen): support tempfile.

	* eval.c (catch_i): should supply argument.

Sat Apr  1 22:50:28 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* marshal.c (r_object): wrong symbol restoration.

Sat Apr  1 21:30:53 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* io.c(rb_io_printf, rb_f_printf): should use rb_io_write.

Sat Apr  1 00:16:05 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* gc.c (rb_gc_call_finalizer_at_exit): should be clear flags
	  before calling finalizers.

	* eval.c (specific_eval): can be called without SecurityError, if
	  $SAFE >= 4.

	* object.c (sym_inspect): inspect gives ":sym", to_s gives "sym".

Fri Mar 31 22:07:04 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.12.

	* lib/net/protocol.rb:  update Net::Protocol::Proxy#connect

	* lib/net/protocol.rb:  ReplyCode is not a class

	* lib/net/http.rb: header value format was change:
	  values do not include header name

	* lib/net/http.rb: header is not a Hash, but HTTPResponse

Thu Mar 30 12:19:44 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* enum.c (enum_find): rb_eval_cmd() should be called with array.

Tue Mar 28 13:57:05 2000  Clemens Hintze  <c.hintze@gmx.net>

	* ext/dbm/dbm.c (fdbm_invert): should return new hash.

	* ext/gdbm/gdbm.c (fgdbm_invert): ditto.

Tue Mar 28 00:58:03 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.11.

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: does not
	  dispatch any commands while dispatching command.

	* lib/net/protocol.rb: failed to get error class of
	  inherited ReplyCode

	* lib/net/http.rb: change feature of "get2", "post2"

Mon Mar 27 01:34:58 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.10.

	* lib/net/http.rb: return value of 'head' was wrong.

Sun Mar 26 17:47:35 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.9.

	* lib/net/smtp.rb: SMTP#do_ready wrongly took no arguments

Sat Mar 25 23:21:10 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* marshal.c (w_object): symbols should be converted to ID before
	  dumping out.

Sun Mar 25 16:52:48 2001  Koji Arai  <JCA02266@nifty.ne.jp>

	* file.c (rb_file_flock): do not trap EINTR.

	* missing/flock.c (flock): returns the value from lockf(2)
	  directly.

Fri Mar 24 18:26:51 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* file.c (test_check): should have checked exact number of arguments.

Fri Mar 24 21:02:11 2000  Koji Arai  <JCA02266@nifty.ne.jp>

	* signal.c (trap): should treat some symbols as the signal.

Fri Mar 24 06:58:03 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.8.

	* lib/net/http.rb:  post, get2, post2, get_body

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: separate
	  Command/Socket documentation.

Thu Mar 23 02:26:14 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* io.c (rb_io_fptr_finalize): fptr may be null.

	* io.c (rb_io_s_new): now calls `initialize'.

	* io.c (rb_io_initialize): actual open done in this method.

	* io.c (rb_file_initialize): ditto.

	* eval.c (rb_eval): class variables in singleton class definition
	  is now handled properly (I hope).

Wed Mar 22 21:49:36 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* st.c (st_delete_safe): skip already deleted entry.

	* hash.c (rb_hash_delete): modify brace miss.

Wed Mar 22 08:53:58 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (exec_under): do not push cbase if ruby_cbase == under.

	* node.h (NEW_CREF0): preserve cbase nesting.

Tue Mar 21 12:57:50 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* object.c (rb_class_s_new): Class::new should call `inherited'.

Sat Mar 18 12:36:09 2000  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* eval.c (rb_backtrace, make_backtrace): removed unused variable
	  `lev'.

	* eval.c (rb_attr): calls `method_added' at attribute definition.

	* eval.c (rb_mod_modfunc): calls `singleton_method_added' while
	  `module_function'.

	* eval.c (rb_eval): parameter to `method_added' and
	  `singleton_method_added' is Symbol.

	* eval.c (Init_eval): caches IDs for `method_added' and
	  `singleton_method_added'.

Sat Mar 18 11:25:10 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* parse.y (rescue): allows `rescue Error in foo'.  experimental.
	  which is better this or preparing alias `exception' for `$!'?

Fri Mar 17 15:02:45 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* variable.c (rb_autoload_id): defining new autoload should be
	  prohibited for $SAFE > 4.

	* variable.c (rb_autoload_load): autoload should be possible for
	  $SAFE > 4.

	* eval.c (call_trace_func): should handle T_ICLASS properly.

Fri Mar 17 14:34:30 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* string.c (str_gsub): forgot to initialize str->orig.

Fri Mar 17 01:24:59 2000  Dave Thomas  <Dave@thomases.com>

	* string.c (rb_str_clone): forgot to copy str->orig if STR_NO_ORIG
	  is set by Array#pack.

Wed Mar 15 21:25:04 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* array.c (rb_ary_join): 'result' is always duplicated
	  before concat string.

Wed Mar 15 17:26:05 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* hash.c (rb_hash_s_create): unexpected recursive call removed.
	  this bug was found by Satoshi Nojo <nojo@t-samukawa.or.jp>.

Wed Mar 15 13:12:39 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (Init_Thread): Thread.join removed finally.

	* string.c (rb_str_chomp_bang): forgot to call rb_str_modify().

Mon Mar 13 16:12:13 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (block_pass): distinguish real orphan block and still
	  on-stack block passed by block argument.

Mon Mar 13 00:20:25 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* parse.y (f_norm_arg): proper error message when constant comes
	  in formal argument list.  this message is suggested by Muvaw
	  Pnazte <bugathlon@yahoo.com>.

	* eval.c (rb_f_raise): proper error message when the first
	  argument is not an exception class/object.

	* string.c (rb_str_dup): dup now postpone buffer copy as long as
	  possible.  performance improved by lazy copying.

Sun Mar 12 13:58:52 2000  Koji Arai  <JCA02266@nifty.ne.jp>

	* signal.c (rb_f_kill): should treat some symbols as the signal.

Sat Mar 11 22:03:03 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* string.c (rb_str_gsub): performance tune by avoiding buffer copy.

	* eval.c (rb_f_missing): check if argv[0] is ID.

Sat Mar 11 15:49:41 2000  Tadayoshi Funaba  <tadf@kt.rim.or.jp>

	* struct.c (rb_struct_aref): struct aref by symbol.

Sat Mar 11 05:07:11 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* process.c (proc_setpriority): should return 0, not nil.

	* process.c (proc_setpgid): ditto.

Fri Mar 10 18:14:54 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* file.c (path_check_1): confusing buf and path.  this bug found
	  by <decoux@moulon.inra.fr>.

Fri Mar 10 09:37:49 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* MANIFEST: add beos/GNUmakefile.in.
	* configure.in: support BeOS R4.5.2 (Intel).
	* beos/GNUmakefile.in: new file to support BeOS R4.5.2 (Intel).

Thu Mar  9 11:13:32 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* regex.c (re_compile_fastmap): fixed embarrassing brace bug.

Thu Mar  9 01:36:32 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* missing/flock.c: emulate missing flock() with fcntl().

Thu Mar  9 00:29:35 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* object.c (sym_to_s): returns ":sym".

	* object.c (sym_id2name): separated from to_s; returns "sym".

Wed Mar  8 19:16:19 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.7.

	* lib/net/http.rb (connecting): returns header

Wed Mar  8 02:08:43 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* parse.y: escape expansion too early.

	* string.c (rb_f_scan): Kernel#scan added.

	* regex.c (re_compile_pattern): support \cX et al.

Tue Mar  7 01:44:27 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* io.c (set_stdin): simplified procedure, allows $stdin = DATA;
	  experimental.

	* io.c (set_outfile): ditto.

	* re.c (Init_Regexp): new method Regexp#last_match added; it's an
	  alternative for $~.

	* configure.in (DEFAULT_KCODE): KCODE_NONE should be the default.

	* dir.c (dir_s_rmdir): should return 0 on success.

	* signal.c: remove CWGUSI support.

Mon Mar  6 12:28:37 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* marshal.c (w_symbol): support symbol object.

	* util.c: make symbol as separated class.

	* error.c (Init_Exception): new exception RangeError.

	* ext/socket/socket.c (ip_addrsetup): should check length of hostname.

	* ext/socket/socket.c (ip_addrsetup): check newline at the end of
	  hostname.  These fixes suggested by Muvaw Pnazte <bugathlon@yahoo.com>.

Sun Mar  5 20:35:45 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* ext/Win32API/Win32API.c (Win32API_initialize): should call
	  LoadLibrary() everytime and should assign the hdll to Win32API
	  object(protect the hdll from GC).

Sun Mar  5 18:49:06 2000  Nakada.Nobuyoshi  <nobu.nokada@softhome.net>

	* misc/ruby-mode.el (ruby-parse-region): not treat method `begin'
	  and `end' as reserved words.

	* misc/ruby-mode.el (ruby-font-lock-docs): ignore after `=begin'
	  and `=end'.

	* misc/ruby-mode.el (ruby-font-lock-keywords, hilit-set-mode-patterns):
	  added `yield' to keywords.

	* misc/ruby-mode.el (ruby-font-lock-keywords, hilit-set-mode-patterns):
	  matches keywords at end of buffer.

Sun Mar  5 18:08:53 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.6.

	* lib/net/http.rb:  allow to omit 'start'

Tue Feb 29 01:08:26 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* range.c (range_initialize): initialization done in `initialize';
	  `initialize' should not be called more than once.

	* object.c (Init_Object): default `initialize' should take zero
	  argument.

	* time.c (time_s_new): call `initialize' in Time::new.

Sat Feb 26 22:39:31 2000  EGUCHI Osamu  <eguchi@shizuokanet.ne.jp>

	* string.c (rb_str_times): fix String#* with huge string.

Sat Feb 26 00:14:59 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* dir.c (dir_s_new): call `initialize' in Dir::new.

Fri Feb 25 23:01:49 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* ruby.h: export ruby_safe_level by EXTERN for mswin32.
	* win32/ruby.def: regular maintenance.

Fri Feb 25 22:12:46 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* io.c (rb_io_reopen): IO#reopen should accept path as well.

	* string.c (rb_str_s_new): call `initialize' in String::new.

	* hash.c (rb_hash_s_new): call `initialize' in Hash::new.

	* array.c (rb_ary_s_new): call `initialize' in Array::new.

Fri Feb 25 12:50:20 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (rb_thread_start_timer): interval changed to 10ms from 50ms.

Fri Feb 25 06:42:26 2000  GOTOU YUUZOU  <gotoyuzo@notwork.org>

	* ext/socket/socket.c (ip_addrsetup): hostp should remain NULL if
	  host is nil.

Thu Feb 24 16:53:47 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (rb_thread_schedule): priority check for sleep expired
	  threads needed.

Wed Feb 23 14:22:32 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* array.c (rb_ary_join): forgot to initialize a local variable
	  `taint'.

Tue Feb 22 07:40:55 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* re.c (Init_Regexp): renamed to MatchData, old name MatchingData
	  remain as alias.

Tue Feb 22 00:20:21 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/protocol.rb, smtp.rb, pop.rb, http.rb: 1.1.5.

	* lib/net/session.rb: rename to protocol.rb

	* lib/net/protocol.rb: ProtocolSocket -> Net::Socket

	* lib/net/protocol.rb: Net::Socket#write, write_pendstr
	  can take block

	* lib/net/smtp.rb: new methods SMTP#ready SMTPCommand#write_mail

	* lib/net/pop.rb: POPMail#pop can take block

Sat Feb 19 23:58:51 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* regex.c (re_match): pop_loop should not pop at forward jump.

Fri Feb 18 17:15:40 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (method_clone): method objects are now clonable.

Fri Feb 18 00:27:34 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* variable.c (rb_shared_variable_declare): shared variable (aka
	  class/module variable) introduced.  prefix `@@'. experimental.

	* class.c (rb_scan_args): new format char '&'.

Thu Feb 17 19:09:05 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* win32/win32.c (mypopen): don't close handle if it is not assigned.
	* win32/win32.c (my_open_osfhandle): support O_NOINHERIT flag.
	* win32/win32.c (win32_getcwd): rename getcwd to win32_getcwd
	  in order to avoid using the C/C++ runtime DLL's getcwd.
	  Use CharNext() to process directory name.
	* win32/win32.h: map getcwd to win32_getcwd.

Wed Feb 16 00:32:49 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (method_arity): nd_rest is -1 for no rest argument.

	* process.c (proc_waitpid): returns nil when waitpid(2) returns 0.

Tue Feb 15 01:47:00 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* process.c (rb_f_waitpid): pid_t should be signed.

Mon Feb 14 13:59:01 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* parse.y (yylex): yylex yields wrong tokens for `:foo=~expr'.

	* ruby.c (load_file): exit if reading file is empty.

Mon Feb 14 03:34:52 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* parse.y (yylex): `foo.bar=1' should be <foo><.><bar><=><1>,
	  not <foo><.><bar=><1>.

	* eval.c (rb_thread_restore_context): process according to
	  RESTORE_* is moved after longjmp().

	* eval.c (thread_switch): new function to process RESTORE_*.

Sun Feb 13 16:19:49 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* ruby.c (require_libraries): don't access freed memory.

	* ruby.c (add_modules): ditto.

Fri Feb 11 12:06:22 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* parse.y (parse_quotedwords): %w() need to split not only by mere
	  spaces, but by all whitespaces.

Thu Feb 10 02:12:04 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* string.c (rb_str_index_m): did not support negative offset.

Wed Feb  9 21:54:26 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* ext/socket/getaddrinfo.c: gcc --traditional support.
	  Rearrange headers to work AC_C_CONST.
	* ext/socket/getnameinfo.c: ditto.
	* ext/socket/socket.c: mswin32: use double instead of long long.

Wed Feb  9 16:30:41 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* numeric.c (num_coerce): should return [y, x].

Wed Feb  9 11:07:30 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* ruby.c (ruby_prog_init): loadpath structure changed.

Tue Feb  8 02:07:33 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* regex.c (re_search): optimize for \G at top.

	* regex.c (re_compile_pattern): \G introduced.

	* regex.c (re_match): ditto.

	* string.c (str_sub_bang): old behavior restored: bang method
	  returns nil if string not changed.

	* regex.c (re_compile_pattern): support independent subexpression
	  `(?>pattern)'. 

	* regex.c (re_match): ditto.

Mon Feb  7 15:51:08 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* regex.c (re_match): now understands interrupts under Ruby.

Mon Feb  7 07:51:52 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* array.c (rb_ary_uniq_bang): always return an Array.

	* array.c (rb_ary_compact_bang): ditto.

	* array.c (rb_ary_flatten_bang): ditto.

	* hash.c (rb_hash_reject): returns a Hash, not an Array.

	* hash.c (env_reject): ditto.

Fri Feb  4 10:20:25 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* string.c (scan_once): scan now leaves information about the last
	  successful pattern match in $&.

	* io.c (rb_io_close): should not check closed IO.

Fri Feb  4 05:44:01 2000  Kentaro Inagaki  <inagaki@tg.rim.or.jp>

	* ext/socket/socket.c (s_recv): TRAP_BEG after retry entry.

Wed Feb  2 22:33:45 2000  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* eval.c (rb_thread_start): receives argument from outside, like
	  `Thread::start(1,2,3){|a,b,c| ... }'.

Wed Feb  2 22:14:40 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* re.c (rb_reg_regsub): should check regs->num_regs.

	* re.c (rb_reg_search): remove matchcache, use static struct
	  re_register instead. 

	* re.c (match_getter): avoid cloning match data.

Wed Feb  2 17:12:15 2000  Dave Thomas  <Dave@Thomases.com>

	* samples/eval.rb: Rescue new ScriptError exception

Wed Feb  2 02:06:07 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* string.c (str_gsub_bang): gsub! now leaves information about the
	  last successful pattern match in $&.

Mon Jan 31 15:24:58 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* string.c (str_sub_bang): bang method returns string always.
	  experimental.

Sun Jan 30 17:58:09 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* eval.c: arrange to use setitimer(2) for BOW, DJGPP

	* defines.h: ditto. use random(3) on cygwin b20.1.

Sun Jan 30 17:20:16 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* eval.c: use getrlimit(2) on DJGPP.

Thu Jan 27 01:27:10 2000  GOTO Kentaro  <gotoken@math.sci.hokudai.ac.jp>

	* dir.c (glob): glob pattern "/*" did not match.

Wed Jan 26 22:30:47 2000  Shigeo Kobayashi  <shigeo@tinyforest.gr.jp>

	* numeric.c (flo_modulo): wrong result for negative modulo.

Wed Jan 26 02:01:57 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* file.c (test_c): should use S_ISCHR.

	* file.c (rb_stat_c): ditto.

	* string.c (rb_str_each_line): should propagate tainting.

Tue Jan 25 04:01:34 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* object.c (rb_obj_freeze): all objects made freezable.

Tue Jan 25 00:37:01 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* configure.in: use AC_CHECK_TOOL for cross compiling.

Mon Jan 24 19:01:54 2000  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* array.c (rb_protect_inspect): should be checked by id of
	  objects; not by object themselves.

Mon Jan 24 18:48:08 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* eval.c (rb_eval): too many warnings;  warned on every method
	  overriding.  should be on method discarding.

Mon Jan 24 02:56:44 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* parse.y (yylex): -2.abs should be `(-2).abs' to accomplish the
	  principle of less surprise.  `+2' too.

	* eval.c (rb_eval): when defining class is already there, and
	  superclass differ, throw away the old class.

	* variable.c (rb_const_set): gives warning again on constant
	  redefinition.

	* error.c (Init_Exception): SyntaxError, NameError, LoadError and
	  NotImplementError are subclasses of ScriptError<Exception, not
	  StandardError.  experimental.

Sat Jan 22 00:00:41 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* parse.y (parse_quotedwords): no longer use `String#split'.
	  and enable space escape within quoted word list.
	  e.g. %w(a\ b\ c abc) => ["a b c", "abc"].

	* string.c (rb_str_slice_bang): new method `slice!'.

Fri Jan 21 21:56:08 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/session.rb, smtp.rb, pop.rb, http.rb: 1.1.4.

	* lib/net/http.rb: can receive messages which have
	  no Content-Length:.

Fri Jan 21 16:15:59 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (thgroup_s_new): new class ThreadGroup.

Tue Jan 18 12:24:28 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* struct.c (Init_Struct): remove Struct's own hash and eql?.

Sat Jan 15 22:21:08 2000  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* eval.c (search_method): argument klass may be 0.

Sat Jan 15 15:03:46 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* enum.c (enum_index): remove this method.

	* enum.c: remove use of pointers to local variables. find,
	  find_all, min, max, index, member?, each_with_index, 

	* eval.c (massign): multiple assignment does not use to_a anymore.
	  experimental.

Fri Jan 14 12:22:04 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* string.c (rb_str_replace): use memmove instead of memcpy for
	  overwrapping strings (e.g. a[1] = a).

Thu Jan 13 11:12:40 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* parse.y (arg_add): use new node, ARGSPUSH.

Mon Jan 10 18:32:28 2000  Koji Arai  <JCA02266@nifty.ne.jp>

	* marshal.c (w_object): forgot an argument to call w_ivar().

Sun Jan  9 18:13:51 2000  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* random.c: first was not defined unless HAVE_RANDOM.

Sat Jan  8 19:02:49 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* io.c (rb_io_sysread): raise IOError for buffered IO.

	* ext/socket/socket.c (s_recv): ditto.

Fri Jan  7 00:59:29 2000  Masahiro Tomita  <tommy@tmtm.org>

	* io.c (io_fread): TRAP_BEG/TRAP_END added around getc().

Thu Jan  6 00:39:54 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* random.c (rb_f_rand): should be initialized unless srand is
	  called before.

Wed Jan  5 16:59:34 2000  Minero Aoki  <aamine@dp.u-netsurf.ne.jp>

	* lib/net/session.rb, smtp.rb, pop.rb, http.rb: 1.1.3.

	* lib/net/session.rb: Session -> Protocol, ...

	* lib/net/http.rb: HTTPCommand implementation was changed.

Wed Jan  5 02:14:46 2000  EGUCHI Osamu  <eguchi@shizuokanet.ne.jp>

	* parse.y: Fix SEGV on empty parens with UMINUS or UPLUS.

Tue Jan  4 22:25:54 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* parse.y (stmt): `() while cond' dumped core.

Tue Jan  4 06:04:14 2000  WATANABE Hirofumi  <eban@os.rim.or.jp>

	* configure.in: modify for cross-compiling.
	  use target_* instead of host_*. 
	  use AC_CANONICAL_TARGET.

	* Makefile.in: ditto.

	* cygwin/GNUmakefile.in: ditto.

Sat Jan  1 13:26:14 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (rb_yield_0): force_recycle ruby_dyna_vars to gain
	  performance.

	* array.c (rb_ary_delete_at_m): takes same argument pattern with
	  rb_ary_aref.

Sat Jan  1 10:12:26 2000  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* ruby.h,util.c (rb_special_const_p): peep hole optimization.

	* ruby.h,util.c (rb_test_false_or_nil): removed.

	* ruby.h (RTEST, SPECIAL_CONST_P): peep hole optimization.

	* ruby.h (FL_ABLE, FL_SET, FL_UNSET, FL_REVERSE): made expressions
	  not statements.

	* ruby.h (OBJ_INFECT): newly added macro which copies taint from
	  `s' to `x'.

Sat Jan  1 02:04:18 2000  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (rb_thread_safe_level): new method.

	* eval.c (rb_yield_0): recycle dyna_var_map to reduce object
	  allocation. 

Fri Dec 31 00:52:48 1999  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c: thread independent trace_func not needed.

Thu Dec 30 14:47:31 1999  akira yamada  <akira@ruby-lang.org>

	* configure.in: specifies -soname in LIBRUBY_DLDFLAGS on linux
	  platforms.

Thu Dec 30 10:51:27 1999  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* array.c,io.c,hash,c,re.c,string.c: `_m' suffix instead of
	  `_method' for wrapper functions to implement method,
	  e.g. `rb_str_join_m()'.

Thu Dec 30 02:08:02 1999  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* bignum.c (rb_cstr2inum): non-numeric format check added.
	  currently it works only with base == 0 (i.e. Integer()).

	* bignum.c (rb_str2inum): now takes VALUE to 1st argument.  null
	  byte check added.

	* array.c (rb_ary_replace): unless replacement is an array,
	  replacement shall be converted to array by `[replacement]', not
	  by `replacement.to_a'.

	* array.c (rb_ary_plus): right operand must be an array.

	* array.c (rb_ary_concat): argument must be an array.

Mon Dec 27 12:35:47 1999  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* ext/socket/socket.c (sock_finalize): mswin32: fix socket handle leak.

	* win32/win32.c (myfdclose): ditto.

Sun Dec 26 23:15:13 1999  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* win32/win32.c (mypopen): raise catchable error instead of rb_fatal.
	* win32/win32.c (mypclose): fix process handle leak.

Sun Dec 26 16:17:11 1999  Katsuyuki Komatsu  <komatsu@sarion.co.jp>

	* ext/Win32API/Win32API.c (Win32API_initialize): use UINT2NUM
	  instead of INT2NUM to set __dll__ and __proc__.

Sat Dec 25 00:08:59 1999  KANEKO Naoshi  <wbs01621@mail.wbs.ne.jp>

	* ext/Win32API/Win32API.c (Win32API_Call): remove 'dword ptr'
	  from _asm.

Fri Dec 24 10:26:47 1999  Koji Oda  <oda@bsd1.qnes.nec.co.jp>

	* win32/win32.h: use "C++" linkage.

Fri Dec 24 02:00:57 1999  Yukihiro Matsumoto  <matz@netlab.co.jp>

	* eval.c (THREAD_ALLOC): should initialize th->trace.

Fri Dec 24 00:43:39 1999  KANEKO Naoshi  <wbs01621@mail.wbs.ne.jp>

	* io.c (pipe_open): check for `fptr->f == NULL'.
	* win32/win32.c (mypopen): STDERR does not work during ` function.

